(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    309051,       5647]
NotebookOptionsPosition[    306032,       5544]
NotebookOutlinePosition[    306372,       5559]
CellTagsIndexPosition[    306329,       5556]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
      "**", "**", "**"}], "*", "NLAs"}], "+", 
   RowBox[{
    RowBox[{"EUFs", "**", "**", "**"}], "*", 
    RowBox[{
    "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{{3.633784555843568*^9, 3.6337845730139437`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"A1", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"x1", "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{"x2", "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x1", "^", "2"}]}], "+", 
       RowBox[{"2", " ", "x1"}], "-", 
       RowBox[{"x2", "^", "2"}], "+", 
       RowBox[{"2", " ", "x2"}], "-", 
       RowBox[{"y", "^", "2"}]}], ">", "0"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B1", "=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x1", "^", "2"}]}], "-", 
       RowBox[{"x2", "^", "2"}], "-", 
       RowBox[{"2", " ", "x2"}], "-", 
       RowBox[{"z", "^", "2"}]}], "\[GreaterEqual]", "0"}], ")"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A2", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "y1"}], "+", "x1", "-", "2"}], "\[GreaterEqual]", "0"}], 
     ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"y1", "^", "2"}]}], "-", 
       RowBox[{"x1", "^", "2"}], "+", 
       RowBox[{"2", " ", "x1", " ", "y1"}], "-", 
       RowBox[{"2", " ", "y1"}], "+", 
       RowBox[{"2", "x1"}]}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"y2", "^", "2"}]}], "-", 
       RowBox[{"y1", "^", "2"}], "-", 
       RowBox[{"x2", "^", "2"}], "-", 
       RowBox[{"4", " ", "y1"}], "+", 
       RowBox[{"2", " ", "x2"}], "-", "4"}], "\[GreaterEqual]", "0"}], ")"}], 
    "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "x2"}], "-", "x1", "-", "1"}], ">", "0"}], ")"}]}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B2", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "z1"}], "+", 
        RowBox[{"2", " ", "x2"}], "+", "1"}], "\[GreaterEqual]", "0"}], ")"}],
      "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"z1", "^", "2"}]}], "-", 
        RowBox[{"4", " ", 
         RowBox[{"x2", "^", "2"}]}], "+", 
        RowBox[{"4", " ", "x2", " ", "z1"}], "+", 
        RowBox[{"3", " ", "z1"}], "-", 
        RowBox[{"6", " ", "x2"}], "-", "2"}], "\[GreaterEqual]", "0"}], ")"}],
      "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"z2", "^", "2"}]}], "-", 
        RowBox[{"x1", "^", "2"}], "-", 
        RowBox[{"x2", "^", "2"}], "+", 
        RowBox[{"2", " ", "x1"}], "+", "z1", "-", 
        RowBox[{"2", " ", "x2"}], "-", "1"}], "\[GreaterEqual]", "0"}], ")"}],
      "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"2", " ", "x1"}], "-", "x2", "-", "1"}], ">", "0"}], " ", 
      ")"}]}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A3", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"y1", "-", "x1", "+", "1"}], ")"}], "^", "2"}]}], "-", "x1",
        "+", "x2"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{"y2", "\[Equal]", 
      RowBox[{
       RowBox[{"\[Alpha]", "[", "y1", "]"}], "+", "1"}]}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x1", "^", "2"}]}], "-", 
       RowBox[{"x2", "^", "2"}], "-", 
       RowBox[{"y2", "^", "2"}], "+", "1"}], ">", "0"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B3", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"z1", "-", "x2", "+", "1"}], ")"}], "^", "2"}]}], "+", 
        "x1", "-", "x2"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{"z2", "\[Equal]", 
       RowBox[{
        RowBox[{"\[Alpha]", "[", "z1", "]"}], "-", "1"}]}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"x1", "^", "2"}]}], "-", 
        RowBox[{"x2", "^", "2"}], "-", 
        RowBox[{"z2", "^", "2"}], "+", "1"}], ">", "0"}], ")"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A32", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x1"}], "+", "x2"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y2", "-", "y", "-", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y", "-", "y2", "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x1", "^", "2"}]}], "-", 
       RowBox[{"x2", "^", "2"}], "-", 
       RowBox[{"y2", "^", "2"}], "+", "1"}], ">", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y1", "-", "x1", "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x1", "-", "y1", "-", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x2", "-", "y1", "-", "1"}], ">", "0"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A34", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x1"}], "+", "x2"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y2", "-", "y", "-", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y", "-", "y2", "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x1", "^", "2"}]}], "-", 
       RowBox[{"x2", "^", "2"}], "-", 
       RowBox[{"y2", "^", "2"}], "+", "1"}], ">", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y1", "-", "x1", "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x1", "-", "y1", "-", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"y", "-", "t"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"t", "-", "y"}], "\[GreaterEqual]", "0"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B31", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x1", "-", "x2"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"z2", "-", "z", "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"z", "-", "z2", "-", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"x1", "^", "2"}]}], "-", 
        RowBox[{"x2", "^", "2"}], "-", 
        RowBox[{"z2", "^", "2"}], "+", "1"}], ">", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"z1", "-", "x2", "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x2", "-", "z1", "-", "1"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"z", "-", "t"}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"t", "-", "z"}], "\[GreaterEqual]", "0"}], ")"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A4", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", "-", 
       RowBox[{"x", "^", "2"}], "-", 
       RowBox[{"y", "^", "2"}]}], "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{"y", "\[GreaterEqual]", "0"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x", "+", "y", "-", "1"}], ">", "0"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B4", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"x", "\[GreaterEqual]", "0"}], ")"}], "&&", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1", "-", 
        RowBox[{"x", "^", "2"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"y", "+", "1"}], ")"}], "^", "2"}]}], "\[GreaterEqual]", 
       "0"}], ")"}]}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"A7", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x1", "^", "2"}]}], "+", 
       RowBox[{"4", "x1"}], "+", "x2", "-", "4"}], "\[GreaterEqual]", "0"}], 
     ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x1"}], "-", "x2", "+", "3", "-", 
       RowBox[{"y", "^", "2"}]}], ">", "0"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B7", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], 
        RowBox[{"x1", "^", "2"}]}], "-", 
       RowBox[{"x2", "^", "2"}], "+", "1"}], "\[GreaterEqual]", "0"}], ")"}], 
    "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x2", "-", 
       RowBox[{"z", "^", "2"}]}], "\[GreaterEqual]", "0"}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.632972560549222*^9, 3.6329726475959063`*^9}, {
   3.632972683372465*^9, 3.632972802978733*^9}, {3.632974254419256*^9, 
   3.632974255747501*^9}, {3.632974748615665*^9, 3.632974785117035*^9}, {
   3.632975855973104*^9, 3.632975867843589*^9}, {3.633092716350111*^9, 
   3.633092725616024*^9}, {3.633093131711154*^9, 3.633093158179662*^9}, 
   3.633093537496736*^9, {3.633098276389858*^9, 3.633098298836362*^9}, {
   3.633170231082181*^9, 3.633170240587945*^9}, 3.633171403253777*^9, {
   3.633309190006961*^9, 3.633309195411949*^9}, 3.633309323945371*^9, {
   3.633518285189355*^9, 3.63351828558427*^9}, {3.6337542149224167`*^9, 
   3.633754498776547*^9}, {3.633754577101028*^9, 3.6337548209625187`*^9}, {
   3.6338353873105297`*^9, 3.633835390515809*^9}, {3.633835448873055*^9, 
   3.633835456069583*^9}, {3.633835488627936*^9, 3.633835551109735*^9}, {
   3.633918514027172*^9, 3.6339185562342997`*^9}, {3.6339185884166594`*^9, 
   3.633918701700224*^9}, {3.6339187425673313`*^9, 3.6339188195499*^9}, {
   3.633918888321149*^9, 3.633918888865822*^9}, {3.63391892992951*^9, 
   3.633918995608193*^9}, {3.633919030384018*^9, 3.633919130810932*^9}, {
   3.6339191770574903`*^9, 3.633919206825467*^9}, {3.6339216566128883`*^9, 
   3.633921689903553*^9}, {3.6339217427278137`*^9, 3.633921743401052*^9}, {
   3.6339218044758863`*^9, 3.633921808323668*^9}, {3.633921899563755*^9, 
   3.633921900681024*^9}, 3.6339219385472507`*^9, {3.633921973452929*^9, 
   3.633921987859408*^9}, {3.633923121699419*^9, 3.633923206132984*^9}, {
   3.633923261062744*^9, 3.633923283229796*^9}, 3.633923338628394*^9, {
   3.63513241109825*^9, 3.635132502864916*^9}, {3.635132689799069*^9, 
   3.635132722710147*^9}, {3.635247879898099*^9, 3.635247880149654*^9}, {
   3.6427613180847807`*^9, 3.642761339557189*^9}, {3.642761511466075*^9, 
   3.642761529810042*^9}, {3.642761916771299*^9, 3.642761947547851*^9}, {
   3.642762013378911*^9, 3.642762065522504*^9}, {3.642808819502966*^9, 
   3.642808865988092*^9}, {3.642812448103393*^9, 3.642812517559363*^9}, {
   3.662693409055699*^9, 3.662693433925344*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**"}], "*", "Example", " ", 
   RowBox[{"1", "**", "**", "**"}], "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{{3.633783248163569*^9, 3.6337832597326*^9}, {
  3.63378452236683*^9, 3.633784530575094*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", 
   RowBox[{"A1", ",", "B1", ",", "0", ",", 
    RowBox[{
     RowBox[{"x1", "^", "2"}], "+", 
     RowBox[{"x2", "^", "2"}], "+", 
     RowBox[{"z", "^", "2"}]}], ",", 
    RowBox[{"2", " ", "x2"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.633752860796007*^9, 3.633752907755897*^9}, {
   3.6337548808526907`*^9, 3.633754883019608*^9}, {3.633754920035802*^9, 
   3.633754930627919*^9}, 3.6337549839231653`*^9, {3.633755014123458*^9, 
   3.633755020939652*^9}, 3.6337551530264807`*^9, 3.633778556380979*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC unsatisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{
  3.6337537050397797`*^9, 3.633755154568853*^9, 3.633755282390167*^9, 
   3.633755358822098*^9, 3.633755454178411*^9, 3.633755496603669*^9, 
   3.6337555349312477`*^9, 3.633755567850998*^9, {3.633756027834581*^9, 
   3.633756043967519*^9}, {3.6337562071481237`*^9, 3.633756208480961*^9}, 
   3.6337563092122583`*^9, {3.63375639896596*^9, 3.63375642079121*^9}, 
   3.633756674469145*^9, {3.633756720268942*^9, 3.6337567436956987`*^9}, 
   3.633756806069735*^9, 3.633756908431961*^9, 3.633757038436343*^9, 
   3.633757158019946*^9, 3.633757196198058*^9, 3.633757235789196*^9, {
   3.633757470168751*^9, 3.633757477770494*^9}, {3.633757640679137*^9, 
   3.6337576425058603`*^9}, 3.63375768295261*^9, 3.633757716494306*^9, {
   3.6337578418972797`*^9, 3.633757916507226*^9}, 3.633757948467671*^9, 
   3.633757985461525*^9, 3.633758016498534*^9, 3.633758110736986*^9, {
   3.633758169553883*^9, 3.6337581774883842`*^9}, 3.633758210987767*^9, 
   3.633758244065753*^9, 3.63375833920216*^9, 3.633758387372699*^9, 
   3.633758582155304*^9, {3.633759062714072*^9, 3.633759076304782*^9}, 
   3.6337592602595253`*^9, {3.6337595374963923`*^9, 3.6337595753241243`*^9}, {
   3.633775430195711*^9, 3.633775465965638*^9}, 3.6337786332298*^9, {
   3.633779205186984*^9, 3.633779216183416*^9}, {3.6337792482884893`*^9, 
   3.63377929421406*^9}, {3.63378054977767*^9, 3.633780561750058*^9}, {
   3.633780599523469*^9, 3.633780603544787*^9}, {3.633780643265562*^9, 
   3.633780644703504*^9}, {3.6337807431656713`*^9, 3.6337807530668163`*^9}, 
   3.6337808019434443`*^9, {3.633780854556623*^9, 3.633780882904454*^9}, {
   3.633781264347467*^9, 3.633781274617879*^9}, {3.6337813159446383`*^9, 
   3.633781320107484*^9}, {3.633781749799109*^9, 3.633781758030003*^9}, {
   3.633781995085504*^9, 3.633781996941658*^9}, {3.633782291714192*^9, 
   3.633782318100564*^9}, {3.633782422589624*^9, 3.633782434300798*^9}, 
   3.633782527655582*^9, 3.633782572648855*^9, 3.633783079322213*^9, {
   3.633783161411003*^9, 3.6337832033254557`*^9}, {3.633784610159884*^9, 
   3.633784611961815*^9}, 3.633784743313714*^9, {3.633784778331646*^9, 
   3.6337847813013477`*^9}, {3.633835248467072*^9, 3.633835263267231*^9}, {
   3.633871665091481*^9, 3.633871673499104*^9}, {3.6338720164613113`*^9, 
   3.633872029462021*^9}, {3.6339174648031*^9, 3.633917468758774*^9}, {
   3.669073122091715*^9, 3.669073126042618*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", "False", 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["A: ", False, "\nB: ", True],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6337537050397797`*^9, 3.633755154568853*^9, 3.633755282390167*^9, 
   3.633755358822098*^9, 3.633755454178411*^9, 3.633755496603669*^9, 
   3.6337555349312477`*^9, 3.633755567850998*^9, {3.633756027834581*^9, 
   3.633756043967519*^9}, {3.6337562071481237`*^9, 3.633756208480961*^9}, 
   3.6337563092122583`*^9, {3.63375639896596*^9, 3.63375642079121*^9}, 
   3.633756674469145*^9, {3.633756720268942*^9, 3.6337567436956987`*^9}, 
   3.633756806069735*^9, 3.633756908431961*^9, 3.633757038436343*^9, 
   3.633757158019946*^9, 3.633757196198058*^9, 3.633757235789196*^9, {
   3.633757470168751*^9, 3.633757477770494*^9}, {3.633757640679137*^9, 
   3.6337576425058603`*^9}, 3.63375768295261*^9, 3.633757716494306*^9, {
   3.6337578418972797`*^9, 3.633757916507226*^9}, 3.633757948467671*^9, 
   3.633757985461525*^9, 3.633758016498534*^9, 3.633758110736986*^9, {
   3.633758169553883*^9, 3.6337581774883842`*^9}, 3.633758210987767*^9, 
   3.633758244065753*^9, 3.63375833920216*^9, 3.633758387372699*^9, 
   3.633758582155304*^9, {3.633759062714072*^9, 3.633759076304782*^9}, 
   3.6337592602595253`*^9, {3.6337595374963923`*^9, 3.6337595753241243`*^9}, {
   3.633775430195711*^9, 3.633775465965638*^9}, 3.6337786332298*^9, {
   3.633779205186984*^9, 3.633779216183416*^9}, {3.6337792482884893`*^9, 
   3.63377929421406*^9}, {3.63378054977767*^9, 3.633780561750058*^9}, {
   3.633780599523469*^9, 3.633780603544787*^9}, {3.633780643265562*^9, 
   3.633780644703504*^9}, {3.6337807431656713`*^9, 3.6337807530668163`*^9}, 
   3.6337808019434443`*^9, {3.633780854556623*^9, 3.633780882904454*^9}, {
   3.633781264347467*^9, 3.633781274617879*^9}, {3.6337813159446383`*^9, 
   3.633781320107484*^9}, {3.633781749799109*^9, 3.633781758030003*^9}, {
   3.633781995085504*^9, 3.633781996941658*^9}, {3.633782291714192*^9, 
   3.633782318100564*^9}, {3.633782422589624*^9, 3.633782434300798*^9}, 
   3.633782527655582*^9, 3.633782572648855*^9, 3.633783079322213*^9, {
   3.633783161411003*^9, 3.6337832033254557`*^9}, {3.633784610159884*^9, 
   3.633784611961815*^9}, 3.633784743313714*^9, {3.633784778331646*^9, 
   3.6337847813013477`*^9}, {3.633835248467072*^9, 3.633835263267231*^9}, {
   3.633871665091481*^9, 3.633871673499104*^9}, {3.6338720164613113`*^9, 
   3.633872029462021*^9}, {3.6339174648031*^9, 3.633917468758774*^9}, {
   3.669073122091715*^9, 3.6690731260434437`*^9}}],

Cell[BoxData["\<\"Var(A) is a subset of Var(B), procedure terminates \
with:\"\>"], "Print",
 CellChangeTimes->{
  3.6337537050397797`*^9, 3.633755154568853*^9, 3.633755282390167*^9, 
   3.633755358822098*^9, 3.633755454178411*^9, 3.633755496603669*^9, 
   3.6337555349312477`*^9, 3.633755567850998*^9, {3.633756027834581*^9, 
   3.633756043967519*^9}, {3.6337562071481237`*^9, 3.633756208480961*^9}, 
   3.6337563092122583`*^9, {3.63375639896596*^9, 3.63375642079121*^9}, 
   3.633756674469145*^9, {3.633756720268942*^9, 3.6337567436956987`*^9}, 
   3.633756806069735*^9, 3.633756908431961*^9, 3.633757038436343*^9, 
   3.633757158019946*^9, 3.633757196198058*^9, 3.633757235789196*^9, {
   3.633757470168751*^9, 3.633757477770494*^9}, {3.633757640679137*^9, 
   3.6337576425058603`*^9}, 3.63375768295261*^9, 3.633757716494306*^9, {
   3.6337578418972797`*^9, 3.633757916507226*^9}, 3.633757948467671*^9, 
   3.633757985461525*^9, 3.633758016498534*^9, 3.633758110736986*^9, {
   3.633758169553883*^9, 3.6337581774883842`*^9}, 3.633758210987767*^9, 
   3.633758244065753*^9, 3.63375833920216*^9, 3.633758387372699*^9, 
   3.633758582155304*^9, {3.633759062714072*^9, 3.633759076304782*^9}, 
   3.6337592602595253`*^9, {3.6337595374963923`*^9, 3.6337595753241243`*^9}, {
   3.633775430195711*^9, 3.633775465965638*^9}, 3.6337786332298*^9, {
   3.633779205186984*^9, 3.633779216183416*^9}, {3.6337792482884893`*^9, 
   3.63377929421406*^9}, {3.63378054977767*^9, 3.633780561750058*^9}, {
   3.633780599523469*^9, 3.633780603544787*^9}, {3.633780643265562*^9, 
   3.633780644703504*^9}, {3.6337807431656713`*^9, 3.6337807530668163`*^9}, 
   3.6337808019434443`*^9, {3.633780854556623*^9, 3.633780882904454*^9}, {
   3.633781264347467*^9, 3.633781274617879*^9}, {3.6337813159446383`*^9, 
   3.633781320107484*^9}, {3.633781749799109*^9, 3.633781758030003*^9}, {
   3.633781995085504*^9, 3.633781996941658*^9}, {3.633782291714192*^9, 
   3.633782318100564*^9}, {3.633782422589624*^9, 3.633782434300798*^9}, 
   3.633782527655582*^9, 3.633782572648855*^9, 3.633783079322213*^9, {
   3.633783161411003*^9, 3.6337832033254557`*^9}, {3.633784610159884*^9, 
   3.633784611961815*^9}, 3.633784743313714*^9, {3.633784778331646*^9, 
   3.6337847813013477`*^9}, {3.633835248467072*^9, 3.633835263267231*^9}, {
   3.633871665091481*^9, 3.633871673499104*^9}, {3.6338720164613113`*^9, 
   3.633872029462021*^9}, {3.6339174648031*^9, 3.633917468758774*^9}, {
   3.669073122091715*^9, 3.669073126044009*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", "False", 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["A: ", False, "\nB: ", True],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6337537050397797`*^9, 3.633755154568853*^9, 3.633755282390167*^9, 
   3.633755358822098*^9, 3.633755454178411*^9, 3.633755496603669*^9, 
   3.6337555349312477`*^9, 3.633755567850998*^9, {3.633756027834581*^9, 
   3.633756043967519*^9}, {3.6337562071481237`*^9, 3.633756208480961*^9}, 
   3.6337563092122583`*^9, {3.63375639896596*^9, 3.63375642079121*^9}, 
   3.633756674469145*^9, {3.633756720268942*^9, 3.6337567436956987`*^9}, 
   3.633756806069735*^9, 3.633756908431961*^9, 3.633757038436343*^9, 
   3.633757158019946*^9, 3.633757196198058*^9, 3.633757235789196*^9, {
   3.633757470168751*^9, 3.633757477770494*^9}, {3.633757640679137*^9, 
   3.6337576425058603`*^9}, 3.63375768295261*^9, 3.633757716494306*^9, {
   3.6337578418972797`*^9, 3.633757916507226*^9}, 3.633757948467671*^9, 
   3.633757985461525*^9, 3.633758016498534*^9, 3.633758110736986*^9, {
   3.633758169553883*^9, 3.6337581774883842`*^9}, 3.633758210987767*^9, 
   3.633758244065753*^9, 3.63375833920216*^9, 3.633758387372699*^9, 
   3.633758582155304*^9, {3.633759062714072*^9, 3.633759076304782*^9}, 
   3.6337592602595253`*^9, {3.6337595374963923`*^9, 3.6337595753241243`*^9}, {
   3.633775430195711*^9, 3.633775465965638*^9}, 3.6337786332298*^9, {
   3.633779205186984*^9, 3.633779216183416*^9}, {3.6337792482884893`*^9, 
   3.63377929421406*^9}, {3.63378054977767*^9, 3.633780561750058*^9}, {
   3.633780599523469*^9, 3.633780603544787*^9}, {3.633780643265562*^9, 
   3.633780644703504*^9}, {3.6337807431656713`*^9, 3.6337807530668163`*^9}, 
   3.6337808019434443`*^9, {3.633780854556623*^9, 3.633780882904454*^9}, {
   3.633781264347467*^9, 3.633781274617879*^9}, {3.6337813159446383`*^9, 
   3.633781320107484*^9}, {3.633781749799109*^9, 3.633781758030003*^9}, {
   3.633781995085504*^9, 3.633781996941658*^9}, {3.633782291714192*^9, 
   3.633782318100564*^9}, {3.633782422589624*^9, 3.633782434300798*^9}, 
   3.633782527655582*^9, 3.633782572648855*^9, 3.633783079322213*^9, {
   3.633783161411003*^9, 3.6337832033254557`*^9}, {3.633784610159884*^9, 
   3.633784611961815*^9}, 3.633784743313714*^9, {3.633784778331646*^9, 
   3.6337847813013477`*^9}, {3.633835248467072*^9, 3.633835263267231*^9}, {
   3.633871665091481*^9, 3.633871673499104*^9}, {3.6338720164613113`*^9, 
   3.633872029462021*^9}, {3.6339174648031*^9, 3.633917468758774*^9}, {
   3.669073122091715*^9, 3.66907312604464*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", 
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["x1", "2"], "+", 
       RowBox[{"x2", " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", "x2"}], ")"}]}]}], ")"}]}], ">", "0"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.633756418760435*^9, 3.633756420862718*^9}, 
   3.633756674548744*^9, {3.6337567203390427`*^9, 3.633756743758852*^9}, 
   3.6337568061320467`*^9, 3.633756908503543*^9, 3.633757038503249*^9, 
   3.633757158083929*^9, 3.633757196265971*^9, 3.6337572358824873`*^9, {
   3.6337574702474957`*^9, 3.633757477818143*^9}, {3.63375764074932*^9, 
   3.6337576425656*^9}, 3.633757683020195*^9, 3.6337577165723867`*^9, {
   3.633757841899169*^9, 3.6337579165674973`*^9}, 3.6337579485283003`*^9, 
   3.633757985518162*^9, 3.633758016617887*^9, 3.6337581107839203`*^9, {
   3.6337581696535473`*^9, 3.633758177537225*^9}, 3.63375821099284*^9, 
   3.633758244071456*^9, 3.633758339269916*^9, 3.633758387462359*^9, 
   3.633758582227419*^9, {3.63375906271951*^9, 3.6337590763093452`*^9}, 
   3.63375926026377*^9, {3.63375953749935*^9, 3.63375957532819*^9}, {
   3.6337754301992064`*^9, 3.6337754659680147`*^9}, 3.6337786332367353`*^9, {
   3.633779205192073*^9, 3.6337792161859703`*^9}, {3.633779248293743*^9, 
   3.633779294216103*^9}, {3.633780549782703*^9, 3.633780561755495*^9}, {
   3.633780599526978*^9, 3.633780603551951*^9}, {3.633780643274527*^9, 
   3.6337806447099648`*^9}, {3.63378074317247*^9, 3.6337807530689707`*^9}, 
   3.6337808019501123`*^9, {3.6337808546047297`*^9, 3.633780882912079*^9}, {
   3.6337812643529463`*^9, 3.6337812746258097`*^9}, {3.633781315951791*^9, 
   3.633781320115823*^9}, {3.633781749804626*^9, 3.633781758039928*^9}, {
   3.6337819950952787`*^9, 3.633781996948547*^9}, {3.633782291722012*^9, 
   3.6337823181088343`*^9}, {3.633782422595525*^9, 3.6337824343112717`*^9}, 
   3.633782527663847*^9, 3.633782572656032*^9, 3.633783079488104*^9, {
   3.633783161416122*^9, 3.633783203332129*^9}, {3.6337846101629953`*^9, 
   3.633784611964375*^9}, 3.633784743317459*^9, {3.63378477833747*^9, 
   3.6337847813058558`*^9}, {3.633835248472438*^9, 3.6338352632722807`*^9}, {
   3.633871665096984*^9, 3.633871673503837*^9}, {3.633872016468995*^9, 
   3.6338720294661083`*^9}, {3.6339174648082447`*^9, 3.633917468762993*^9}, {
   3.669073122095636*^9, 3.669073126045354*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**"}], "*", "Example", " ", 
   RowBox[{"2", "**", "**", "**"}], "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{
  3.633783293299996*^9, {3.633784514712081*^9, 3.6337845326772823`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", 
   RowBox[{"A2", ",", "B2", ",", "0", ",", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"2", "-", "x1", "+", "y1"}], ")"}], "2"], ",", 
    RowBox[{"-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"2", "-", "x1", "+", "y1"}], ")"}], "2"]}]}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.633775505347245*^9, 3.633775507427074*^9}, 
   3.633778657683482*^9, 3.6337790312659817`*^9, 3.63377908323027*^9, 
   3.633781040551813*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC unsatisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{{3.633782450726831*^9, 3.633782454681266*^9}, 
   3.633782942733121*^9, 3.633783085983459*^9, {3.633783216283143*^9, 
   3.633783229403741*^9}, {3.633784739294724*^9, 3.6337847473507423`*^9}, 
   3.633784783894306*^9, 3.633835266117065*^9, 3.633835589017975*^9, 
   3.633836698834118*^9, 3.633836797337131*^9, {3.6338664740160646`*^9, 
   3.633866478749528*^9}, {3.633871836312495*^9, 3.633871878998612*^9}, {
   3.633871935897406*^9, 3.6338719595436707`*^9}, 3.633872036438603*^9, {
   3.669075007517006*^9, 3.669075010696393*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
      RowBox[{"2", " ", "x1"}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], " ", "x1"}], "-", 
      SuperscriptBox["x1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], "-", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
      RowBox[{"2", " ", "x2"}], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["y2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "-", "x1", "+", 
      RowBox[{"2", " ", "x2"}]}], ">", "0"}]}], 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"1", "+", 
      RowBox[{"2", " ", "x2"}], "-", "z1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], "-", 
      RowBox[{"6", " ", "x2"}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{"3", " ", "z1"}], "+", 
      RowBox[{"4", " ", "x2", " ", "z1"}], "-", 
      SuperscriptBox["z1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "x1"}], "-", 
      SuperscriptBox["x1", "2"], "-", 
      RowBox[{"2", " ", "x2"}], "-", 
      SuperscriptBox["x2", "2"], "+", "z1", "-", 
      SuperscriptBox["z2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "x1"}], "-", "x2"}], ">", "0"}]}]}],
  SequenceForm["A: ", 
   And[(-2) (-2 + $CellContext`x1) - (-2 + $CellContext`x1)^2 + 
     2 $CellContext`x1 + 
     2 (-2 + $CellContext`x1) $CellContext`x1 - $CellContext`x1^2 >= 
    0, -4 - 4 (-2 + $CellContext`x1) - (-2 + $CellContext`x1)^2 + 
     2 $CellContext`x2 - $CellContext`x2^2 - $CellContext`y2^2 >= 
    0, -1 - $CellContext`x1 + 2 $CellContext`x2 > 0], "\nB: ", 
   And[1 + 2 $CellContext`x2 - $CellContext`z1 >= 
    0, -2 - 6 $CellContext`x2 - 4 $CellContext`x2^2 + 3 $CellContext`z1 + 
     4 $CellContext`x2 $CellContext`z1 - $CellContext`z1^2 >= 
    0, -1 + 2 $CellContext`x1 - $CellContext`x1^2 - 
     2 $CellContext`x2 - $CellContext`x2^2 + $CellContext`z1 - \
$CellContext`z2^2 >= 0, -1 + 2 $CellContext`x1 - $CellContext`x2 > 0]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.633782450726831*^9, 3.633782454681266*^9}, 
   3.633782942733121*^9, 3.633783085983459*^9, {3.633783216283143*^9, 
   3.633783229403741*^9}, {3.633784739294724*^9, 3.6337847473507423`*^9}, 
   3.633784783894306*^9, 3.633835266117065*^9, 3.633835589017975*^9, 
   3.633836698834118*^9, 3.633836797337131*^9, {3.6338664740160646`*^9, 
   3.633866478749528*^9}, {3.633871836312495*^9, 3.633871878998612*^9}, {
   3.633871935897406*^9, 3.6338719595436707`*^9}, 3.633872036438603*^9, {
   3.669075007517006*^9, 3.669075010698594*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.633783216291415*^9, 3.633783229409319*^9}, {
   3.633784739300809*^9, 3.6337847473563757`*^9}, 3.633784783901285*^9, 
   3.6338352661224413`*^9, 3.6338355890245047`*^9, 3.633836698905147*^9, 
   3.63383679734158*^9, {3.6338664740216923`*^9, 3.633866478752623*^9}, {
   3.6338718363182573`*^9, 3.633871879005456*^9}, {3.633871935903871*^9, 
   3.63387195954989*^9}, 3.633872036441008*^9, {3.669075007923736*^9, 
   3.669075010699717*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
       RowBox[{"2", " ", "x1"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}], " ", "x1"}], "-", 
       SuperscriptBox["x1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
       RowBox[{"2", " ", "x2"}], "-", 
       SuperscriptBox["x2", "2"], "-", 
       SuperscriptBox["y2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "-", "x1", "+", 
       RowBox[{"2", " ", "x2"}]}], ">", "0"}]}], "\[InvisibleSpace]", ",", 
    "\[InvisibleSpace]", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"2", " ", "x2"}], "-", "z1"}], "\[GreaterEqual]", "0"}], "&&", 
     
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], "-", 
       RowBox[{"6", " ", "x2"}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["x2", "2"]}], "+", 
       RowBox[{"3", " ", "z1"}], "+", 
       RowBox[{"4", " ", "x2", " ", "z1"}], "-", 
       SuperscriptBox["z1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", "x1"}], "-", 
       SuperscriptBox["x1", "2"], "-", 
       RowBox[{"2", " ", "x2"}], "-", 
       SuperscriptBox["x2", "2"], "+", "z1", "-", 
       SuperscriptBox["z2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", "x1"}], "-", "x2"}], ">", "0"}]}], ",", "0", ",", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "-", 
       RowBox[{"2", " ", "x2"}], "+", "z1"}], ")"}], "2"], ",", "0"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.633783312021572*^9, 3.633783341058907*^9}, {
  3.6338356636505547`*^9, 3.633835690919232*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC unsatisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{
  3.633783342122178*^9, 3.6337847491455927`*^9, 3.633784787914254*^9, 
   3.63383527139048*^9, 3.633835694630879*^9, 3.633836739481943*^9, 
   3.633836798818584*^9, 3.6338664817806683`*^9, 3.633871871162698*^9, {
   3.633871937747373*^9, 3.633871961626624*^9}, 3.633872039187117*^9, {
   3.6690758126342363`*^9, 3.6690758162459593`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
      RowBox[{"2", " ", "x1"}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], " ", "x1"}], "-", 
      SuperscriptBox["x1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], "-", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
      RowBox[{"2", " ", "x2"}], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["y2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "-", "x1", "+", 
      RowBox[{"2", " ", "x2"}]}], ">", "0"}]}], 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], "-", 
      RowBox[{"6", " ", "x2"}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "x2"}]}], ")"}]}], "+", 
      RowBox[{"4", " ", "x2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "x2"}]}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "x2"}]}], ")"}], "2"]}], "\[GreaterEqual]", "0"}], 
    "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"2", " ", "x1"}], "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["z2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "x1"}], "-", "x2"}], ">", "0"}]}]}],
  SequenceForm["A: ", 
   And[(-2) (-2 + $CellContext`x1) - (-2 + $CellContext`x1)^2 + 
     2 $CellContext`x1 + 
     2 (-2 + $CellContext`x1) $CellContext`x1 - $CellContext`x1^2 >= 
    0, -4 - 4 (-2 + $CellContext`x1) - (-2 + $CellContext`x1)^2 + 
     2 $CellContext`x2 - $CellContext`x2^2 - $CellContext`y2^2 >= 
    0, -1 - $CellContext`x1 + 2 $CellContext`x2 > 0], "\nB: ", 
   And[-2 - 6 $CellContext`x2 - 4 $CellContext`x2^2 + 
     3 (1 + 2 $CellContext`x2) + 
     4 $CellContext`x2 (1 + 2 $CellContext`x2) - (1 + 2 $CellContext`x2)^2 >= 
    0, 2 $CellContext`x1 - $CellContext`x1^2 - $CellContext`x2^2 - \
$CellContext`z2^2 >= 0, -1 + 2 $CellContext`x1 - $CellContext`x2 > 0]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.633783342122178*^9, 3.6337847491455927`*^9, 3.633784787914254*^9, 
   3.63383527139048*^9, 3.633835694630879*^9, 3.633836739481943*^9, 
   3.633836798818584*^9, 3.6338664817806683`*^9, 3.633871871162698*^9, {
   3.633871937747373*^9, 3.633871961626624*^9}, 3.633872039187117*^9, {
   3.6690758126342363`*^9, 3.669075816247604*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{
  3.633783342125843*^9, 3.633784749150576*^9, 3.633784787918586*^9, 
   3.63383527139679*^9, 3.633835694636158*^9, 3.633836739485546*^9, 
   3.6338367988227997`*^9, 3.633866481786978*^9, 3.633871871168042*^9, {
   3.633871937750516*^9, 3.633871961632197*^9}, 3.633872039190937*^9, {
   3.669075812639435*^9, 3.669075816248296*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
       RowBox[{"2", " ", "x1"}], "+", 
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}], " ", "x1"}], "-", 
       SuperscriptBox["x1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], "-", 
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
       RowBox[{"2", " ", "x2"}], "-", 
       SuperscriptBox["x2", "2"], "-", 
       SuperscriptBox["y2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "-", "x1", "+", 
       RowBox[{"2", " ", "x2"}]}], ">", "0"}]}], "\[InvisibleSpace]", ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], "-", 
       RowBox[{"6", " ", "x2"}], "-", 
       RowBox[{"4", " ", 
        SuperscriptBox["x2", "2"]}], "+", 
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"2", " ", "x2"}]}], ")"}]}], "+", 
       RowBox[{"4", " ", "x2", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"2", " ", "x2"}]}], ")"}]}], "-", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"2", " ", "x2"}]}], ")"}], "2"]}], "\[GreaterEqual]", "0"}],
      "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"2", " ", "x1"}], "-", 
       SuperscriptBox["x1", "2"], "-", 
       SuperscriptBox["x2", "2"], "-", 
       SuperscriptBox["z2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", "x1"}], "-", "x2"}], ">", "0"}]}], ",", "1", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "/", "2"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x1", "-", "1"}], ")"}], "^", "2"}]}], "+", 
     RowBox[{
      RowBox[{"1", "/", "2"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"x2", "-", "1"}], ")"}], "^", "2"}]}], "+", 
     RowBox[{
      RowBox[{"1", "/", "4"}], " ", 
      SuperscriptBox["y2", "2"]}], "+", 
     RowBox[{
      RowBox[{"1", "/", "4"}], " ", 
      SuperscriptBox["z2", "2"]}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "/", "4"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"y2", "^", "2"}]}], "-", 
        RowBox[{"x1", "^", "2"}], "-", 
        RowBox[{"x2", "^", "2"}], "+", 
        RowBox[{"2", "*", "x2"}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"1", "/", "2"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "*", "x2"}], "-", "x1", "-", "1"}], ")"}]}]}]}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.63378432786592*^9, 3.633784375532497*^9}, {
   3.633835711227103*^9, 3.633835733919567*^9}, 3.633845750449356*^9, 
   3.633846075675673*^9, {3.6338472044317493`*^9, 3.633847227541658*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC satisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{{3.633784774431439*^9, 3.633784795650906*^9}, 
   3.633835274346519*^9, 3.633835737817391*^9, 3.633836800627549*^9, 
   3.633836867124434*^9, 3.633836907207143*^9, 3.6338463206400223`*^9, {
   3.633846556918928*^9, 3.633846561979269*^9}, {3.633846622702092*^9, 
   3.633846625542375*^9}, 3.6338467211897087`*^9, 3.633846767818293*^9, 
   3.63384683503386*^9, 3.633846893754964*^9, 3.63384704856698*^9, {
   3.633847093191839*^9, 3.633847134580357*^9}, {3.633847233995929*^9, 
   3.633847238926581*^9}, {3.633847499228709*^9, 3.6338475093319407`*^9}, 
   3.633866486347426*^9, 3.633866538737999*^9, 3.633866571025159*^9, 
   3.633866609533739*^9, 3.6338666500161324`*^9, 3.6338671040309668`*^9, 
   3.633871873671288*^9, 3.633871939602448*^9, 3.633872041867505*^9, {
   3.6690766784405212`*^9, 3.669076681882299*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
      RowBox[{"2", " ", "x1"}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], " ", "x1"}], "-", 
      SuperscriptBox["x1", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "4"}], "-", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", "x1"}], ")"}], "2"], "+", 
      RowBox[{"2", " ", "x2"}], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["y2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "-", "x1", "+", 
      RowBox[{"2", " ", "x2"}]}], ">", "0"}]}], 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], "-", 
      RowBox[{"6", " ", "x2"}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["x2", "2"]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "x2"}]}], ")"}]}], "+", 
      RowBox[{"4", " ", "x2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "x2"}]}], ")"}]}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "x2"}]}], ")"}], "2"]}], "\[GreaterEqual]", "0"}], 
    "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"2", " ", "x1"}], "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["z2", "2"]}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "x1"}], "-", "x2"}], ">", "0"}]}]}],
  SequenceForm["A: ", 
   And[(-2) (-2 + $CellContext`x1) - (-2 + $CellContext`x1)^2 + 
     2 $CellContext`x1 + 
     2 (-2 + $CellContext`x1) $CellContext`x1 - $CellContext`x1^2 >= 
    0, -4 - 4 (-2 + $CellContext`x1) - (-2 + $CellContext`x1)^2 + 
     2 $CellContext`x2 - $CellContext`x2^2 - $CellContext`y2^2 >= 
    0, -1 - $CellContext`x1 + 2 $CellContext`x2 > 0], "\nB: ", 
   And[-2 - 6 $CellContext`x2 - 4 $CellContext`x2^2 + 
     3 (1 + 2 $CellContext`x2) + 
     4 $CellContext`x2 (1 + 2 $CellContext`x2) - (1 + 2 $CellContext`x2)^2 >= 
    0, 2 $CellContext`x1 - $CellContext`x1^2 - $CellContext`x2^2 - \
$CellContext`z2^2 >= 0, -1 + 2 $CellContext`x1 - $CellContext`x2 > 0]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.633784774431439*^9, 3.633784795650906*^9}, 
   3.633835274346519*^9, 3.633835737817391*^9, 3.633836800627549*^9, 
   3.633836867124434*^9, 3.633836907207143*^9, 3.6338463206400223`*^9, {
   3.633846556918928*^9, 3.633846561979269*^9}, {3.633846622702092*^9, 
   3.633846625542375*^9}, 3.6338467211897087`*^9, 3.633846767818293*^9, 
   3.63384683503386*^9, 3.633846893754964*^9, 3.63384704856698*^9, {
   3.633847093191839*^9, 3.633847134580357*^9}, {3.633847233995929*^9, 
   3.633847238926581*^9}, {3.633847499228709*^9, 3.6338475093319407`*^9}, 
   3.633866486347426*^9, 3.633866538737999*^9, 3.633866571025159*^9, 
   3.633866609533739*^9, 3.6338666500161324`*^9, 3.6338671040309668`*^9, 
   3.633871873671288*^9, 3.633871939602448*^9, 3.633872041867505*^9, {
   3.6690766784405212`*^9, 3.669076681884151*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "x1"}], "+", "x2"}], ">", "0"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.633784379808193*^9, 3.633784398411374*^9}, {
   3.633784751162965*^9, 3.633784795655389*^9}, 3.633835274351677*^9, 
   3.633835737822692*^9, 3.6338368006326036`*^9, 3.633836867126865*^9, 
   3.633836907212323*^9, 3.6338463207063217`*^9, {3.633846556923278*^9, 
   3.633846561983899*^9}, {3.633846622706163*^9, 3.633846625547361*^9}, 
   3.633846721196616*^9, 3.6338467678267193`*^9, 3.6338468350428753`*^9, 
   3.6338468937621737`*^9, 3.6338470485739813`*^9, {3.633847093201685*^9, 
   3.6338471345888767`*^9}, {3.633847234002163*^9, 3.633847238932397*^9}, {
   3.6338474992377996`*^9, 3.633847509336624*^9}, 3.633866486353409*^9, 
   3.633866538746176*^9, 3.633866571029109*^9, 3.633866609539865*^9, 
   3.6338666500235567`*^9, 3.6338671040349617`*^9, 3.633871873675069*^9, 
   3.633871939607081*^9, 3.633872041870685*^9, {3.6690766784433002`*^9, 
   3.669076681885001*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**"}], "*", "Example", " ", 
   RowBox[{"3", "**", "**", "**"}], "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{{3.6337832684338303`*^9, 3.633783272556663*^9}, {
  3.633784483004459*^9, 3.63378452892607*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"reduce", "[", 
   RowBox[{"A3", ",", "B3", ",", "0", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"y1", "-", "x1", "+", "1"}], ")"}], "^", "2"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"z1", "-", "x2", "+", "1"}], ")"}], "^", "2"}]}], ",", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"y1", "-", "x1", "+", "1"}], ")"}], "^", "2"}]}], "-", "x1", 
     "+", "x2"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.632977493305573*^9, 3.632977498367567*^9}, {
   3.633169596637876*^9, 3.633169597580113*^9}, {3.633171808117592*^9, 
   3.633171814607674*^9}, {3.633319181140072*^9, 3.633319184183222*^9}, 
   3.633319362861286*^9, 3.633319430144971*^9, {3.633494308758827*^9, 
   3.633494310468419*^9}, {3.633494359367708*^9, 3.633494359479037*^9}, {
   3.633494402916493*^9, 3.633494427824272*^9}, {3.633512657844841*^9, 
   3.633512678874529*^9}, 3.633755142716633*^9, {3.633756548564102*^9, 
   3.633756550014579*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"A: \"\>", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "x1"}], "+", "x2"}], "\[GreaterEqual]", "0"}], "&&", 
      RowBox[{"y2", "\[Equal]", 
       RowBox[{"1", "+", "a1"}]}], "&&", 
      RowBox[{
       RowBox[{"1", "-", 
        SuperscriptBox["x1", "2"], "-", 
        SuperscriptBox["x2", "2"], "-", 
        SuperscriptBox["y2", "2"]}], ">", "0"}], "&&", 
      RowBox[{"y1", "\[Equal]", 
       RowBox[{
        RowBox[{"-", "1"}], "+", "x1"}]}], "&&", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"x1", "-", "x2"}], "\[GreaterEqual]", "0"}], "\[Rule]", 
        RowBox[{"a1", "\[Equal]", "tt"}]}], ")"}]}], ")"}]}], 
   "\[InvisibleSpace]", "\<\"\\nDA: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"a1", "\[Equal]", 
     RowBox[{"\[Alpha]", "[", "y1", "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nNA: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\"\\nB: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"x1", "-", "x2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{"z2", "\[Equal]", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "b1"}]}], "&&", 
    RowBox[{
     RowBox[{"1", "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["z2", "2"]}], ">", "0"}], "&&", 
    RowBox[{"z1", "\[Equal]", 
     RowBox[{
      RowBox[{"-", "1"}], "+", "x2"}]}], "&&", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "x1"}], "+", "x2"}], "\[GreaterEqual]", "0"}], "\[Rule]", 
      RowBox[{"b1", "\[Equal]", "tt"}]}], ")"}]}], 
   "\[InvisibleSpace]", "\<\"\\nDB: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"b1", "\[Equal]", 
     RowBox[{"\[Alpha]", "[", "z1", "]"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nNB: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", "}"}], "\[InvisibleSpace]", "\<\"\\nD: \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a1", "\[Equal]", 
      RowBox[{"\[Alpha]", "[", "y1", "]"}]}], ",", 
     RowBox[{"b1", "\[Equal]", 
      RowBox[{"\[Alpha]", "[", "z1", "]"}]}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nN: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"y1", "\[Equal]", "z1"}], "\[Implies]", 
     RowBox[{"a1", "\[Equal]", "b1"}]}], "}"}], 
   "\[InvisibleSpace]", "\<\"\\nNmix: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"y1", "\[Equal]", "z1"}], "\[Implies]", 
     RowBox[{"a1", "\[Equal]", "b1"}]}], "}"}]}],
  SequenceForm[
  "A: " And[-$CellContext`x1 + $CellContext`x2 >= 0, $CellContext`y2 == 
     1 + $CellContext`a1, 
     1 - $CellContext`x1^2 - $CellContext`x2^2 - $CellContext`y2^2 > 
     0, $CellContext`y1 == -1 + $CellContext`x1, $CellContext`x1 - \
$CellContext`x2 >= 0 -> $CellContext`a1 == $CellContext`tt], 
   "\nDA: ", {$CellContext`a1 == $CellContext`\[Alpha][$CellContext`y1]}, 
   "\nNA: ", {}, "\nB: ", 
   And[$CellContext`x1 - $CellContext`x2 >= 
    0, $CellContext`z2 == -1 + $CellContext`b1, 
    1 - $CellContext`x1^2 - $CellContext`x2^2 - $CellContext`z2^2 > 
    0, $CellContext`z1 == -1 + $CellContext`x2, -$CellContext`x1 + \
$CellContext`x2 >= 0 -> $CellContext`b1 == $CellContext`tt], 
   "\nDB: ", {$CellContext`b1 == $CellContext`\[Alpha][$CellContext`z1]}, 
   "\nNB: ", {}, 
   "\nD: ", {$CellContext`a1 == $CellContext`\[Alpha][$CellContext`y1], \
$CellContext`b1 == $CellContext`\[Alpha][$CellContext`z1]}, "\nN: ", {
    Implies[$CellContext`y1 == $CellContext`z1, $CellContext`a1 == \
$CellContext`b1]}, "\nNmix: ", {
    Implies[$CellContext`y1 == $CellContext`z1, $CellContext`a1 == \
$CellContext`b1]}],
  Editable->False]], "Print",
 CellChangeTimes->{{3.633494438056408*^9, 3.633494465603707*^9}, 
   3.633494514312722*^9, {3.633494547198107*^9, 3.633494549004145*^9}, 
   3.63349469148644*^9, 3.633495181410309*^9, {3.633495211929848*^9, 
   3.633495214657867*^9}, {3.633495279239495*^9, 3.633495294038323*^9}, {
   3.633495546380083*^9, 3.633495566373266*^9}, 3.633495729255039*^9, 
   3.63349885539479*^9, 3.633499658834874*^9, {3.633499799029819*^9, 
   3.633499820901723*^9}, {3.633499916346179*^9, 3.633499927905973*^9}, 
   3.63350008616012*^9, 3.633501360042915*^9, 3.633501452391018*^9, {
   3.633501523602582*^9, 3.633501549729919*^9}, {3.633501686312884*^9, 
   3.63350169762033*^9}, 3.633512800169182*^9, {3.633512852865453*^9, 
   3.633512864844069*^9}, 3.633518204440232*^9, 3.633518717417758*^9, 
   3.633519161735358*^9, {3.633519255579406*^9, 3.633519268073056*^9}, {
   3.633519302814106*^9, 3.633519321489112*^9}, 3.633519478790961*^9, {
   3.633519560437989*^9, 3.633519562342674*^9}, 3.633519718968119*^9, {
   3.633519834501017*^9, 3.633519857342189*^9}, {3.633519899431509*^9, 
   3.633519926169665*^9}, 3.633519995589636*^9, 3.633520075113385*^9, 
   3.633520262222976*^9, 3.633520354544552*^9, 3.633520390331646*^9, {
   3.633520834022226*^9, 3.633520863631521*^9}, 3.633520936998212*^9, 
   3.633521762503256*^9, {3.633521839920187*^9, 3.633521842481704*^9}, 
   3.633521936883323*^9, {3.633522066536412*^9, 3.63352206746493*^9}, {
   3.633522119130935*^9, 3.633522121593925*^9}, {3.6337518564226027`*^9, 
   3.63375188834205*^9}, 3.63375514356532*^9, 3.633755292366826*^9, {
   3.633756541323594*^9, 3.633756552594582*^9}, {3.633756585250523*^9, 
   3.63375658930954*^9}, 3.633758150310931*^9, {3.633759644736327*^9, 
   3.633759646272937*^9}, {3.633775406300596*^9, 3.63377542837924*^9}, {
   3.633775467939312*^9, 3.633775469010865*^9}, 3.633835243330184*^9, {
   3.633871483087322*^9, 3.633871498649314*^9}, 3.63387200726401*^9, 
   3.633917458882091*^9, 3.633917527317852*^9, {3.633918202065422*^9, 
   3.633918206694706*^9}, {3.669077675529058*^9, 3.669077679527335*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "Null"}], "}"}]], "Output",
 CellChangeTimes->{{3.633171815538366*^9, 3.633171825998822*^9}, {
   3.633306593553118*^9, 3.633306597986014*^9}, {3.633309170176258*^9, 
   3.633309172825135*^9}, {3.633309215050896*^9, 3.633309224592522*^9}, {
   3.633309274758209*^9, 3.633309276522976*^9}, {3.633309307276503*^9, 
   3.633309343702327*^9}, {3.633319197293079*^9, 3.633319201070711*^9}, {
   3.633319344192864*^9, 3.633319379771288*^9}, {3.633319420281369*^9, 
   3.633319435684424*^9}, {3.633484906620713*^9, 3.63348492565205*^9}, {
   3.633494431246229*^9, 3.633494465605014*^9}, 3.633494514315685*^9, {
   3.633494547200866*^9, 3.633494549006661*^9}, 3.633494691489446*^9, 
   3.63349518141478*^9, {3.63349521193103*^9, 3.633495214659079*^9}, {
   3.633495279242485*^9, 3.633495294042862*^9}, {3.63349554638412*^9, 
   3.633495566374572*^9}, 3.633495729258032*^9, 3.633498855400018*^9, 
   3.633499658863458*^9, {3.633499799034234*^9, 3.633499820907169*^9}, {
   3.633499916351824*^9, 3.633499927912117*^9}, 3.633500086164632*^9, 
   3.633501360046713*^9, 3.633501452396031*^9, {3.633501523607478*^9, 
   3.633501549735157*^9}, {3.633501686320267*^9, 3.633501697623305*^9}, 
   3.633512800234581*^9, {3.633512852889355*^9, 3.633512864847823*^9}, 
   3.6335182044446*^9, 3.633518717422388*^9, 3.633519161739924*^9, {
   3.633519255583488*^9, 3.633519268077815*^9}, {3.633519302819281*^9, 
   3.633519321493419*^9}, 3.633519479514593*^9, {3.63351956108606*^9, 
   3.633519562972976*^9}, 3.633519719418052*^9, {3.633519835206169*^9, 
   3.633519858057694*^9}, {3.633519899450237*^9, 3.633519926174668*^9}, 
   3.633519995594529*^9, 3.633520075118405*^9, 3.633520262226281*^9, 
   3.633520354547423*^9, 3.633520390335858*^9, {3.633520834026355*^9, 
   3.633520863634362*^9}, 3.633520937000096*^9, 3.633521762505195*^9, {
   3.633521839921829*^9, 3.633521842483091*^9}, 3.633521936885864*^9, {
   3.633522066537766*^9, 3.633522067466979*^9}, {3.633522119132302*^9, 
   3.633522121596142*^9}, {3.6337518564268837`*^9, 3.6337518883452578`*^9}, 
   3.633755143568018*^9, 3.633755292368931*^9, {3.6337565413277817`*^9, 
   3.633756552597477*^9}, {3.6337565852530117`*^9, 3.633756589311679*^9}, 
   3.6337581503132563`*^9, {3.633759644738381*^9, 3.6337596462753677`*^9}, {
   3.6337754063024187`*^9, 3.6337754283809137`*^9}, {3.633775467941327*^9, 
   3.633775469013299*^9}, 3.633835243332959*^9, {3.633871483089487*^9, 
   3.633871498651084*^9}, 3.633872007265843*^9, 3.633917458883424*^9, 
   3.633917527320445*^9, {3.633918202067108*^9, 3.6339182066968822`*^9}, {
   3.6690776755302267`*^9, 3.66907767952861*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{
   RowBox[{"IGFQC", "[", 
    RowBox[{"A32", ",", "B31", ",", "1", ",", "0", ",", 
     RowBox[{
      RowBox[{"-", "x1"}], "+", "x2"}]}], "]"}], "||", 
   RowBox[{"IGFQC", "[", 
    RowBox[{"A34", ",", "B31", ",", "1", ",", 
     RowBox[{
      RowBox[{"1", "/", "2"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"y2", "-", "1"}], ")"}], "^", "2"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"z2", "+", "1"}], ")"}], "^", "2"}], "+", 
        RowBox[{"x1", "^", "2"}], "+", 
        RowBox[{"x2", "^", "2"}]}], ")"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1"}], "-", "t", "+", "y2", "+", 
      RowBox[{
       RowBox[{"1", "/", "2"}], 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         SuperscriptBox["x1", "2"], "-", 
         SuperscriptBox["x2", "2"], "-", 
         SuperscriptBox["y2", "2"]}], ")"}]}]}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6339192754125643`*^9, 3.633919306244228*^9}, {
   3.633920445068593*^9, 3.633920446445022*^9}, {3.6339218493326397`*^9, 
   3.633921850292013*^9}, 3.633922001667719*^9, {3.633922175287067*^9, 
   3.6339221893426*^9}, {3.633923521094768*^9, 3.633923551639495*^9}, {
   3.633923709641021*^9, 3.633923720048374*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC satisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{{3.633922054512569*^9, 3.633922082524427*^9}, {
   3.6339221324053993`*^9, 3.633922141965584*^9}, 3.6339237285374413`*^9, {
   3.669079396791039*^9, 3.669079400371811*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "x1"}], "+", "x2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "-", "y", "+", "y2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "+", "y", "-", "y2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["y2", "2"]}], ">", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", "x1", "+", "y1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "x1", "-", "y1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "x2", "-", "y1"}], ">", "0"}]}], 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"x1", "-", "x2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", "z", "+", "z2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "z", "-", "z2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["z2", "2"]}], ">", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", "x2", "+", "z1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "x2", "-", "z1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "t"}], "+", "z"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"t", "-", "z"}], "\[GreaterEqual]", "0"}]}]}],
  SequenceForm["A: ", 
   And[-$CellContext`x1 + $CellContext`x2 >= 
    0, -1 - $CellContext`y + $CellContext`y2 >= 0, 
    1 + $CellContext`y - $CellContext`y2 >= 0, 
    1 - $CellContext`x1^2 - $CellContext`x2^2 - $CellContext`y2^2 > 0, 
    1 - $CellContext`x1 + $CellContext`y1 >= 
    0, -1 + $CellContext`x1 - $CellContext`y1 >= 
    0, -1 + $CellContext`x2 - $CellContext`y1 > 0], "\nB: ", 
   And[$CellContext`x1 - $CellContext`x2 >= 0, 
    1 - $CellContext`z + $CellContext`z2 >= 
    0, -1 + $CellContext`z - $CellContext`z2 >= 0, 
    1 - $CellContext`x1^2 - $CellContext`x2^2 - $CellContext`z2^2 > 0, 
    1 - $CellContext`x2 + $CellContext`z1 >= 
    0, -1 + $CellContext`x2 - $CellContext`z1 >= 
    0, -$CellContext`t + $CellContext`z >= 0, $CellContext`t - $CellContext`z >= 
    0]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.633922054512569*^9, 3.633922082524427*^9}, {
   3.6339221324053993`*^9, 3.633922141965584*^9}, 3.6339237285374413`*^9, {
   3.669079396791039*^9, 3.6690794003732033`*^9}}],

Cell[BoxData["\<\"NSOSC satisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{{3.633922054512569*^9, 3.633922082524427*^9}, {
   3.6339221324053993`*^9, 3.633922141965584*^9}, 3.6339237285374413`*^9, {
   3.669079396791039*^9, 3.66907940037398*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "x1"}], "+", "x2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "-", "y", "+", "y2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "+", "y", "-", "y2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["y2", "2"]}], ">", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", "x1", "+", "y1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "x1", "-", "y1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "t"}], "+", "y"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"t", "-", "y"}], "\[GreaterEqual]", "0"}]}], 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", 
   RowBox[{
    RowBox[{
     RowBox[{"x1", "-", "x2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", "z", "+", "z2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "z", "-", "z2"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", 
      SuperscriptBox["x1", "2"], "-", 
      SuperscriptBox["x2", "2"], "-", 
      SuperscriptBox["z2", "2"]}], ">", "0"}], "&&", 
    RowBox[{
     RowBox[{"1", "-", "x2", "+", "z1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", "x2", "-", "z1"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "t"}], "+", "z"}], "\[GreaterEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{"t", "-", "z"}], "\[GreaterEqual]", "0"}]}]}],
  SequenceForm["A: ", 
   And[-$CellContext`x1 + $CellContext`x2 >= 
    0, -1 - $CellContext`y + $CellContext`y2 >= 0, 
    1 + $CellContext`y - $CellContext`y2 >= 0, 
    1 - $CellContext`x1^2 - $CellContext`x2^2 - $CellContext`y2^2 > 0, 
    1 - $CellContext`x1 + $CellContext`y1 >= 
    0, -1 + $CellContext`x1 - $CellContext`y1 >= 
    0, -$CellContext`t + $CellContext`y >= 0, $CellContext`t - $CellContext`y >= 
    0], "\nB: ", 
   And[$CellContext`x1 - $CellContext`x2 >= 0, 
    1 - $CellContext`z + $CellContext`z2 >= 
    0, -1 + $CellContext`z - $CellContext`z2 >= 0, 
    1 - $CellContext`x1^2 - $CellContext`x2^2 - $CellContext`z2^2 > 0, 
    1 - $CellContext`x2 + $CellContext`z1 >= 
    0, -1 + $CellContext`x2 - $CellContext`z1 >= 
    0, -$CellContext`t + $CellContext`z >= 0, $CellContext`t - $CellContext`z >= 
    0]],
  Editable->False]], "Print",
 CellChangeTimes->{{3.633922054512569*^9, 3.633922082524427*^9}, {
   3.6339221324053993`*^9, 3.633922141965584*^9}, 3.6339237285374413`*^9, {
   3.669079396791039*^9, 3.669079400375401*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "x1"}], "+", "x2"}], ">", "0"}], "||", 
    RowBox[{
     RowBox[{
      FractionBox["1", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "4"}], " ", "t"}], "-", 
        SuperscriptBox["x1", "2"], "-", 
        SuperscriptBox["x2", "2"]}], ")"}]}], ">", "0"}]}]}], "}"}]], "Output",\

 CellChangeTimes->{{3.633922044951*^9, 3.633922082531041*^9}, {
   3.633922132410077*^9, 3.6339221419706373`*^9}, 3.633923728546356*^9, {
   3.6690793967968388`*^9, 3.669079400376217*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**"}], "*", "Example", " ", 
   RowBox[{"4", "**", "**", "**"}], "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{{3.6337832684338303`*^9, 3.633783272556663*^9}, {
   3.633784483004459*^9, 3.63378452892607*^9}, 3.63513238942675*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", 
   RowBox[{"A4", ",", "B4", ",", "0", ",", 
    RowBox[{
     RowBox[{"x", "^", "2"}], "+", 
     RowBox[{"y", "^", "2"}]}], ",", 
    RowBox[{"2", "y"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.632977493305573*^9, 3.632977498367567*^9}, {
   3.633169596637876*^9, 3.633169597580113*^9}, {3.633171808117592*^9, 
   3.633171814607674*^9}, {3.633319181140072*^9, 3.633319184183222*^9}, 
   3.633319362861286*^9, 3.633319430144971*^9, {3.633494308758827*^9, 
   3.633494310468419*^9}, {3.633494359367708*^9, 3.633494359479037*^9}, {
   3.633494402916493*^9, 3.633494427824272*^9}, {3.633512657844841*^9, 
   3.633512678874529*^9}, 3.633755142716633*^9, {3.633756548564102*^9, 
   3.633756550014579*^9}, {3.635133017661405*^9, 3.6351330241175632`*^9}, {
   3.635139520701913*^9, 3.6351395214072247`*^9}, {3.635139581095376*^9, 
   3.635139584886969*^9}, {3.63513971225492*^9, 3.63513973382225*^9}, 
   3.635139782022645*^9}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC unsatisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{
  3.6351397878200407`*^9, 3.635139829593382*^9, {3.635139871717884*^9, 
   3.6351398730189037`*^9}, 3.635148722930135*^9, 3.635148761602313*^9, 
   3.635149407472808*^9, {3.635150131167108*^9, 3.6351501979408503`*^9}, 
   3.635150374733307*^9, 3.6351510654358683`*^9, {3.635248056735237*^9, 
   3.635248064026698*^9}, {3.6352481548595963`*^9, 3.63524816821732*^9}, 
   3.669080166559094*^9, {3.669080200794194*^9, 3.669080217627612*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", "False", 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["A: ", False, "\nB: ", True],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.6351397878200407`*^9, 3.635139829593382*^9, {3.635139871717884*^9, 
   3.6351398730189037`*^9}, 3.635148722930135*^9, 3.635148761602313*^9, 
   3.635149407472808*^9, {3.635150131167108*^9, 3.6351501979408503`*^9}, 
   3.635150374733307*^9, 3.6351510654358683`*^9, {3.635248056735237*^9, 
   3.635248064026698*^9}, {3.6352481548595963`*^9, 3.63524816821732*^9}, 
   3.669080166559094*^9, {3.669080200794194*^9, 3.669080217628212*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["x", "2"], "+", 
        RowBox[{"y", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", "y"}], ")"}]}]}], ")"}]}], ">", "0"}], "||", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["x", "2"], "+", 
          RowBox[{"y", " ", 
           RowBox[{"(", 
            RowBox[{"4", "+", "y"}], ")"}]}]}], ")"}]}], "\[Equal]", "0"}], "&&",
       "Null"}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.6352480567370253`*^9, 3.6352480640298843`*^9}, {
   3.635248154863043*^9, 3.635248168219254*^9}, 3.6690801665611763`*^9, {
   3.669080200797591*^9, 3.669080217629076*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", 
   RowBox[{"False", ",", "True", ",", "0", ",", "0", ",", "0"}], "]"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.635149460051696*^9, 3.6351494766565027`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"Var(A) is a subset of Var(B), procedure terminates \
with:\"\>"], "Print",
 CellChangeTimes->{
  3.635149484698638*^9, 3.635150153278561*^9, 3.6351503855083237`*^9, 
   3.635151053382823*^9, {3.669081558024181*^9, 3.669081561174963*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", "False", 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm["A: ", False, "\nB: ", True],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.635149484698638*^9, 3.635150153278561*^9, 3.6351503855083237`*^9, 
   3.635151053382823*^9, {3.669081558024181*^9, 3.669081561176188*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "False"}], "}"}]], "Output",
 CellChangeTimes->{
  3.635149484701582*^9, 3.635150153281806*^9, 3.635150385511456*^9, 
   3.635151053384918*^9, {3.6690815580257874`*^9, 3.66908156117741*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**"}], "*", "Example", " ", 
   RowBox[{"5", "**", "**", "**"}], "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{3.635310658587636*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContourPlot3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"z", "-", "x"}], "\[Equal]", "0"}], ",", 
     RowBox[{
      RowBox[{"x", "-", "y"}], "\[Equal]", "0"}], ",", 
     RowBox[{"z", "\[Equal]", "0"}], ",", 
     RowBox[{
      RowBox[{"x", "+", "y"}], "\[Equal]", "0"}], ",", 
     RowBox[{"y", "\[Equal]", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "0.8"}], "x"}], "-", 
       RowBox[{"0.2", "y"}]}], "\[Equal]", "0"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.635310660792592*^9, 3.635310770285883*^9}, {
   3.635310803897155*^9, 3.635310811920167*^9}, {3.635319794872188*^9, 
   3.6353197951760073`*^9}, 3.63532018296688*^9}],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJyk3XncrkdV5vu9k+wkpJFBkaFBRhX1gA00qI0c9ntUAgFF0VYRbAcUZBRa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   "], {{
     {RGBColor[0.880722, 0.611041, 0.142051], EdgeForm[None], Specularity[
       GrayLevel[1], 3], 
      StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJw13Qm8b1P5BvDfueZzcX4H527TufwMTYZIg1JJKZGhFJmnipCZhFTmeR6j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         "]]],
       Lighting->{{"Ambient", 
          RGBColor[0.30100577, 0.22414668499999998`, 0.090484535]}, {
         "Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.2642166, 0.18331229999999998`, 0.04261530000000001], 
          ImageScaled[{2, 0, 2}]}}]}, 
     {RGBColor[0.368417, 0.506779, 0.709798], EdgeForm[None], Specularity[
       GrayLevel[1], 3], 
      StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJxF3WeYHMXVBeBlVyBgBNIsEpoBNGhXKzKInBEZTM45Z0w2GZGzybaxweRg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         "]]],
       Lighting->{{"Ambient", 
          RGBColor[
          0.19699838300000003`, 0.252204821, 0.33320940200000004`]}, {
         "Directional", 
          RGBColor[
          0.15473514000000002`, 0.21284718000000002`, 0.29811516000000005`], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          RGBColor[
          0.15473514000000002`, 0.21284718000000002`, 0.29811516000000005`], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[
          0.15473514000000002`, 0.21284718000000002`, 0.29811516000000005`], 
          ImageScaled[{2, 0, 2}]}}]}, 
     {RGBColor[0.560181, 0.691569, 0.194885], EdgeForm[None], Specularity[
       GrayLevel[1], 3], 
      StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJxN2nfcneP9B/CHnCTGY52HY7a2IMQKNUIJghghhIgRYgti7yqlRoyo2nur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         "]]],
       Lighting->{{"Ambient", 
          RGBColor[0.1830429875, 0.21424763749999998`, 0.0962851875]}, {
         "Directional", 
          RGBColor[0.14004525, 0.17289224999999997`, 0.048721249999999994`], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          RGBColor[0.14004525, 0.17289224999999997`, 0.048721249999999994`], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.14004525, 0.17289224999999997`, 0.048721249999999994`], 
          ImageScaled[{2, 0, 2}]}}]}, 
     {RGBColor[0.922526, 0.385626, 0.209179], EdgeForm[None], Specularity[
       GrayLevel[1], 6], 
      StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJw13Xe8bOP1BvCjzIy2r3K1O0cc7tUiiN5Fr9EJIhGiRO89IYjoRI0aIcgv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         "]]],
       Lighting->{{"Ambient", 
          RGBColor[0.30756835, 0.18676585, 0.147065275]}, {"Directional", 
          RGBColor[0.2306315, 0.0964065, 0.05229475], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          GrayLevel[0.3], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.2306315, 0.0964065, 0.05229475], 
          ImageScaled[{2, 0, 2}]}}]}, 
     {RGBColor[0.528488, 0.470624, 0.701351], EdgeForm[None], Specularity[
       GrayLevel[1], 6], 
      StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJxN23W8Z2XVBfDLDHAvdYeGl/nBHEDpLmEkpIaUIaQlhu6UkJLuku6QbqRE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         "]]],
       Lighting->{{"Ambient", 
          RGBColor[0.41139519999999996`, 0.3882496, 0.4805404]}, {
         "Directional", 
          RGBColor[0.264244, 0.235312, 0.3506755], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          Hue[0.7, 1, 1], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.264244, 0.235312, 0.3506755], 
          ImageScaled[{2, 0, 2}]}}]}, 
     {RGBColor[0.772079, 0.431554, 0.102387], EdgeForm[None], Specularity[
       GrayLevel[1], 6], 
      StyleBox[GraphicsGroup3DBox[Polygon3DBox[CompressedData["
1:eJw13AeYXVUVBeChiPMCMhAmEHAGBmZA6SigUkSaClIEpIsgIAhKE5BebEix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         "]]],
       Lighting->{{"Ambient", 
          RGBColor[0.35441579999999995`, 0.2863108, 0.2204774]}, {
         "Directional", 
          RGBColor[0.19301974999999993`, 0.1078885, 0.02559675], 
          ImageScaled[{0, 2, 2}]}, {"Directional", 
          GrayLevel[0.3], 
          ImageScaled[{2, 2, 2}]}, {"Directional", 
          RGBColor[0.19301974999999993`, 0.1078885, 0.02559675], 
          ImageScaled[{2, 0, 2}]}}]}, {}, {}, {}, {}, {}, {}, {}, {}, {}}, {
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0k9oznEcwPHPnpg/G/a0zaQ9zx4XjVqPP9eR5ZFNs4MjpYyUP+GAOYww
KXGQC0mJJsth2S7bTImDlJMw4ZnHLsuBCy0XB69vO3x6fd6/Z/1+3+e3Z03v
yT0nqiJiwuSWRixnbVNEPQu6gSuNS/FkRUQ3B7mbQyzxHrfxLjvYVRdR5aY7
2WnGXMvwKf/5mxGu1bNs5Xe2sMI8v6WzsMxp89X0OcvndG8H+cSzutP+wT5l
+nWP/mGfNEf09qb57/XK3Na9utG57tgXc5+u5i2d5X5dx/u6L51Rn+FfPeP6
c13hnJ7mpP7CP7rMl+n56WXW2DmsX/Cnz9/wo16V8U59PmWvsS8xWf1ON9jr
TcHkTSkb0cwOruZWVnMjF7DIDNuy6QVHrOeQ51TSOzSP7WU+TM/mA77ndT7j
NY5zgKO8xIvmgjlvFuWdy9n77afMQv1Wpx/MDec9zNf6EG/qHek+usTTegtH
dDvP6XV8pFt5XBc4qPPpmfqqr9Gjr7CoB9itL7NNH0v/f32Uv3MRu+wH7QfM
nN6rN9s3mV96gy7al5nZ3Pzv+z/xdVxg
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0r9LlHEcwPFv52WgR+CJpJylDXqHIlIGauYtLmWQ1Ga5pDn4AysiMlyc
agg9JbA07IeD1GBElBDR0lRLDlLhPyC0OJRFeZa9Hhw+vD7v53gev895h3sv
nxvZE0J4YzpLQqiJhVBdHMJZe5P9iGk2Laa0PIQhJjjMEl5iIS8yzl4u82BB
CK+5qgf4iX1c4QxjPr/Pv3qK28wxzwlOmj/2LfPL/DbJshBGnO1H9Azn2+R1
HfesOV3IG/qz67f1V07qBtef6kZO6QwPeNYde529xaT0Pd1qz7lvnz6pp+15
9353/Zve5Aa3WJT0HnHn1IF79Y7r+ehMulLXM5FwBqb0Ue7Xx5jRrUzqNtbq
dmaje02uwvlNyj7Dat5lFR8xzce86W9u+75G+Y9jbHf9Izu4yEN8yArOs5Yv
mOFL1vEVl6P/m/ninZ/zg3dZ4pqe43s9yxWd4zs9wXXdz2e6O3qOPs9F3cO3
+hTn9QnO8jiXXM/ypy7w/k983wumS4/67IH9WvQb1IP6qr3DfotX9Diz+jS7
dSfTuosX9BnW6HRs9/f9H7n7XTY=
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0TkoxnEcx/GfohRy5chRFEnJYnAMjifHgHIMEnLtj0SOZJTBRpRIyiDq
IZPsykYmIZvCgEEmkZcM716f8ff9/4vHJnqicSGERUXiQ2hWeUYIraxgOyvZ
yRoOsI5DrOcoG9mkcXuSa5ziOme5yXlucYn7XOYBVxjjsY4UTQ7hhNM85QzP
uMorbnBd1/Y2b7jDW36wOiGET9byiw38ZhNTU0LoYzr7mcVhjmpEZZnuYikH
WcJu5rOLeexkDjuYzWK+u+FNRfYrC/nCAj4znfdM4x1TeMNkJilRl94Yxwv+
uOWcT4zxkYd84B7vuMsFtnCOEU6ymjWK2lXsZRG7WMg25v59j/j///0L6Jo+
Cw==
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0ktIVAEUgOFjoBKkLTRBIyoiColI1IboDYNUUJIbaZW0SdHGFDJfmUJY
YGaEgzsXRbRLIURcRAhG0KIHDVIhaGFJRa9FIK36hhaH7/x37p253Llbz7XW
pXIiYsY8Lo1ozI2Y5QW2mpQpL4po4/aCiCvco/u4SQ+wSl/jNj3MQ/ouE3qG
J/U0q/UUd26IaLCv2Bez1+kTesley0984ppMXsQzPc8H+iWf6jTv6FFO6Bsc
0YN8qMc5qZf4Xq/N9116HRf0T8en9He+1a/ty/aP5ov5arZsjMhzfhnzuZlr
WMJgMSedlynzm3zDCXY4ftbnKTYwzX6OsYcj7OYtdvEmh81le6fpMJUm4Zl8
c28V9pxiz5S/9AEuu999/KETXNW1WXWSn3UN/+rT/K1feaZH9Que0vNM6gzn
9IB7v6/7eY9Djl21t5sxPajP22/bm3hdN2f/B32QF/V+dukaduokL+ndbNS7
2Kv3skVXstpUmR7Pr9scs/fxePZcFvIwC3iE61nPHTzDtPt/530d5QeOc5WP
+Ie9fM6m3P/v9z9WwWhA
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0TsoBWAYgOHfxOISJTk6ZVBWAyuRolBEMVDMomSQUjqcUMjlqON2Qgah
yKZMymaUQQaZZHBXLovnZHh7vr7p7/tL+wbbBjJCCGOKZ4YwoZgKc0KYZoSL
jDLBCh6xipU6MdfwlHU8Y4qRrBC2GeUey3jAcp6zmhes5SUb2aRm1ZeE0MIG
trKRbWxnNzvYw072sot9nOQc45znNBc5wyUmuMkVppjkqrbNO9pSQW4Ia8xl
ktmM8dcbx/nNUb5zhK8s5gaLuMZ8LqfvpTzzAn/cZZhfHOIb+/nMFz3pMxLC
hx7TOz6k97zlPW94x2ve8oo33OUJd3jMFA+5wX3Oc4uz6b/hFNcj///9B8jP
TMw=
       "]]}, 
     {GrayLevel[0], Line3DBox[CompressedData["
1:eJwl0j1IVWEYB/BHaTAJr9G95pCBi9Csk2WDX6Cgw40gRAsCFbUPHExBEAUt
QUVcxMmpxlwUs5ykloK2cDE/BnFR8CuJQsrfweHP733f8z+X555zSp++zL7I
iYgZyaQjPuVFFHONjcy/GpEnpamIBvv/zmv5jzU85zoPdHLltl4wR/ZuRVzh
Lvf1fvCApyxwfsQUT1jIY15nRUlECyvZynts410+Zh3bWc8ONrBRuqy7k3Mz
ZNkkvWZr5jA7OcIyVmci7uiVWBfJA+c3+ZzV7OEzqbIu17vPP0knP+Ivb/CM
19juegHP7X/r/eQvbvCMWzzkE70dbicdeWfmt/Ldeo7fOMuvyT3M+M1tprnJ
FNc5n/wvDvIhB5L52c9HHGIb37CVrznFL/wsr5JnZpY+TpttjBMc5STHucwF
ZvXe84P9Ry5xhYusT96R66veaVH68vu5AGRMUQw=
       
       "]]}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, 
     {GrayLevel[0.2], 
      Line3DBox[{2589, 2588, 5446, 2587, 5449, 2594, 5450, 2595, 5474, 2620, 
       5475, 2611, 5465, 2610, 5463, 5464, 2609, 5518, 2671, 5517, 2657, 5507,
        2656, 5508, 2658, 5529, 2685, 5530, 2677, 5523, 2676, 2678}], 
      Line3DBox[{2592, 2591, 5448, 2593, 5473, 2619, 5472, 2618, 5470, 2617, 
       5471, 2616, 5469, 2615, 5543, 5544, 2664, 5511, 2663, 5512, 2662, 5510,
        2661, 5527, 2674, 5521, 2673, 5522, 2675, 5524, 2680, 2679}], 
      Line3DBox[{2608, 2605, 5459, 2590, 5447, 2586, 5445, 2585, 5476, 2621, 
       5477, 2613, 5466, 2612, 5467, 5468, 2614, 5514, 2668, 5520, 2672, 5519,
        2660, 5509, 2659, 5525, 2681, 5526, 2682, 5528, 2683, 2684}], 
      Line3DBox[{2633, 2632, 5484, 2631, 5483, 2630, 5499, 2648, 5496, 2646, 
       5494, 2602, 5454, 2601, 5457, 5458, 2604, 5531, 2686, 5532, 2687, 5540,
        2693, 5536, 2692, 5550, 2703, 5555, 2710, 5553, 2709, 2712}], 
      Line3DBox[{2634, 2629, 5482, 2628, 5500, 2653, 5501, 2647, 5495, 2645, 
       5493, 2600, 5453, 2599, 5455, 5456, 2603, 5533, 2688, 5539, 2695, 5537,
        2694, 5538, 2696, 5549, 2702, 5554, 2708, 5552, 2707, 2711}], 
      Line3DBox[{2636, 2635, 5485, 2623, 5478, 2622, 5479, 2624, 5502, 2654, 
       5503, 2641, 5489, 2640, 5487, 5488, 2639, 5548, 2701, 5547, 2691, 5535,
        2690, 5534, 2689, 5563, 2720, 5564, 2705, 5551, 2704, 2706}], 
      Line3DBox[{2638, 2637, 5486, 2626, 5480, 2625, 5481, 2627, 5504, 2655, 
       5506, 2643, 5490, 2642, 5491, 5492, 2644, 5541, 2697, 5542, 2698, 5545,
        2699, 5546, 2700, 5556, 2713, 5558, 2715, 5562, 2718, 2719}], 
      Line3DBox[{2650, 2649, 5498, 2652, 5497, 2651, 5505, 2598, 5452, 2597, 
       5451, 2596, 5462, 2607, 5460, 5461, 2606, 5559, 2716, 5561, 2717, 5560,
        2714, 5557, 2670, 5516, 2669, 5515, 2667, 5513, 2666, 2665}], 
      Line3DBox[{2724, 2723, 5570, 2727, 5566, 2726, 5568, 2730, 5581, 2743, 
       5578, 2742, 5586, 2749, 5584, 5585, 2748, 5629, 2793, 5626, 2792, 5644,
        2815, 5646, 2811, 5640, 2810, 5639, 2809, 5638, 2808, 2807}], 
      Line3DBox[{2725, 2722, 5565, 2721, 5569, 2731, 5571, 2732, 5593, 2746, 
       5580, 2745, 5579, 2744, 5582, 5583, 2747, 5621, 2784, 5628, 2791, 5625,
        2790, 5627, 2794, 5637, 2802, 5636, 2801, 5641, 2806, 2805}], 
      Line3DBox[{2737, 2736, 5573, 2735, 5576, 2741, 5575, 2740, 5590, 2751, 
       5587, 2750, 5596, 2755, 5591, 5592, 2754, 5635, 2800, 5634, 2789, 5624,
        2788, 5623, 2787, 5643, 2814, 5648, 2818, 5647, 2804, 2803}], 
      Line3DBox[{2738, 2734, 5572, 2733, 5577, 2739, 5574, 2729, 5567, 2728, 
       5589, 2753, 5588, 2752, 5594, 5595, 2756, 5630, 2795, 5633, 2799, 5632,
        2786, 5622, 2785, 5645, 2813, 5642, 2812, 5649, 2817, 2816}], 
      Line3DBox[{2758, 2757, 5598, 2761, 5602, 2765, 5600, 2764, 5607, 2773, 
       5606, 2772, 5612, 2777, 5610, 5611, 2776, 5656, 2828, 5658, 2827, 5655,
        2826, 5667, 2838, 5666, 2837, 5665, 2798, 5631, 2797, 2796}], 
      Line3DBox[{2763, 2762, 5599, 2760, 5597, 2759, 5601, 2766, 5608, 2774, 
       5609, 2775, 5613, 2778, 5614, 5615, 2779, 5650, 2819, 5651, 2820, 5657,
        2825, 5654, 2824, 5661, 2830, 5664, 2835, 5663, 2834, 2836}], 
      Line3DBox[{2769, 2768, 5603, 2767, 5605, 2771, 5604, 2770, 5616, 2780, 
       5617, 2781, 5618, 2782, 5619, 5620, 2783, 5660, 2829, 5659, 2823, 5653,
        2822, 5652, 2821, 5668, 2839, 5669, 2832, 5662, 2831, 2833}], 
      Line3DBox[{2853, 2852, 7702, 2841, 7695, 2840, 7696, 2842, 7717, 2868, 
       7714, 2857, 7704, 2856, 7705, 2858, 7763, 2923, 7762, 2915, 7754, 2914,
        7753, 2913, 7769, 2930, 7775, 2932, 7771, 7772, 2931, 2933}], 
      Line3DBox[{2855, 2854, 7703, 2845, 7698, 2844, 7697, 2843, 7710, 2864, 
       7716, 2867, 7713, 2866, 7715, 2869, 7759, 2920, 7758, 2919, 7761, 2922,
        7760, 2921, 7770, 2929, 7768, 2928, 7773, 7774, 2934, 2935}], 
      Line3DBox[{2878, 2877, 7723, 2881, 7748, 2907, 7745, 2906, 7744, 2905, 
       7743, 2851, 7701, 2850, 7700, 2849, 7784, 2946, 7786, 2945, 7783, 2944,
        7800, 2953, 7792, 2952, 7791, 2951, 7795, 7796, 2959, 2958}], 
      Line3DBox[{2883, 2882, 7725, 2880, 7722, 2879, 7747, 2900, 7737, 2899, 
       7736, 2898, 7742, 2904, 7741, 2903, 7776, 2936, 7777, 2937, 7785, 2943,
        7782, 2942, 7793, 2954, 7794, 2957, 7797, 7798, 2961, 2960}], 
      Line3DBox[{2888, 2889, 7729, 7728, 2885, 7726, 2886, 7727, 2887, 7732, 
       2893, 7733, 2890, 7730, 2891, 7731, 2892, 7880, 3058, 7881, 3055, 7878,
        3056, 7879, 3057, 7883, 3062, 7884, 3059, 7882, 3060, 3061}], 
      Line3DBox[{2926, 2927, 7767, 7766, 2924, 7764, 2925, 7765, 2918, 7756, 
       2916, 7755, 2917, 7757, 2912, 7752, 2859, 7706, 2860, 7707, 2861, 7708,
        2862, 7709, 2863, 7712, 2865, 7711, 2846, 7699, 2847, 2848}], 
      Line3DBox[{2955, 2956, 7804, 7803, 2965, 7805, 2964, 7802, 2940, 7780, 
       2941, 7781, 2938, 7778, 2939, 7779, 2896, 7735, 2897, 7739, 2902, 7740,
        2901, 7738, 2884, 7724, 2872, 7718, 2873, 7719, 2870, 2871}], 
      Line3DBox[{2967, 2966, 7807, 7806, 2962, 7799, 2963, 7801, 2949, 7789, 
       2950, 7790, 2947, 7787, 2948, 7788, 2911, 7750, 2909, 7749, 2910, 7751,
        2908, 7746, 2874, 7720, 2875, 7721, 2876, 7734, 2894, 2895}], 
      Line3DBox[{2969, 2968, 7808, 2970, 7813, 2975, 7810, 2974, 7823, 2992, 
       7825, 2994, 7827, 2996, 7826, 2995, 7861, 3036, 7860, 3034, 7858, 3033,
        7864, 3041, 7890, 3068, 7892, 3053, 7876, 7877, 3050, 3049}], 
      Line3DBox[{2973, 2972, 7809, 2971, 7812, 2978, 7814, 2979, 7833, 2993, 
       7824, 2991, 7822, 2990, 7821, 2989, 7871, 3047, 7870, 3032, 7857, 3031,
        7859, 3035, 7893, 3069, 7891, 3052, 7874, 7875, 3051, 3054}], 
      Line3DBox[{2982, 2981, 7815, 2980, 7818, 2987, 7817, 2986, 7832, 3000, 
       7829, 2999, 7834, 3002, 7835, 3003, 7869, 3046, 7868, 3045, 7873, 3048,
        7872, 3040, 7863, 3039, 7889, 3064, 7885, 7886, 3063, 3065}], 
      Line3DBox[{2985, 2984, 7816, 2983, 7820, 2988, 7819, 2977, 7811, 2976, 
       7831, 2998, 7828, 2997, 7830, 3001, 7911, 3089, 7910, 3044, 7867, 3043,
        7866, 3042, 7865, 3038, 7862, 3037, 7887, 7888, 3066, 3067}], 
      Line3DBox[{3005, 3004, 7837, 3008, 7841, 3012, 7839, 3011, 7846, 3021, 
       7848, 3023, 7850, 3025, 7849, 3024, 7896, 3072, 7895, 3071, 7894, 3070,
        7901, 3079, 7914, 3092, 7917, 3088, 7908, 7909, 3085, 3084}], 
      Line3DBox[{3010, 3009, 7838, 3007, 7836, 3006, 7840, 3013, 7854, 3029, 
       7855, 3022, 7847, 3020, 7845, 3019, 7907, 3083, 7906, 3075, 7898, 3074,
        7897, 3073, 7918, 3094, 7919, 3093, 7915, 7916, 3087, 3086}], 
      Line3DBox[{3016, 3015, 7842, 3014, 7844, 3018, 7843, 3017, 7852, 3028, 
       7853, 3027, 7851, 3026, 7856, 3030, 7905, 3082, 7904, 3081, 7903, 3080,
        7902, 3077, 7899, 3076, 7900, 3078, 7912, 7913, 3091, 3090}], 
      Line3DBox[{3096, 3095, 5670, 3097, 5671, 3098, 5672, 3099, 5679, 3110, 
       5680, 3111, 5681, 3112, 5682, 5683, 3113, 5734, 3167, 5735, 3168, 5736,
        3169, 5737, 3170, 5746, 3179, 5747, 3180, 5748, 3181, 3182}], 
      Line3DBox[{3101, 3100, 5673, 3102, 5675, 3106, 5676, 3107, 5684, 3114, 
       5685, 3115, 5688, 3118, 5689, 5690, 3119, 5738, 3171, 5739, 3172, 5742,
        3175, 5743, 3176, 5749, 3183, 5750, 3184, 5753, 3187, 3188}], 
      Line3DBox[{3104, 3103, 5674, 3105, 5677, 3108, 5678, 3109, 5686, 3116, 
       5687, 3117, 5691, 3120, 5692, 5693, 3121, 5740, 3173, 5741, 3174, 5744,
        3177, 5745, 3178, 5751, 3185, 5752, 3186, 5754, 3189, 3190}], 
      Line3DBox[{3123, 3122, 5694, 3124, 5697, 3131, 5698, 3132, 5709, 3147, 
       5710, 3148, 5715, 3153, 5716, 5717, 3154, 5755, 3191, 5756, 3192, 5761,
        3197, 5762, 3198, 5775, 3211, 5776, 3212, 5781, 3217, 3218}], 
      Line3DBox[{3128, 3126, 5696, 3130, 5700, 3134, 5702, 3136, 5712, 3150, 
       5714, 3152, 5719, 3156, 5722, 5723, 3158, 5758, 3194, 5760, 3196, 5764,
        3200, 5766, 3202, 5778, 3214, 5780, 3216, 5783, 3220, 3222}], 
      Line3DBox[{3138, 3137, 5703, 3139, 5705, 3143, 5706, 3144, 5724, 3159, 
       5725, 3160, 5728, 3163, 5729, 5730, 3164, 5767, 3203, 5768, 3204, 5771,
        3207, 5772, 3208, 5784, 3223, 5785, 3224, 5788, 3227, 3228}], 
      Line3DBox[{3141, 3140, 5704, 3142, 5707, 3145, 5708, 3146, 5726, 3161, 
       5727, 3162, 5731, 3165, 5732, 5733, 3166, 5769, 3205, 5770, 3206, 5773,
        3209, 5774, 3210, 5786, 3225, 5787, 3226, 5789, 3229, 3230}], 
      Line3DBox[{3221, 3219, 5782, 3215, 5779, 3213, 5777, 3201, 5765, 3199, 
       5763, 3195, 5759, 3193, 5757, 3157, 5721, 5720, 3155, 5718, 3151, 5713,
        3149, 5711, 3135, 5701, 3133, 5699, 3129, 5695, 3125, 3127}], 
      Line3DBox[{3232, 3231, 5790, 3233, 5792, 3237, 5793, 3238, 5802, 3251, 
       5803, 3252, 5806, 3255, 5807, 5808, 3256, 5846, 3294, 5847, 3295, 5850,
        3298, 5851, 3299, 5862, 3310, 5863, 3311, 5866, 3314, 3315}], 
      Line3DBox[{3235, 3234, 5791, 3236, 5794, 3239, 5795, 3240, 5804, 3253, 
       5805, 3254, 5809, 3257, 5810, 5811, 3258, 5848, 3296, 5849, 3297, 5852,
        3300, 5853, 3301, 5864, 3312, 5865, 3313, 5867, 3316, 3317}], 
      Line3DBox[{3242, 3241, 5796, 3243, 5798, 3247, 5799, 3248, 5812, 3259, 
       5813, 3260, 5816, 3263, 5817, 5818, 3264, 5854, 3302, 5855, 3303, 5858,
        3306, 5859, 3307, 5868, 3318, 5869, 3319, 5872, 3322, 3323}], 
      Line3DBox[{3245, 3244, 5797, 3246, 5800, 3249, 5801, 3250, 5814, 3261, 
       5815, 3262, 5819, 3265, 5820, 5821, 3266, 5856, 3304, 5857, 3305, 5860,
        3308, 5861, 3309, 5870, 3320, 5871, 3321, 5873, 3324, 3325}], 
      Line3DBox[{3268, 3267, 5822, 3269, 5824, 3273, 5825, 3274, 5831, 3282, 
       5832, 3283, 5835, 3286, 5836, 5837, 3287, 5874, 3326, 5875, 3327, 5878,
        3330, 5879, 3331, 5886, 3338, 5887, 3339, 5890, 3342, 3343}], 
      Line3DBox[{3271, 3270, 5823, 3272, 5826, 3275, 5827, 3276, 5833, 3284, 
       5834, 3285, 5838, 3288, 5839, 5840, 3289, 5876, 3328, 5877, 3329, 5880,
        3332, 5881, 3333, 5888, 3340, 5889, 3341, 5891, 3344, 3345}], 
      Line3DBox[{3278, 3277, 5828, 3279, 5829, 3280, 5830, 3281, 5841, 3290, 
       5842, 3291, 5843, 3292, 5844, 5845, 3293, 5882, 3334, 5883, 3335, 5884,
        3336, 5885, 3337, 5892, 3346, 5893, 3347, 5894, 3348, 3349}], 
      Line3DBox[{3357, 3356, 7923, 3355, 7931, 3368, 7930, 3367, 7937, 3377, 
       7939, 3375, 7935, 3374, 7941, 3379, 7993, 3443, 7992, 3442, 7991, 3441,
        7990, 3434, 7984, 3433, 7986, 3437, 7999, 8000, 3446, 3445}], 
      Line3DBox[{3363, 3362, 7926, 3361, 7929, 3366, 7928, 3354, 7922, 3353, 
       7938, 3373, 7934, 3372, 7936, 3376, 8031, 3482, 8030, 3440, 7989, 3439,
        7988, 3438, 7987, 3436, 7985, 3435, 7997, 7998, 3448, 3449}], 
      Line3DBox[{3365, 3364, 7927, 3351, 7920, 3350, 7921, 3352, 7942, 3378, 
       7940, 3370, 7932, 3369, 7933, 3371, 7995, 3444, 7994, 3432, 7983, 3431,
        7982, 3430, 7996, 3447, 8003, 3451, 8001, 8002, 3450, 3452}], 
      Line3DBox[{3381, 3380, 7943, 3384, 7950, 3391, 7947, 3390, 7962, 3410, 
       7965, 3413, 7969, 3417, 7968, 3416, 8006, 3455, 8005, 3454, 8004, 3453,
        8013, 3462, 8041, 3490, 8043, 3478, 8026, 8027, 3473, 3472}], 
      Line3DBox[{3383, 3382, 7949, 3389, 7946, 3388, 7948, 3392, 7964, 3409, 
       7961, 3408, 7971, 3419, 7970, 3418, 8008, 3457, 8007, 3456, 8012, 3461,
        8014, 3463, 8042, 3477, 8025, 3476, 8023, 8024, 3475, 3474}], 
      Line3DBox[{3393, 3394, 7952, 7951, 3395, 8109, 3574, 8110, 3575, 8121, 
       3582, 8116, 3583, 8119, 3584, 8117, 3585, 8129, 3594, 8130, 3592, 8127,
        3593, 8128, 3532, 8072, 3533, 8075, 3528, 8067, 3524, 3525}], 
      Line3DBox[{3396, 3397, 7954, 7953, 3398, 7955, 3399, 7956, 3400, 8122, 
       3587, 8120, 3580, 8115, 3581, 8118, 3586, 8131, 3595, 8132, 3590, 8125,
        3591, 8126, 3534, 8073, 3530, 8071, 3531, 8074, 3526, 3527}], 
      Line3DBox[{3402, 3401, 7957, 3387, 7945, 3386, 7944, 3385, 7979, 3429, 
       7981, 3428, 7978, 3412, 7963, 3411, 8020, 3469, 8019, 3468, 8018, 3467,
        8017, 3466, 8034, 3485, 8037, 3488, 8044, 8045, 3492, 3491}], 
      Line3DBox[{3407, 3406, 7960, 3405, 7959, 3404, 7958, 3403, 7972, 3420, 
       7974, 3422, 7980, 3427, 7977, 3426, 8016, 3465, 8015, 3464, 8022, 3471,
        8021, 3470, 8038, 3489, 8040, 3487, 8035, 8036, 3486, 3493}], 
      Line3DBox[{3424, 3423, 7976, 3425, 7975, 3421, 7973, 3415, 7967, 3414, 
       7966, 3360, 7925, 3359, 7924, 3358, 8009, 3458, 8011, 3460, 8010, 3459,
        8039, 3484, 8033, 3483, 8032, 3481, 8028, 8029, 3480, 3479}], 
      Line3DBox[{3502, 3501, 8050, 3500, 8049, 3499, 8069, 3516, 8060, 3515, 
       8059, 3514, 8062, 3518, 8061, 3517, 8087, 3549, 8089, 3551, 8094, 3555,
        8091, 3554, 8106, 3572, 8108, 3573, 8111, 8112, 3577, 3576}], 
      Line3DBox[{3503, 3498, 8048, 3497, 8068, 3529, 8070, 3523, 8066, 3522, 
       8065, 3521, 8064, 3520, 8063, 3519, 8088, 3550, 8093, 3553, 8090, 3552,
        8092, 3556, 8107, 3571, 8105, 3570, 8113, 8114, 3579, 3578}], 
      Line3DBox[{3546, 3545, 8085, 3538, 8078, 3535, 8076, 3513, 8058, 3512, 
       8057, 3496, 8047, 3495, 8046, 3494, 8142, 3604, 8144, 3603, 8140, 3596,
        8133, 3562, 8098, 3561, 8097, 3560, 8101, 8102, 3567, 3566}], 
      Line3DBox[{3548, 3547, 8084, 3537, 8077, 3536, 8079, 3511, 8056, 3510, 
       8055, 3509, 8054, 3508, 8053, 3507, 8137, 3600, 8143, 3602, 8139, 3601,
        8141, 3559, 8096, 3558, 8095, 3557, 8103, 8104, 3569, 3568}], 
      Line3DBox[{3563, 3564, 8100, 8099, 3565, 8134, 3597, 8135, 3598, 8136, 
       3599, 8138, 3589, 8124, 3588, 8123, 3504, 8051, 3505, 8052, 3506, 8080,
        3539, 8081, 3540, 8086, 3541, 8082, 3542, 8083, 3543, 3544}], 
      Line3DBox[{3606, 3605, 8145, 3607, 8146, 3608, 8147, 3609, 8154, 3620, 
       8155, 3621, 8156, 3622, 8157, 3623, 8201, 3677, 8202, 3678, 8203, 3679,
        8204, 3680, 8213, 3689, 8214, 3690, 8215, 8216, 3691, 3692}], 
      Line3DBox[{3611, 3610, 8148, 3612, 8150, 3616, 8151, 3617, 8158, 3624, 
       8159, 3625, 8162, 3628, 8163, 3629, 8205, 3681, 8206, 3682, 8209, 3685,
        8210, 3686, 8217, 3693, 8218, 3694, 8221, 8222, 3697, 3698}], 
      Line3DBox[{3614, 3613, 8149, 3615, 8152, 3618, 8153, 3619, 8160, 3626, 
       8161, 3627, 8164, 3630, 8165, 3631, 8207, 3683, 8208, 3684, 8211, 3687,
        8212, 3688, 8219, 3695, 8220, 3696, 8223, 8224, 3699, 3700}], 
      Line3DBox[{3633, 3632, 8166, 3634, 8169, 3641, 8170, 3642, 8181, 3657, 
       8182, 3658, 8187, 3663, 8188, 3664, 8225, 3701, 8226, 3702, 8231, 3707,
        8232, 3708, 8245, 3721, 8246, 3722, 8251, 8252, 3727, 3728}], 
      Line3DBox[{3637, 3635, 8167, 3639, 8171, 3643, 8173, 3645, 8183, 3659, 
       8185, 3661, 8189, 3665, 8191, 3667, 8227, 3703, 8229, 3705, 8233, 3709,
        8235, 3711, 8247, 3723, 8249, 3725, 8253, 8254, 3729, 3731}], 
      Line3DBox[{3648, 3647, 8175, 3649, 8177, 3653, 8178, 3654, 8193, 3669, 
       8194, 3670, 8197, 3673, 8198, 3674, 8237, 3713, 8238, 3714, 8241, 3717,
        8242, 3718, 8257, 3733, 8258, 3734, 8261, 8262, 3737, 3738}], 
      Line3DBox[{3651, 3650, 8176, 3652, 8179, 3655, 8180, 3656, 8195, 3671, 
       8196, 3672, 8199, 3675, 8200, 3676, 8239, 3715, 8240, 3716, 8243, 3719,
        8244, 3720, 8259, 3735, 8260, 3736, 8263, 8264, 3739, 3740}], 
      Line3DBox[{3732, 3730, 8256, 8255, 3726, 8250, 3724, 8248, 3712, 8236, 
       3710, 8234, 3706, 8230, 3704, 8228, 3668, 8192, 3666, 8190, 3662, 8186,
        3660, 8184, 3646, 8174, 3644, 8172, 3640, 8168, 3636, 3638}], 
      Line3DBox[{3742, 3741, 8265, 3743, 8267, 3747, 8268, 3748, 8277, 3761, 
       8278, 3762, 8281, 3765, 8282, 3766, 8314, 3804, 8315, 3805, 8318, 3808,
        8319, 3809, 8330, 3820, 8331, 3821, 8334, 8335, 3824, 3825}], 
      Line3DBox[{3745, 3744, 8266, 3746, 8269, 3749, 8270, 3750, 8279, 3763, 
       8280, 3764, 8283, 3767, 8284, 3768, 8316, 3806, 8317, 3807, 8320, 3810,
        8321, 3811, 8332, 3822, 8333, 3823, 8336, 8337, 3826, 3827}], 
      Line3DBox[{3752, 3751, 8271, 3753, 8273, 3757, 8274, 3758, 8285, 3769, 
       8286, 3770, 8289, 3773, 8290, 3774, 8322, 3812, 8323, 3813, 8326, 3816,
        8327, 3817, 8338, 3828, 8339, 3829, 8342, 8343, 3832, 3833}], 
      Line3DBox[{3755, 3754, 8272, 3756, 8275, 3759, 8276, 3760, 8287, 3771, 
       8288, 3772, 8291, 3775, 8292, 3776, 8324, 3814, 8325, 3815, 8328, 3818,
        8329, 3819, 8340, 3830, 8341, 3831, 8344, 8345, 3834, 3835}], 
      Line3DBox[{3778, 3777, 8293, 3779, 8295, 3783, 8296, 3784, 8302, 3792, 
       8303, 3793, 8306, 3796, 8307, 3797, 8346, 3836, 8347, 3837, 8350, 3840,
        8351, 3841, 8358, 3848, 8359, 3849, 8362, 8363, 3852, 3853}], 
      Line3DBox[{3781, 3780, 8294, 3782, 8297, 3785, 8298, 3786, 8304, 3794, 
       8305, 3795, 8308, 3798, 8309, 3799, 8348, 3838, 8349, 3839, 8352, 3842,
        8353, 3843, 8360, 3850, 8361, 3851, 8364, 8365, 3854, 3855}], 
      Line3DBox[{3788, 3787, 8299, 3789, 8300, 3790, 8301, 3791, 8310, 3800, 
       8311, 3801, 8312, 3802, 8313, 3803, 8354, 3844, 8355, 3845, 8356, 3846,
        8357, 3847, 8366, 3856, 8367, 3857, 8368, 8369, 3858, 3859}], 
      Line3DBox[{3870, 3869, 8378, 3871, 8377, 3868, 8376, 3867, 8383, 3875, 
       8380, 3874, 8382, 3877, 8381, 3876, 8403, 3900, 8404, 3901, 8406, 3903,
        8405, 3902, 8411, 3907, 8412, 3908, 8413, 8414, 3909, 3910}], 
      Line3DBox[{3881, 3880, 8386, 8385, 3878, 8384, 3879, 8387, 3882, 8409, 
       3906, 8410, 3905, 8408, 3904, 8407, 3866, 8375, 3863, 8372, 3862, 8371,
        3860, 8370, 3861, 8374, 3864, 8373, 3865, 8379, 3872, 3873}], 
      Line3DBox[{3891, 3889, 8394, 8393, 3890, 8396, 3893, 8397, 3892, 8395, 
       3885, 8389, 3883, 8388, 3884, 8391, 3888, 8392, 3886, 8390, 3887, 8399,
        3896, 8400, 3894, 8398, 3895, 8401, 3899, 8402, 3897, 3898}], 
      Line3DBox[{3913, 3912, 8415, 3911, 8416, 3914, 8417, 3915, 8419, 3918, 
       8420, 3917, 8418, 3916, 8421, 3919, 8431, 3932, 8432, 3931, 8430, 3930,
        8429, 3929, 8436, 3936, 8435, 3934, 8433, 8434, 3933, 3935}], 
      Line3DBox[{3922, 3921, 8422, 3920, 8424, 3924, 8423, 3923, 8425, 3925, 
       8426, 3926, 8428, 3928, 8427, 3927, 8439, 3940, 8440, 3938, 8437, 3937,
        8438, 3939, 8444, 3944, 8443, 3943, 8441, 8442, 3942, 3941}]}, 
     {GrayLevel[0.2], 
      Line3DBox[{3994, 3993, 5471, 4001, 8468, 4002, 5475, 8472, 4013, 4012, 
       5477, 8474, 4014, 3965, 5451, 8451, 3966, 4063, 5493, 8493, 4064, 5494,
        4059, 8491, 4060, 5503, 4075, 8502, 4076, 5506, 4079, 8650, 4225, 
       5578, 4224, 8571, 4230, 5580, 4229, 8578, 4246, 5587, 4245, 8580, 4249,
        5589, 4248, 8602, 4285, 5606, 4283, 8598, 4284, 5609, 8600, 4294, 
       4306, 5617, 8611, 4304, 4305, 4309}], 
      Line3DBox[{3996, 3995, 5470, 3999, 8467, 4000, 5474, 8471, 4011, 4015, 
       5476, 8473, 4007, 3967, 5452, 8452, 3968, 4065, 5495, 8497, 4066, 5496,
        4067, 8503, 4074, 5502, 4073, 8505, 4078, 5504, 4077, 8651, 4233, 
       5581, 4231, 8570, 4232, 5593, 4243, 8577, 4244, 5590, 4250, 8579, 4204,
        5567, 4203, 8603, 4287, 5607, 4286, 8601, 4289, 5608, 8599, 4288, 
       4303, 5616, 8610, 4302, 4308, 4307}], 
      Line3DBox[{4004, 4003, 5473, 4009, 8469, 3956, 5449, 8449, 3948, 3947, 
       5447, 8447, 3952, 3953, 5497, 8498, 4070, 4072, 5500, 8500, 4027, 5483,
        4018, 8475, 4017, 5478, 4016, 8476, 4021, 5480, 4022, 8574, 4200, 
       5566, 4199, 8561, 4206, 5569, 4197, 8559, 4198, 5576, 4221, 8568, 4222,
        5577, 4223, 8590, 4267, 5602, 4270, 8593, 4260, 5597, 8587, 4259, 
       4278, 5605, 8597, 4277, 4279, 4280}], 
      Line3DBox[{4008, 4005, 5472, 4006, 8470, 3958, 5450, 8450, 3957, 3949, 
       5445, 8445, 3946, 3945, 5505, 8504, 4069, 4068, 5501, 8501, 4071, 5499,
        4029, 8479, 4020, 5479, 4019, 8477, 4023, 5481, 4024, 8573, 4205, 
       5568, 4201, 8560, 4202, 5571, 4195, 8558, 4196, 5575, 4218, 8566, 4219,
        5574, 4220, 8612, 4266, 5600, 4265, 8594, 4269, 5601, 8592, 4268, 
       4276, 5604, 8596, 4275, 4281, 4282}], 
      Line3DBox[{4010, 3955, 5448, 3954, 8448, 3950, 5446, 8446, 3951, 3975, 
       5459, 8456, 3976, 3977, 5498, 8499, 4028, 4025, 5482, 8478, 4026, 5484,
        4030, 8487, 4046, 5485, 4045, 8488, 4047, 5486, 4048, 8572, 4207, 
       5570, 4194, 8557, 4193, 5565, 4192, 8567, 4211, 5573, 4208, 8562, 4209,
        5572, 4210, 8591, 4262, 5598, 4261, 8588, 4263, 5599, 8589, 4264, 
       4272, 5603, 8595, 4271, 4273, 4274}], 
      Line3DBox[{4092, 4091, 5512, 4096, 8512, 4095, 5517, 8517, 4109, 4113, 
       5520, 8520, 4114, 4115, 5561, 8552, 4158, 4157, 5539, 8535, 4143, 5532,
        4142, 8542, 4172, 5547, 4161, 8537, 4162, 5542, 4037, 8483, 4038, 
       5626, 4331, 8621, 4335, 5628, 4334, 8626, 4347, 5634, 4351, 8629, 4352,
        5633, 4353, 8667, 4391, 5658, 4390, 8648, 4376, 5651, 8641, 4375, 
       4402, 5659, 8655, 4395, 4396, 4397}], 
      Line3DBox[{4098, 4097, 5511, 4083, 8507, 4082, 5518, 8518, 4110, 4101, 
       5514, 8514, 4102, 4103, 5559, 8550, 4156, 4144, 5533, 8530, 4141, 5531,
        4140, 8543, 4173, 5548, 4159, 8536, 4160, 5541, 4039, 8484, 4040, 
       5629, 4336, 8620, 4323, 5621, 4322, 8627, 4348, 5635, 4339, 8623, 4340,
        5630, 4341, 8665, 4389, 5656, 4377, 8642, 4374, 5650, 8640, 4373, 
       4403, 5660, 8656, 4392, 4393, 4394}], 
      Line3DBox[{4125, 4124, 5524, 4128, 8524, 4121, 5523, 8522, 4122, 4137, 
       5528, 8527, 4138, 4099, 5513, 8513, 4100, 4104, 5552, 8546, 4180, 5553,
        4179, 8545, 4178, 5551, 4177, 8554, 4188, 5562, 4035, 8482, 4036, 
       5638, 4362, 8633, 4363, 5641, 4359, 8632, 4360, 5647, 4370, 8637, 4371,
        5649, 4337, 8622, 4338, 5631, 4342, 8660, 4410, 5663, 8661, 4409, 
       4408, 5662, 8659, 4407, 4421, 4420}], 
      Line3DBox[{4126, 4118, 5522, 4119, 8521, 4120, 5530, 8529, 4139, 4133, 
       5526, 8526, 4129, 4105, 5515, 8515, 4106, 4181, 5554, 8547, 4182, 5555,
        4183, 8553, 4189, 5564, 4191, 8555, 4186, 5558, 4031, 8480, 4032, 
       5639, 4356, 8631, 4357, 5636, 4358, 8639, 4372, 5648, 4368, 8635, 4364,
        5642, 4343, 8624, 4344, 5665, 4411, 8662, 4412, 5664, 8663, 4413, 
       4422, 5669, 8669, 4424, 4418, 4417}], 
      Line3DBox[{4127, 4116, 5521, 4117, 8523, 4123, 5529, 8528, 4132, 4130, 
       5525, 8525, 4131, 4107, 5516, 8516, 4108, 4174, 5549, 8544, 4175, 5550,
        4176, 8556, 4190, 5563, 4187, 8549, 4184, 5556, 4033, 8481, 4034, 
       5640, 4354, 8630, 4355, 5637, 4361, 8638, 4367, 5643, 4365, 8634, 4366,
        5645, 4345, 8625, 4346, 5666, 4404, 8657, 4405, 5661, 8658, 4406, 
       4423, 5668, 8668, 4419, 4415, 4414}], 
      Line3DBox[{4134, 4094, 5510, 4090, 8510, 4080, 5507, 8506, 4081, 4089, 
       5519, 8519, 4111, 4112, 5560, 8551, 4154, 4152, 5537, 8533, 4153, 5540,
        4150, 8532, 4148, 5535, 4147, 8540, 4170, 5545, 4043, 8486, 4044, 
       5644, 4333, 8619, 4330, 5625, 4320, 8616, 4321, 5624, 4329, 8628, 4349,
        5632, 4350, 8666, 4387, 5655, 4385, 8646, 4386, 5657, 8649, 4383, 
       4381, 5653, 8644, 4380, 4398, 4399}], 
      Line3DBox[{4136, 4135, 5527, 4093, 8511, 4084, 5508, 8508, 4085, 4086, 
       5509, 8509, 4087, 4088, 5557, 8548, 4185, 4155, 5538, 8534, 4151, 5536,
        4149, 8531, 4146, 5534, 4145, 8541, 4171, 5546, 4041, 8485, 4042, 
       5646, 4369, 8636, 4332, 5627, 4324, 8617, 4325, 5623, 4326, 8618, 4327,
        5622, 4328, 8664, 4416, 5667, 4388, 8647, 4384, 5654, 8645, 4382, 
       4379, 5652, 8643, 4378, 4400, 4401}], 
      Line3DBox[{4168, 4164, 5544, 4166, 8539, 3986, 5464, 8461, 3984, 3982, 
       5468, 8465, 3990, 3979, 5461, 8458, 3962, 3960, 5456, 8455, 3972, 5458,
        3974, 8495, 4054, 5488, 4050, 8490, 4052, 5492, 4062, 8653, 4241, 
       5585, 4235, 8576, 4237, 5583, 4239, 8583, 4255, 5592, 4253, 8586, 4257,
        5595, 4213, 8564, 4215, 5611, 4296, 8607, 4301, 5615, 8609, 4291, 
       4293, 5620, 8615, 4313, 4315, 4319}], 
      Line3DBox[{4169, 3997, 5469, 3998, 8466, 3987, 5465, 8462, 3988, 3991, 
       5466, 8463, 3992, 3980, 5462, 8459, 3964, 3963, 5453, 8453, 3969, 5454,
        3970, 8496, 4056, 5489, 4055, 8492, 4058, 5490, 4057, 8654, 4242, 
       5586, 4226, 8569, 4227, 5579, 4228, 8581, 4251, 5596, 4258, 8584, 4247,
        5588, 4216, 8565, 4217, 5612, 4297, 8604, 4298, 5613, 8605, 4299, 
       4311, 5618, 8613, 4310, 4317, 4316}], 
      Line3DBox[{4318, 4314, 4312, 8614, 5619, 4292, 4290, 8608, 5614, 4300, 
       8606, 4295, 5610, 4214, 8563, 4212, 5594, 4256, 8585, 4252, 5591, 4254,
        8582, 4238, 5582, 4236, 8575, 4234, 5584, 4240, 8652, 4061, 5491, 
       4051, 8489, 4049, 5487, 4053, 8494, 3973, 5457, 3971, 8454, 5455, 3959,
        3961, 8457, 5460, 3978, 3989, 8464, 5467, 3981, 3983, 8460, 5463, 
       3985, 8538, 4165, 5543, 4163, 4167}], 
      Line3DBox[{4426, 4425, 8673, 4432, 8672, 4431, 8674, 4434, 8687, 4447, 
       8683, 4446, 8685, 4449, 8684, 4448, 8701, 4485, 8700, 4483, 8698, 4482,
        8699, 4484, 8717, 4501, 8714, 4500, 8712, 8713, 4499, 4502}], 
      Line3DBox[{4433, 4430, 9255, 5375, 9260, 5377, 9261, 4455, 9259, 4454, 
       9258, 4453, 9257, 4452, 9256, 5376, 9284, 5390, 9287, 4486, 9285, 5391,
        9286, 5392, 9289, 4498, 9288, 5393, 9290, 9291, 4503, 5394}], 
      Line3DBox[{4441, 4440, 8679, 4437, 8676, 4436, 8675, 4435, 8678, 4439, 
       8677, 4438, 8682, 4445, 8681, 4444, 8727, 4519, 8726, 4492, 8705, 4491,
        8704, 4490, 8707, 4493, 8706, 4489, 8702, 8703, 4488, 4487}], 
      Line3DBox[{4443, 4442, 8680, 4429, 8671, 4428, 8670, 4427, 8689, 4457, 
       8690, 4456, 8688, 4451, 8686, 4450, 8711, 4497, 8710, 4496, 8709, 4495,
        8708, 4494, 8715, 4504, 8716, 4505, 8718, 8719, 4507, 4506}], 
      Line3DBox[{4458, 5378, 9263, 4459, 9262, 5379, 9266, 5381, 9277, 5386, 
       9279, 4474, 9278, 4473, 9276, 5385, 9293, 4509, 9292, 5395, 9295, 4510,
        9294, 5396, 9302, 5401, 9305, 4523, 9303, 9304, 4518, 5399}], 
      Line3DBox[{4464, 4463, 8691, 4462, 8696, 4480, 8697, 4479, 8695, 4478, 
       8694, 4477, 8693, 4476, 8692, 4475, 8720, 4508, 8723, 4512, 8721, 4511,
        8722, 4513, 8725, 4517, 8724, 4516, 8728, 8729, 4521, 4520}], 
      Line3DBox[{4472, 4471, 9275, 4461, 9265, 4460, 9264, 5380, 9280, 5387, 
       9283, 4481, 9281, 5388, 9282, 5389, 9297, 4514, 9296, 5397, 9299, 4515,
        9298, 5398, 9301, 4522, 9300, 5400, 9306, 9307, 5402, 5403}], 
      Line3DBox[{4525, 4524, 8734, 4530, 8732, 4529, 8733, 4531, 8742, 4543, 
       8741, 4542, 8746, 4548, 8745, 4547, 8782, 4590, 8781, 4589, 8785, 4594,
        8786, 4595, 8801, 4606, 8797, 4605, 8795, 8796, 4604, 4603}], 
      Line3DBox[{4534, 4533, 8735, 4532, 8740, 4541, 8739, 4540, 8748, 4551, 
       8749, 4550, 8747, 4549, 8753, 4556, 8790, 4598, 8789, 4597, 8788, 4596,
        8787, 4592, 8783, 4591, 8784, 4593, 8799, 8800, 4614, 4613}], 
      Line3DBox[{4539, 4538, 8738, 4528, 8731, 4527, 8730, 4526, 8754, 4554, 
       8751, 4553, 8750, 4552, 8752, 4555, 8794, 4602, 8793, 4601, 8792, 4600,
        8791, 4599, 8798, 4615, 8804, 4617, 8802, 8803, 4616, 4618}], 
      Line3DBox[{4559, 4558, 8755, 4557, 8757, 4562, 8758, 4563, 8777, 4576, 
       8767, 4575, 8766, 4574, 8765, 4573, 8812, 4626, 8811, 4620, 8805, 4619,
        8806, 4621, 8834, 4647, 8833, 4634, 8819, 8820, 4633, 4635}], 
      Line3DBox[{4566, 4565, 8759, 4564, 8764, 4572, 8763, 4561, 8756, 4560, 
       8775, 4584, 8773, 4583, 8774, 4546, 8744, 4545, 8743, 4544, 8810, 4625,
        8809, 4624, 8808, 4623, 8807, 4622, 8831, 8832, 4645, 4646}], 
      Line3DBox[{4569, 4568, 8760, 4567, 8762, 4571, 8761, 4570, 8778, 4587, 
       8780, 4588, 8779, 4586, 8776, 4585, 8814, 4628, 8813, 4627, 8816, 4630,
        8815, 4629, 8827, 4642, 8830, 4644, 8828, 8829, 4643, 4648}], 
      Line3DBox[{4582, 4581, 8772, 4579, 8769, 4578, 8768, 4577, 8771, 4580, 
       8770, 4537, 8737, 4536, 8736, 4535, 8818, 4632, 8817, 4631, 8824, 4640,
        8823, 4639, 8826, 4641, 8825, 4638, 8821, 8822, 4637, 4636}], 
      Line3DBox[{4611, 4610, 9312, 5405, 9314, 4612, 9313, 4608, 9309, 4607, 
       9308, 5404, 9311, 4609, 9310, 4469, 9272, 4468, 9271, 5384, 9274, 4470,
        9273, 4466, 9268, 4465, 9267, 5382, 9269, 9270, 4467, 5383}], 
      Line3DBox[{4649, 4650, 5670, 4651, 5673, 4658, 5674, 4659, 5694, 4689, 
       5696, 5695, 4690, 5703, 4695, 5704, 4696, 5790, 4784, 5791, 4785, 5796,
        4790, 5797, 4791, 5822, 4816, 5823, 4817, 5828, 4822, 4823}], 
      Line3DBox[{4652, 4653, 5671, 4656, 5675, 4660, 5677, 4662, 5697, 4691, 
       5700, 5699, 4693, 5705, 4697, 5707, 4699, 5792, 4786, 5794, 4788, 5798,
        4792, 5800, 4794, 5824, 4818, 5826, 4820, 5829, 4824, 4826}], 
      Line3DBox[{4654, 4655, 5672, 4657, 5676, 4661, 5678, 4663, 5698, 4692, 
       5702, 5701, 4694, 5706, 4698, 5708, 4700, 5793, 4787, 5795, 4789, 5799,
        4793, 5801, 4795, 5825, 4819, 5827, 4821, 5830, 4825, 4827}], 
      Line3DBox[{4664, 4665, 5679, 4668, 5684, 4679, 5686, 4681, 5709, 4701, 
       5712, 5711, 4703, 5724, 4711, 5726, 4713, 5802, 4796, 5804, 4798, 5812,
        4806, 5814, 4808, 5831, 4828, 5833, 4830, 5841, 4838, 4840}], 
      Line3DBox[{4666, 4667, 5680, 4669, 5685, 4680, 5687, 4682, 5710, 4702, 
       5714, 5713, 4704, 5725, 4712, 5727, 4714, 5803, 4797, 5805, 4799, 5813,
        4807, 5815, 4809, 5832, 4829, 5834, 4831, 5842, 4839, 4841}], 
      Line3DBox[{4670, 4671, 5681, 4676, 5688, 4683, 5691, 4686, 5715, 4705, 
       5719, 5718, 4708, 5728, 4715, 5731, 4718, 5806, 4800, 5809, 4803, 5816,
        4810, 5819, 4813, 5835, 4832, 5838, 4835, 5843, 4842, 4845}], 
      Line3DBox[{4673, 4675, 5683, 4678, 5690, 4685, 5693, 4688, 5717, 4707, 
       5723, 5721, 4710, 5730, 4717, 5733, 4720, 5808, 4802, 5811, 4805, 5818,
        4812, 5821, 4815, 5837, 4834, 5840, 4837, 5845, 4844, 4847}], 
      Line3DBox[{4721, 4722, 5734, 4725, 5738, 4733, 5740, 4735, 5755, 4756, 
       5758, 5757, 4758, 5767, 4764, 5769, 4766, 5846, 4848, 5848, 4850, 5854,
        4856, 5856, 4858, 5874, 4876, 5876, 4878, 5882, 4884, 4886}], 
      Line3DBox[{4723, 4724, 5735, 4726, 5739, 4734, 5741, 4736, 5756, 4757, 
       5760, 5759, 4759, 5768, 4765, 5770, 4767, 5847, 4849, 5849, 4851, 5855,
        4857, 5857, 4859, 5875, 4877, 5877, 4879, 5883, 4885, 4887}], 
      Line3DBox[{4727, 4728, 5736, 4731, 5742, 4737, 5744, 4739, 5761, 4760, 
       5764, 5763, 4762, 5771, 4768, 5773, 4770, 5850, 4852, 5852, 4854, 5858,
        4860, 5860, 4862, 5878, 4880, 5880, 4882, 5884, 4888, 4890}], 
      Line3DBox[{4729, 4730, 5737, 4732, 5743, 4738, 5745, 4740, 5762, 4761, 
       5766, 5765, 4763, 5772, 4769, 5774, 4771, 5851, 4853, 5853, 4855, 5859,
        4861, 5861, 4863, 5879, 4881, 5881, 4883, 5885, 4889, 4891}], 
      Line3DBox[{4741, 4742, 5746, 4745, 5749, 4750, 5751, 4752, 5775, 4772, 
       5778, 5777, 4774, 5784, 4778, 5786, 4780, 5862, 4864, 5864, 4866, 5868,
        4870, 5870, 4872, 5886, 4892, 5888, 4894, 5892, 4898, 4900}], 
      Line3DBox[{4743, 4744, 5747, 4746, 5750, 4751, 5752, 4753, 5776, 4773, 
       5780, 5779, 4775, 5785, 4779, 5787, 4781, 5863, 4865, 5865, 4867, 5869,
        4871, 5871, 4873, 5887, 4893, 5889, 4895, 5893, 4899, 4901}], 
      Line3DBox[{4747, 4748, 5748, 4749, 5753, 4754, 5754, 4755, 5781, 4776, 
       5783, 5782, 4777, 5788, 4782, 5789, 4783, 5866, 4868, 5867, 4869, 5872,
        4874, 5873, 4875, 5890, 4896, 5891, 4897, 5894, 4902, 4903}], 
      Line3DBox[{4846, 4843, 5844, 4836, 5839, 4833, 5836, 4814, 5820, 4811, 
       5817, 4804, 5810, 4801, 5807, 4719, 5732, 4716, 5729, 4709, 5720, 5722,
        4706, 5716, 4687, 5692, 4684, 5689, 4677, 5682, 4674, 4672}], 
      Line3DBox[{4906, 4905, 8835, 4904, 8839, 4911, 8840, 4913, 8858, 4923, 
       8848, 4922, 8847, 4921, 8846, 4920, 8892, 4964, 8891, 4954, 8882, 4953,
        8884, 4956, 8913, 4985, 8912, 4971, 8898, 8899, 4970, 4972}], 
      Line3DBox[{4912, 4909, 8837, 4908, 8836, 4907, 8838, 4910, 8853, 4930, 
       8852, 4929, 8855, 4932, 8854, 4931, 8883, 4955, 8887, 4960, 8886, 4959,
        8888, 4961, 8900, 4967, 8895, 4966, 8896, 8897, 4969, 4968}], 
      Line3DBox[{4916, 4915, 8841, 4914, 8845, 4919, 8844, 4918, 8857, 4934, 
       8856, 4933, 8859, 4935, 8860, 4936, 8890, 4963, 8889, 4962, 8894, 4965,
        8893, 4958, 8885, 4957, 8911, 4983, 8909, 8910, 4982, 4984}], 
      Line3DBox[{4926, 4925, 8849, 4924, 8851, 4928, 8850, 4927, 8922, 4993, 
       8921, 4992, 8924, 4994, 8923, 4980, 8906, 4979, 8905, 4978, 8908, 4981,
        8907, 4975, 8902, 4974, 8901, 4973, 8903, 8904, 4977, 4976}], 
      Line3DBox[{4941, 4940, 8864, 4939, 8863, 4938, 8876, 4947, 8869, 4946, 
       8868, 4945, 8872, 4950, 8871, 4949, 8914, 4986, 8915, 4987, 8920, 4990,
        8917, 4989, 8929, 4996, 8930, 4997, 8933, 8934, 5000, 4999}], 
      Line3DBox[{4942, 4943, 8866, 8865, 4944, 9011, 5098, 9012, 5099, 9014, 
       5100, 9013, 5101, 9015, 5082, 8999, 5083, 9029, 5115, 9030, 5116, 9031,
        5117, 9032, 5033, 8962, 5032, 8961, 5029, 8959, 5030, 5031}], 
      Line3DBox[{4998, 5423, 8932, 8931, 5424, 8935, 5425, 8936, 5426, 8939, 
       4991, 8918, 5419, 8919, 4988, 8916, 4917, 8842, 5406, 8843, 5407, 8873,
        5413, 8874, 5414, 8875, 5415, 8877, 5417, 8878, 4951, 5416}], 
      Line3DBox[{5003, 5427, 8941, 8940, 5002, 8938, 5001, 8937, 4995, 8925, 
       5420, 8926, 5421, 8927, 5422, 8928, 4948, 8870, 5412, 8879, 5418, 8881,
        4952, 8880, 4937, 8861, 5408, 8862, 5409, 8867, 5410, 5411}], 
      Line3DBox[{5007, 5006, 8947, 5012, 8945, 5011, 8946, 5013, 8955, 5022, 
       8952, 5021, 8958, 5028, 8957, 5027, 8998, 5081, 8997, 5080, 9000, 5084,
        9001, 5085, 9019, 5097, 9010, 5096, 9008, 9009, 5095, 5094}], 
      Line3DBox[{5010, 5009, 8944, 5005, 8942, 5004, 8943, 5008, 8960, 5025, 
       8954, 5024, 8953, 5023, 8956, 5026, 9005, 5091, 9004, 5079, 8996, 5078,
        8995, 5077, 9020, 5104, 9018, 5103, 9016, 9017, 5102, 5105}], 
      Line3DBox[{5040, 5039, 8966, 5038, 8968, 5041, 8967, 5035, 8963, 5034, 
       8965, 5037, 8964, 5036, 8970, 5046, 9034, 5119, 9033, 5118, 9036, 5120,
        9035, 5111, 9025, 5110, 9024, 5109, 9026, 9027, 5113, 5112}], 
      Line3DBox[{5045, 5044, 8972, 5047, 8971, 5043, 8969, 5042, 8989, 5066, 
       8988, 5065, 8992, 5071, 8991, 5070, 9021, 5106, 9023, 5108, 9022, 5107,
        9028, 5114, 9037, 5123, 9040, 5124, 9038, 9039, 5122, 5121}], 
      Line3DBox[{5055, 5054, 8977, 5053, 8979, 5056, 8978, 5050, 8974, 5049, 
       8973, 5048, 8976, 5052, 8975, 5051, 8985, 5063, 8984, 5062, 8987, 5064,
        8986, 5059, 8981, 5058, 8980, 5057, 8982, 8983, 5061, 5060}], 
      Line3DBox[{5073, 5430, 9320, 5072, 9319, 5429, 9321, 5069, 9318, 5068, 
       9317, 5015, 9316, 5014, 9315, 5428, 9324, 5432, 9325, 5433, 9329, 5128,
        9328, 5126, 9327, 5125, 9326, 5087, 9322, 9323, 5086, 5431}], 
      Line3DBox[{5076, 5075, 8994, 5074, 8993, 5067, 8990, 5018, 8949, 5017, 
       8948, 5016, 8951, 5020, 8950, 5019, 9041, 5127, 9042, 5129, 9044, 5130,
        9043, 5090, 9003, 5089, 9002, 5088, 9006, 9007, 5093, 5092}], 
      Line3DBox[{5141, 5139, 9054, 5147, 9050, 5145, 9052, 5149, 9066, 5164, 
       9068, 5166, 9075, 5172, 9072, 5170, 9108, 5217, 9111, 5215, 9106, 5213,
        9115, 5209, 9102, 5207, 9121, 5225, 9117, 9118, 5223, 5227}], 
      Line3DBox[{5144, 5138, 9049, 5137, 9057, 5152, 9056, 5151, 9071, 5169, 
       9070, 5168, 9074, 5174, 9077, 5175, 9140, 5246, 9141, 5219, 9110, 5212,
        9105, 5211, 9104, 5206, 9101, 5205, 9123, 9124, 5230, 5229}], 
      Line3DBox[{5187, 5186, 9085, 5185, 9084, 5184, 9086, 5181, 9081, 5180, 
       9094, 5197, 9092, 5196, 9093, 5163, 9065, 5162, 9064, 5161, 9135, 5243,
        9137, 5240, 9131, 5239, 9133, 5238, 9129, 9130, 5237, 5248}], 
      Line3DBox[{5188, 5183, 9083, 5182, 9088, 5190, 9087, 5189, 9096, 5199, 
       9095, 5198, 9097, 5200, 9098, 5158, 9061, 5157, 9062, 5159, 9136, 5242,
        9134, 5241, 9132, 5236, 9128, 5235, 9143, 9144, 5250, 5249}], 
      Line3DBox[{5193, 5439, 9336, 5143, 9333, 5437, 9334, 5131, 9330, 5434, 
       9331, 5435, 9332, 5436, 9335, 5438, 9341, 5443, 9342, 5444, 9344, 5247,
        9343, 5222, 9340, 5204, 9337, 5440, 9338, 9339, 5441, 5442}], 
      Line3DBox[{5194, 5192, 9089, 5191, 9090, 5195, 9091, 5134, 9046, 5133, 
       9045, 5132, 9048, 5136, 9047, 5135, 9146, 5251, 9145, 5245, 9139, 5244,
        9142, 5221, 9113, 5220, 9114, 5202, 9099, 9100, 5201, 5203}], 
      Line3DBox[{5228, 5224, 9120, 9119, 5226, 9122, 5208, 9103, 5210, 9116, 
       5214, 9107, 5216, 9112, 5218, 9109, 5171, 9073, 5173, 9076, 5167, 9069,
        5165, 9067, 5150, 9053, 5146, 9051, 5148, 9055, 5140, 5142}], 
      Line3DBox[{5233, 5231, 9126, 9125, 5232, 9127, 5234, 9138, 5160, 9063, 
       5153, 9058, 5154, 9060, 5155, 9059, 5156, 9080, 5179, 9082, 5178, 9079,
        5176, 9078, 5177, 9214, 5335, 9213, 5336, 9215, 5333, 5334}], 
      Line3DBox[{5259, 5258, 9153, 5262, 9151, 5261, 9152, 5264, 9162, 5276, 
       9163, 5277, 9170, 5281, 9166, 5280, 9206, 5329, 9208, 5328, 9205, 5327,
        9210, 5324, 9202, 5323, 9218, 5338, 9216, 9217, 5337, 5339}], 
      Line3DBox[{5260, 5257, 9150, 5256, 9155, 5266, 9154, 5265, 9165, 5279, 
       9164, 5278, 9169, 5283, 9171, 5284, 9245, 5366, 9246, 5330, 9207, 5326,
        9204, 5325, 9203, 5322, 9201, 5321, 9219, 9220, 5341, 5340}], 
      Line3DBox[{5263, 5255, 9149, 5253, 9147, 5252, 9148, 5254, 9168, 5282, 
       9167, 5269, 9157, 5268, 9156, 5267, 9212, 5332, 9211, 5331, 9209, 5320,
        9200, 5319, 9223, 5345, 9224, 5344, 9221, 9222, 5343, 5342}], 
      Line3DBox[{5299, 5298, 9180, 5297, 9179, 5296, 9182, 5291, 9175, 5290, 
       9191, 5313, 9189, 5312, 9190, 5275, 9161, 5274, 9160, 5273, 9236, 5360,
        9238, 5356, 9231, 5355, 9233, 5354, 9229, 9230, 5353, 5369}], 
      Line3DBox[{5300, 5295, 9178, 5294, 9184, 5305, 9183, 5304, 9193, 5315, 
       9192, 5314, 9197, 5318, 9199, 5271, 9158, 5270, 9159, 5272, 9237, 5358,
        9234, 5357, 9232, 5352, 9228, 5351, 9249, 9250, 5371, 5370}], 
      Line3DBox[{5302, 5301, 9181, 5286, 9172, 5285, 9173, 5287, 9198, 5316, 
       9194, 5310, 9187, 5307, 9185, 5306, 9235, 5359, 9240, 5361, 9239, 5347,
        9225, 5346, 9247, 5367, 9248, 5368, 9251, 9252, 5373, 5372}], 
      Line3DBox[{5303, 5289, 9174, 5288, 9176, 5292, 9177, 5293, 9196, 5317, 
       9195, 5309, 9186, 5308, 9188, 5311, 9242, 5362, 9241, 5350, 9227, 5349,
        9226, 5348, 9253, 5374, 9254, 5364, 9243, 9244, 5363, 5365}]}, 
     {GrayLevel[0.2], 
      Line3DBox[{5900, 5898, 8448, 5897, 8469, 5913, 8470, 5912, 8467, 5911, 
       8468, 5910, 8466, 5909, 8538, 8539, 5949, 8507, 5948, 8512, 5953, 8510,
        5952, 8511, 5954, 8523, 5958, 8521, 5957, 8524, 5962, 5961}], 
      Line3DBox[{5926, 5927, 8482, 5923, 8480, 5924, 8481, 5925, 8485, 5931, 
       8486, 5928, 8483, 5929, 8484, 5930, 8653, 8652, 6093, 8654, 6091, 8650,
        6092, 8651, 6015, 8573, 6016, 8574, 6012, 8572, 6013, 6014}], 
      Line3DBox[{5933, 5932, 8487, 5917, 8475, 5916, 8479, 5922, 8503, 5939, 
       8491, 5938, 8496, 5942, 8494, 8495, 5941, 8543, 5978, 8542, 5971, 8532,
        5970, 8531, 5969, 8556, 5989, 8553, 5984, 8545, 5980, 5979}], 
      Line3DBox[{5935, 5934, 8488, 5919, 8476, 5918, 8477, 5920, 8505, 5946, 
       8502, 5940, 8492, 5937, 8489, 8490, 5936, 8536, 5974, 8537, 5975, 8540,
        5976, 8541, 5977, 8549, 5987, 8555, 5990, 8554, 5983, 5982}], 
      Line3DBox[{5955, 7673, 8513, 7674, 8515, 7675, 8516, 7676, 8548, 7682, 
       8551, 7683, 8552, 5988, 8550, 5905, 8458, 8457, 7660, 8459, 5902, 8451,
        7656, 8452, 7657, 8504, 5944, 8498, 7670, 8499, 5943, 7669}], 
      Line3DBox[{5960, 5959, 8522, 7679, 8529, 5967, 8528, 5950, 8508, 5947, 
       8506, 7671, 8517, 7677, 8518, 5906, 8461, 8460, 7662, 8462, 7663, 8472,
        5914, 8471, 5901, 8450, 5899, 8449, 5896, 8446, 7653, 7654}], 
      Line3DBox[{5966, 5965, 8527, 5964, 8526, 5963, 8525, 5951, 8509, 7672, 
       8519, 7678, 8520, 5956, 8514, 5908, 8465, 8464, 5907, 8463, 7664, 8474,
        5915, 8473, 5895, 8445, 7652, 8447, 7655, 8456, 7659, 7661}], 
      Line3DBox[{5986, 5985, 8546, 7681, 8547, 5981, 8544, 5973, 8534, 5972, 
       8533, 7680, 8535, 5968, 8530, 5904, 8455, 8454, 5903, 8453, 7658, 8493,
        7667, 8497, 7668, 8501, 5945, 8500, 5921, 8478, 7665, 7666}], 
      Line3DBox[{5996, 5992, 8557, 5991, 8561, 5998, 8560, 5997, 8570, 6011, 
       8571, 6010, 8569, 6009, 8575, 8576, 6017, 8620, 6061, 8621, 6060, 8619,
        6059, 8636, 6071, 8630, 6070, 8631, 6072, 8633, 6077, 6076}], 
      Line3DBox[{6004, 6000, 8562, 5999, 8568, 6006, 8566, 6005, 8579, 6020, 
       8580, 6021, 8584, 6024, 8585, 8586, 6025, 8623, 6065, 8629, 6069, 8628,
        6058, 8618, 6057, 8634, 6078, 8635, 6079, 8637, 6080, 6081}], 
      Line3DBox[{6008, 6007, 8567, 5995, 8559, 5994, 8558, 5993, 8577, 6018, 
       8578, 6019, 8581, 6022, 8582, 8583, 6023, 8627, 6068, 8626, 6055, 8616,
        6054, 8617, 6056, 8638, 6082, 8639, 6074, 8632, 6073, 6075}], 
      Line3DBox[{6028, 6027, 8588, 6030, 8593, 6036, 8594, 6037, 8601, 6041, 
       8598, 6040, 8604, 6046, 8606, 8607, 6048, 8642, 6085, 8648, 6089, 8646,
        6088, 8647, 6090, 8657, 6094, 8662, 6099, 8660, 6098, 6101}], 
      Line3DBox[{6032, 6031, 8591, 6034, 8590, 6033, 8612, 6045, 8603, 6044, 
       8602, 6003, 8565, 6002, 8563, 8564, 6001, 8665, 6104, 8667, 6105, 8666,
        6103, 8664, 6067, 8625, 6066, 8624, 6064, 8622, 6063, 6062}], 
      Line3DBox[{6097, 6096, 8659, 7693, 8669, 6106, 8668, 6086, 8643, 7689, 
       8644, 7690, 8655, 7692, 8656, 6053, 8615, 8614, 6052, 8613, 6051, 8611,
        6050, 8610, 6039, 8596, 7688, 8597, 6038, 8595, 7686, 7687}], 
      Line3DBox[{6102, 6100, 8661, 7694, 8663, 6095, 8658, 6087, 8645, 7691, 
       8649, 6084, 8641, 6083, 8640, 6049, 8609, 8608, 6047, 8605, 6043, 8600,
        6042, 8599, 6035, 8592, 6026, 8587, 7684, 8589, 6029, 7685}], 
      Line3DBox[{6148, 6149, 6154, 9258, 7708, 6138, 8683, 6137, 7714, 6165, 
       8690, 6167, 7716, 6124, 8677, 6123, 7743, 6215, 8694, 6204, 7736, 6205,
        9279, 7740, 6212, 6229, 9283, 7751, 6221, 6222, 9308, 7878, 6385, 
       8741, 6386, 7825, 6393, 7824, 6394, 8751, 6408, 7829, 6407, 8749, 6413,
        7831, 6412, 8770, 6458, 7848, 6455, 8767, 6456, 7855, 6472, 8780, 
       6468, 7853, 6466, 8775, 6431, 6430}], 
      Line3DBox[{6150, 6151, 6155, 9259, 7709, 6147, 8687, 6146, 7717, 6166, 
       8689, 6160, 7710, 6126, 8678, 6125, 7744, 6216, 8695, 6206, 7737, 6207,
        9277, 7738, 6208, 6220, 9280, 7746, 6217, 6218, 9309, 7879, 6395, 
       8742, 6392, 7823, 6391, 7833, 6416, 8754, 6414, 7832, 6411, 8748, 6367,
        7811, 6366, 8771, 6454, 7846, 6453, 8777, 6470, 7854, 6469, 8778, 
       6465, 7852, 6429, 8756, 6426, 6425}], 
      Line3DBox[{6156, 6157, 6162, 9260, 7711, 6118, 8672, 6107, 7695, 6108, 
       8671, 6113, 7698, 6114, 8676, 6122, 7748, 6223, 8696, 6179, 7722, 6169,
        9262, 7718, 6168, 6175, 9265, 7721, 6174, 6199, 9314, 7884, 6362, 
       8732, 6363, 7813, 6369, 7812, 6359, 8731, 6360, 7818, 6380, 8740, 6384,
        7820, 6383, 8769, 6435, 7841, 6432, 8757, 6420, 7836, 6419, 8762, 
       6445, 7844, 6447, 8764, 6441, 6440}], 
      Line3DBox[{6161, 6159, 6158, 9261, 7712, 6120, 8674, 6109, 7696, 6110, 
       8670, 6111, 7697, 6112, 8675, 6121, 7745, 6219, 8697, 6224, 7747, 6180,
        9266, 7724, 6176, 6173, 9264, 7720, 6172, 6198, 9313, 7883, 6368, 
       8733, 6365, 7810, 6364, 7814, 6357, 8730, 6358, 7817, 6379, 8739, 6382,
        7819, 6381, 8768, 6428, 7839, 6427, 8758, 6434, 7840, 6433, 8761, 
       6444, 7843, 6446, 8763, 6439, 6438}], 
      Line3DBox[{6163, 6117, 6115, 9255, 7699, 6116, 8673, 6119, 7702, 6134, 
       8680, 6133, 7703, 6132, 8679, 6131, 7723, 6178, 8691, 6177, 7725, 6171,
        9263, 7719, 6170, 6197, 9275, 7734, 6200, 6201, 9312, 7882, 6370, 
       8734, 6356, 7808, 6355, 7809, 6361, 8738, 6373, 7815, 6371, 8735, 6372,
        7816, 6378, 8772, 6422, 7837, 6421, 8755, 6424, 7838, 6423, 8760, 
       6437, 7842, 6436, 8759, 6443, 6442}], 
      Line3DBox[{6243, 6244, 6248, 9287, 7757, 6240, 8700, 6239, 7762, 6268, 
       8710, 6254, 7758, 6255, 8726, 6318, 7786, 6317, 8723, 6304, 7777, 6305,
        9292, 7778, 6306, 6321, 9296, 7787, 6319, 6190, 9271, 7730, 6189, 
       8781, 6479, 7860, 6478, 7870, 6504, 8793, 6500, 7868, 6496, 8789, 6497,
        7910, 6565, 8817, 6533, 7895, 6532, 8811, 6562, 7906, 6561, 8813, 
       6557, 7904, 6400, 8743, 6397, 6396}], 
      Line3DBox[{6249, 6247, 6233, 9284, 7752, 6234, 8701, 6241, 7763, 6269, 
       8711, 6256, 7759, 6257, 8727, 6316, 7784, 6303, 8720, 6301, 7776, 6302,
        9293, 7779, 6307, 6322, 9297, 7788, 6320, 6192, 9272, 7731, 6191, 
       8782, 6481, 7861, 6480, 7871, 6505, 8794, 6501, 7869, 6498, 8790, 6499,
        7911, 6566, 8818, 6535, 7896, 6534, 8812, 6564, 7907, 6563, 8814, 
       6558, 7905, 6401, 8744, 6399, 6398}], 
      Line3DBox[{6286, 6284, 6282, 9291, 7767, 6278, 8713, 6276, 7772, 6298, 
       8719, 6300, 7774, 6253, 8703, 6251, 7796, 6338, 8729, 6340, 7798, 6342,
        9304, 7804, 6352, 6354, 9307, 7807, 6348, 6188, 9270, 7729, 6186, 
       8796, 6507, 7877, 6509, 7875, 6511, 8803, 6516, 7886, 6514, 8800, 6521,
        7888, 6519, 8822, 6572, 7909, 6568, 8820, 6570, 7916, 6577, 8829, 
       6579, 7913, 6582, 8832, 6545, 6543}], 
      Line3DBox[{6287, 6272, 6270, 9288, 7764, 6271, 8714, 6279, 7775, 6293, 
       8716, 6291, 7768, 6263, 8706, 6262, 7791, 6332, 8724, 6331, 7794, 6336,
        9305, 7805, 6349, 6346, 9300, 7799, 6345, 6182, 9267, 7726, 6181, 
       8797, 6512, 7892, 6525, 7891, 6526, 8804, 6522, 7889, 6487, 8784, 6485,
        7862, 6484, 8825, 6573, 7917, 6584, 8833, 6585, 7919, 6580, 8830, 
       6546, 7900, 6540, 8807, 6541, 6550}], 
      Line3DBox[{6288, 6274, 6273, 9289, 7765, 6280, 8717, 6292, 7769, 6290, 
       8715, 6289, 7770, 6265, 8707, 6264, 7792, 6333, 8725, 6334, 7793, 6335,
        9302, 7802, 6343, 6344, 9301, 7801, 6350, 6184, 9268, 7727, 6183, 
       8801, 6524, 7890, 6523, 7893, 6517, 8798, 6486, 7863, 6482, 8783, 6483,
        7865, 6489, 8826, 6574, 7914, 6583, 8834, 6586, 7918, 6575, 8827, 
       6539, 7899, 6538, 8808, 6548, 6547}], 
      Line3DBox[{6294, 6245, 6242, 9285, 7755, 6232, 8698, 6231, 7754, 6238, 
       8709, 6267, 7761, 6261, 8705, 6260, 7783, 6313, 8721, 6312, 7785, 6311,
        9295, 7781, 6310, 6330, 9299, 7790, 6329, 6196, 9274, 7733, 6195, 
       8785, 6475, 7858, 6473, 7857, 6474, 8792, 6503, 7873, 6495, 8788, 6493,
        7867, 6492, 8824, 6529, 7894, 6527, 8805, 6528, 7898, 6537, 8816, 
       6556, 7903, 6553, 8810, 6554, 6560}], 
      Line3DBox[{6296, 6295, 6246, 9286, 7756, 6236, 8699, 6235, 7753, 6237, 
       8708, 6266, 7760, 6259, 8704, 6258, 7800, 6315, 8722, 6314, 7782, 6309,
        9294, 7780, 6308, 6328, 9298, 7789, 6327, 6194, 9273, 7732, 6193, 
       8786, 6488, 7864, 6476, 7859, 6477, 8791, 6502, 7872, 6494, 8787, 6491,
        7866, 6490, 8823, 6549, 7901, 6530, 8806, 6531, 7897, 6536, 8815, 
       6555, 7902, 6551, 8809, 6552, 6559}], 
      Line3DBox[{6325, 6323, 6152, 9256, 7706, 6140, 8684, 6139, 7705, 6145, 
       8686, 6144, 7715, 6135, 8681, 6127, 7700, 6128, 8692, 6213, 7741, 6203,
        9276, 7735, 6202, 6209, 9282, 7750, 6227, 6228, 9310, 7880, 6404, 
       8745, 6402, 7826, 6387, 7821, 6388, 8752, 6417, 7835, 6418, 8753, 6410,
        7830, 6374, 8736, 6375, 7849, 6450, 8765, 6449, 7845, 6448, 8776, 
       6471, 7856, 6464, 8774, 6462, 6461}], 
      Line3DBox[{6326, 6324, 6153, 9257, 7707, 6142, 8685, 6141, 7704, 6143, 
       8688, 6164, 7713, 6136, 8682, 6129, 7701, 6130, 8693, 6214, 7742, 6211,
        9278, 7739, 6210, 6226, 9281, 7749, 6225, 6230, 9311, 7881, 6405, 
       8746, 6403, 7827, 6389, 7822, 6390, 8750, 6415, 7834, 6409, 8747, 6406,
        7828, 6376, 8737, 6377, 7850, 6451, 8766, 6452, 7847, 6457, 8779, 
       6463, 7851, 6459, 8773, 6460, 6467}], 
      Line3DBox[{6542, 6544, 8831, 6581, 7912, 6578, 8828, 6576, 7915, 6569, 
       8819, 6567, 7908, 6571, 8821, 6518, 7887, 6520, 8799, 6513, 7885, 6515,
        8802, 6510, 7874, 6508, 7876, 6506, 8795, 6185, 7728, 9269, 6187, 
       6347, 7806, 9306, 6353, 6351, 7803, 9303, 6341, 7797, 6339, 8728, 6337,
        7795, 6250, 8702, 6252, 7773, 6299, 8718, 6297, 7771, 6275, 8712, 
       6277, 7766, 9290, 6281, 6283, 6285}], 
      Line3DBox[{6589, 6590, 8839, 6587, 7920, 6588, 8836, 6596, 7931, 6614, 
       8845, 6613, 7929, 6616, 8851, 6629, 7946, 6658, 8863, 6661, 7950, 6664,
        8877, 7975, 6654, 6655, 8862, 7945, 6657, 7959, 6680, 8979, 6900, 
       8071, 6899, 8961, 6905, 8075, 6839, 8942, 6840, 8068, 6849, 8945, 6850,
        8049, 6852, 8968, 6909, 8078, 6931, 8993, 6929, 8077, 6914, 8971, 
       6915, 8082, 9319, 6942, 6939, 6938}], 
      Line3DBox[{6593, 6594, 8835, 6595, 7927, 6598, 8837, 6597, 7923, 6604, 
       8841, 6605, 7926, 6610, 8849, 6627, 7949, 6663, 8864, 6650, 7943, 6651,
        8878, 7976, 6682, 6678, 8867, 7957, 6677, 7960, 6681, 8977, 6906, 
       8074, 6896, 8959, 6897, 8067, 6847, 8944, 6848, 8048, 6851, 8947, 6855,
        8050, 6856, 8966, 6907, 8085, 6946, 8994, 6945, 8084, 6916, 8972, 
       6917, 8083, 9320, 6912, 6913, 6944}], 
      Line3DBox[{6602, 6603, 8840, 6591, 7921, 6592, 8838, 6601, 7930, 6612, 
       8844, 6611, 7928, 6615, 8850, 6628, 7948, 6662, 8876, 6659, 7947, 6660,
        8875, 7973, 6652, 6653, 8861, 7944, 6656, 7958, 6679, 8978, 6904, 
       8073, 6903, 8962, 6901, 8072, 6841, 8943, 6842, 8070, 6853, 8946, 6854,
        8069, 6898, 8967, 6908, 8076, 6926, 8990, 6930, 8079, 6910, 8969, 
       6911, 8086, 9321, 6940, 6941, 6943}], 
      Line3DBox[{6617, 6618, 8846, 6619, 7933, 6626, 8854, 6634, 7941, 6649, 
       8860, 6641, 7936, 6642, 8923, 6699, 7970, 6694, 8871, 6693, 7968, 6607,
        8842, 7924, 6606, 6690, 8870, 7963, 6689, 7977, 6707, 8975, 6920, 
       8131, 7033, 9029, 7034, 8129, 6887, 8956, 6888, 8063, 6893, 8957, 6890,
        8061, 6889, 8970, 6844, 8046, 6843, 8950, 6869, 8053, 6871, 8991, 
       6858, 8051, 9315, 6857, 6865, 6867}], 
      Line3DBox[{6625, 6621, 8847, 6620, 7932, 6622, 8855, 6635, 7935, 6640, 
       8859, 6636, 7934, 6637, 8924, 6700, 7971, 6696, 8872, 6695, 7969, 6609,
        8843, 7925, 6608, 6706, 8879, 7978, 6708, 7980, 6710, 8976, 6921, 
       8132, 7035, 9030, 7036, 8130, 6882, 8953, 6883, 8064, 6894, 8958, 6892,
        8062, 6891, 8964, 6846, 8047, 6845, 8951, 6870, 8054, 6872, 8992, 
       6860, 8052, 9316, 6859, 6866, 6868}], 
      Line3DBox[{6645, 6646, 8858, 6647, 7942, 6633, 8853, 6632, 7937, 6643, 
       8857, 6599, 7922, 6600, 8922, 6691, 7964, 6687, 8869, 6686, 7962, 6688,
        8874, 7967, 6698, 6703, 8880, 7979, 6701, 7972, 6702, 8974, 6919, 
       8126, 7032, 9032, 7038, 8128, 6902, 8960, 6895, 8066, 6886, 8955, 6881,
        8060, 6880, 8963, 6876, 8058, 6863, 8949, 6864, 8056, 6874, 8989, 
       6928, 8081, 9318, 6937, 6935, 6934}], 
      Line3DBox[{6648, 6624, 8848, 6623, 7940, 6631, 8852, 6630, 7939, 6639, 
       8856, 6638, 7938, 6644, 8921, 6683, 7961, 6684, 8868, 6685, 7965, 6692,
        8873, 7966, 6697, 6709, 8881, 7981, 6704, 7974, 6705, 8973, 6918, 
       8125, 7031, 9031, 7037, 8127, 6884, 8954, 6885, 8065, 6877, 8952, 6878,
        8059, 6879, 8965, 6875, 8057, 6861, 8948, 6862, 8055, 6873, 8988, 
       6927, 8080, 9317, 6936, 6933, 6932}], 
      Line3DBox[{6719, 6716, 8884, 6715, 7982, 6717, 8888, 6732, 7990, 6737, 
       8893, 6733, 7988, 6734, 8907, 6769, 8014, 6793, 8917, 6792, 8013, 6797,
        8939, 8039, 6804, 6805, 8925, 8017, 6807, 8021, 6809, 8986, 6924, 
       8122, 7012, 9014, 7013, 8121, 6953, 8995, 6954, 8092, 6963, 9001, 6960,
        8091, 6959, 9035, 7041, 8133, 7048, 9043, 7065, 8141, 7028, 9028, 
       7029, 8136, 9328, 7058, 7062, 7063}], 
      Line3DBox[{6720, 6712, 8882, 6711, 7983, 6718, 8886, 6728, 7991, 6738, 
       8894, 6735, 7989, 6736, 8908, 6770, 8012, 6796, 8920, 6785, 8004, 6786,
        8918, 8010, 6794, 6806, 8926, 8018, 6808, 8022, 6810, 8987, 6925, 
       8120, 7009, 9013, 7010, 8116, 6955, 8996, 6956, 8090, 6958, 9000, 6964,
        8094, 6966, 9036, 7042, 8140, 7066, 9044, 7064, 8139, 7017, 9022, 
       7018, 8138, 9329, 7024, 7025, 7061}], 
      Line3DBox[{6743, 6744, 8891, 6747, 7994, 6730, 8887, 6729, 7992, 6739, 
       8889, 6741, 8030, 6766, 8905, 6765, 8007, 6788, 8915, 6787, 8005, 6789,
        8919, 8011, 6795, 6802, 8927, 8019, 6798, 8015, 6799, 8984, 6922, 
       8115, 7011, 9015, 7014, 8119, 6983, 9004, 6965, 8093, 6957, 8997, 6952,
        8089, 6951, 9033, 7039, 8144, 7059, 9042, 7060, 8143, 7019, 9023, 
       7020, 8124, 9325, 7026, 7023, 7022}], 
      Line3DBox[{6745, 6746, 8892, 6748, 7995, 6714, 8883, 6713, 7993, 6740, 
       8890, 6742, 8031, 6768, 8906, 6767, 8008, 6784, 8914, 6783, 8006, 6790,
        8916, 8009, 6791, 6803, 8928, 8020, 6800, 8016, 6801, 8985, 6923, 
       8118, 6961, 8999, 6962, 8117, 6984, 9005, 6950, 8088, 6949, 8998, 6948,
        8087, 6947, 9034, 7040, 8142, 7056, 9041, 7057, 8137, 7015, 9021, 
       7016, 8123, 9324, 7021, 7027, 7030}], 
      Line3DBox[{6778, 6756, 8898, 6754, 8001, 6752, 8896, 6750, 7999, 6773, 
       8909, 6771, 7997, 6763, 8903, 6761, 8023, 6811, 8933, 6816, 8026, 6818,
        8931, 8028, 6821, 6837, 8940, 8044, 6830, 8035, 6832, 8982, 6671, 
       7953, 6669, 8865, 6667, 7951, 6665, 9016, 7007, 8113, 6991, 9008, 6993,
        8111, 7005, 9026, 6981, 8101, 6979, 9006, 6985, 8103, 6987, 9038, 
       6977, 8099, 9322, 6975, 7050, 7052}], 
      Line3DBox[{6780, 6781, 8913, 6775, 7996, 6758, 8900, 6721, 7984, 6722, 
       8885, 6725, 7987, 6731, 8902, 6760, 8042, 6814, 8929, 6813, 8041, 6826,
        8936, 8033, 6825, 6828, 8937, 8034, 6827, 8038, 6835, 8981, 6676, 
       7956, 6675, 9012, 7002, 8110, 7004, 9020, 6999, 8107, 6998, 9019, 6996,
        8106, 6995, 9025, 6974, 8098, 6973, 9003, 6970, 8096, 6969, 9037, 
       7047, 8135, 9327, 7045, 7046, 7055}], 
      Line3DBox[{6782, 6777, 8912, 6776, 8003, 6749, 8895, 6726, 7986, 6727, 
       8911, 6723, 7985, 6724, 8901, 6759, 8025, 6815, 8930, 6820, 8043, 6824,
        8935, 8032, 6823, 6829, 8938, 8037, 6834, 8040, 6836, 8980, 6674, 
       7955, 6673, 9011, 7001, 8109, 7003, 9018, 6990, 8105, 6989, 9010, 6997,
        8108, 7000, 9024, 6972, 8097, 6971, 9002, 6968, 8095, 6967, 9040, 
       7049, 8134, 9326, 7043, 7044, 7054}], 
      Line3DBox[{7053, 7051, 6976, 9323, 8100, 6978, 9039, 6988, 8104, 6986, 
       9007, 6980, 8102, 6982, 9027, 7006, 8112, 6994, 9009, 6992, 8114, 7008,
        9017, 6666, 7952, 6668, 8866, 6670, 7954, 6672, 8983, 6833, 8036, 
       6831, 8045, 8941, 6838, 6822, 8029, 8932, 6819, 8027, 6817, 8934, 6812,
        8024, 6762, 8904, 6764, 7998, 6772, 8910, 6774, 8000, 6751, 8897, 
       6753, 8002, 6755, 8899, 6757, 6779}], 
      Line3DBox[{7067, 7068, 8145, 7069, 8148, 7076, 8149, 7077, 8166, 7102, 
       8168, 8167, 7103, 8175, 7108, 8176, 7109, 8265, 7202, 8266, 7203, 8271,
        7208, 8272, 7209, 8293, 7230, 8294, 7231, 8299, 7236, 7237}], 
      Line3DBox[{7070, 7071, 8146, 7074, 8150, 7078, 8152, 7080, 8169, 7104, 
       8172, 8171, 7106, 8177, 7110, 8179, 7112, 8267, 7204, 8269, 7206, 8273,
        7210, 8275, 7212, 8295, 7232, 8297, 7234, 8300, 7238, 7240}], 
      Line3DBox[{7072, 7073, 8147, 7075, 8151, 7079, 8153, 7081, 8170, 7105, 
       8174, 8173, 7107, 8178, 7111, 8180, 7113, 8268, 7205, 8270, 7207, 8274,
        7211, 8276, 7213, 8296, 7233, 8298, 7235, 8301, 7239, 7241}], 
      Line3DBox[{7082, 7083, 8154, 7086, 8158, 7094, 8160, 7096, 8181, 7114, 
       8184, 8183, 7116, 8193, 7122, 8195, 7124, 8277, 7214, 8279, 7216, 8285,
        7222, 8287, 7224, 8302, 7242, 8304, 7244, 8310, 7250, 7252}], 
      Line3DBox[{7084, 7085, 8155, 7087, 8159, 7095, 8161, 7097, 8182, 7115, 
       8186, 8185, 7117, 8194, 7123, 8196, 7125, 8278, 7215, 8280, 7217, 8286,
        7223, 8288, 7225, 8303, 7243, 8305, 7245, 8311, 7251, 7253}], 
      Line3DBox[{7088, 7089, 8156, 7092, 8162, 7098, 8164, 7100, 8187, 7118, 
       8190, 8189, 7120, 8197, 7126, 8199, 7128, 8281, 7218, 8283, 7220, 8289,
        7226, 8291, 7228, 8306, 7246, 8308, 7248, 8312, 7254, 7256}], 
      Line3DBox[{7090, 7091, 8157, 7093, 8163, 7099, 8165, 7101, 8188, 7119, 
       8192, 8191, 7121, 8198, 7127, 8200, 7129, 8282, 7219, 8284, 7221, 8290,
        7227, 8292, 7229, 8307, 7247, 8309, 7249, 8313, 7255, 7257}], 
      Line3DBox[{7130, 7131, 8201, 7134, 8205, 7142, 8207, 7144, 8225, 7170, 
       8228, 8227, 7172, 8237, 7178, 8239, 7180, 8314, 7258, 8316, 7260, 8322,
        7266, 8324, 7268, 8346, 7290, 8348, 7292, 8354, 7298, 7300}], 
      Line3DBox[{7132, 7133, 8202, 7135, 8206, 7143, 8208, 7145, 8226, 7171, 
       8230, 8229, 7173, 8238, 7179, 8240, 7181, 8315, 7259, 8317, 7261, 8323,
        7267, 8325, 7269, 8347, 7291, 8349, 7293, 8355, 7299, 7301}], 
      Line3DBox[{7136, 7137, 8203, 7140, 8209, 7146, 8211, 7148, 8231, 7174, 
       8234, 8233, 7176, 8241, 7182, 8243, 7184, 8318, 7262, 8320, 7264, 8326,
        7270, 8328, 7272, 8350, 7294, 8352, 7296, 8356, 7302, 7304}], 
      Line3DBox[{7138, 7139, 8204, 7141, 8210, 7147, 8212, 7149, 8232, 7175, 
       8236, 8235, 7177, 8242, 7183, 8244, 7185, 8319, 7263, 8321, 7265, 8327,
        7271, 8329, 7273, 8351, 7295, 8353, 7297, 8357, 7303, 7305}], 
      Line3DBox[{7150, 7151, 8213, 7154, 8217, 7162, 8219, 7164, 8245, 7186, 
       8248, 8247, 7188, 8257, 7194, 8259, 7196, 8330, 7274, 8332, 7276, 8338,
        7282, 8340, 7284, 8358, 7306, 8360, 7308, 8366, 7314, 7316}], 
      Line3DBox[{7152, 7153, 8214, 7155, 8218, 7163, 8220, 7165, 8246, 7187, 
       8250, 8249, 7189, 8258, 7195, 8260, 7197, 8331, 7275, 8333, 7277, 8339,
        7283, 8341, 7285, 8359, 7307, 8361, 7309, 8367, 7315, 7317}], 
      Line3DBox[{7156, 7158, 8215, 7160, 8221, 7166, 8223, 7168, 8251, 7190, 
       8255, 8253, 7192, 8261, 7198, 8263, 7200, 8334, 7278, 8336, 7280, 8342,
        7286, 8344, 7288, 8362, 7310, 8364, 7312, 8368, 7318, 7320}], 
      Line3DBox[{7321, 7319, 8369, 7313, 8365, 7311, 8363, 7289, 8345, 7287, 
       8343, 7281, 8337, 7279, 8335, 7201, 8264, 7199, 8262, 7193, 8254, 8256,
        7191, 8252, 7169, 8224, 7167, 8222, 7161, 8216, 7159, 7157}], 
      Line3DBox[{7380, 8376, 7379, 7608, 9214, 7400, 9086, 7399, 9087, 7342, 
       9334, 8374, 7341, 7404, 9091, 7348, 9056, 7346, 9052, 9053, 7345, 8398,
        7456, 9182, 7556, 9183, 7553, 9177, 7549, 8423, 7545, 9173, 7520, 
       9154, 7519, 9152, 7502, 9148, 7501, 8417, 7513, 7517}], 
      Line3DBox[{7396, 8377, 7395, 7607, 9213, 7393, 9084, 7392, 9088, 7340, 
       9333, 8373, 7339, 7403, 9090, 7349, 9057, 7344, 9050, 9051, 7343, 8401,
        7459, 9179, 7555, 9184, 7552, 9176, 7551, 8424, 7544, 9172, 7521, 
       9155, 7518, 9151, 7500, 9147, 7499, 8416, 7510, 7516}], 
      Line3DBox[{7398, 8378, 7397, 7604, 9215, 7394, 9085, 7391, 9083, 7390, 
       9336, 8379, 7402, 7401, 9089, 7338, 9049, 7337, 9054, 9055, 7347, 8402,
        7460, 9180, 7554, 9178, 7547, 9174, 7546, 8422, 7548, 9181, 7515, 
       9150, 7514, 9153, 7504, 9149, 7503, 8415, 7505, 7565}], 
      Line3DBox[{7408, 8380, 7381, 7378, 9079, 7377, 9094, 7407, 9095, 7325, 
       9331, 8371, 7324, 7326, 9045, 7327, 9070, 7367, 9068, 9069, 7366, 8399,
        7457, 9191, 7570, 9192, 7571, 9195, 7564, 8426, 7563, 9194, 7538, 
       9164, 7536, 9163, 7535, 9167, 7527, 8420, 7506, 7507}], 
      Line3DBox[{7409, 8381, 7389, 7384, 9080, 7383, 9093, 7406, 9098, 7368, 
       9335, 8375, 7336, 7331, 9047, 7330, 9077, 7370, 9072, 9073, 7369, 8392,
        7445, 9190, 7569, 9199, 7567, 9188, 7566, 8427, 7557, 9185, 7543, 
       9171, 7540, 9166, 7523, 9156, 7522, 8421, 7532, 7537}], 
      Line3DBox[{7410, 8382, 7386, 7387, 9082, 7388, 9092, 7405, 9097, 7333, 
       9332, 8372, 7332, 7334, 9048, 7335, 9074, 7373, 9075, 9076, 7374, 8390,
        7443, 9189, 7568, 9197, 7559, 9186, 7558, 8428, 7562, 9187, 7542, 
       9169, 7541, 9170, 7526, 9157, 7524, 8418, 7508, 7509}], 
      Line3DBox[{7411, 8383, 7382, 7376, 9078, 7375, 9081, 7385, 9096, 7323, 
       9330, 8370, 7322, 7329, 9046, 7328, 9071, 7365, 9066, 9067, 7364, 8400,
        7458, 9175, 7550, 9193, 7572, 9196, 7561, 8425, 7560, 9198, 7539, 
       9165, 7534, 9162, 7533, 9168, 7525, 8419, 7511, 7512}], 
      Line3DBox[{7476, 8403, 7372, 7355, 9059, 7354, 9065, 7360, 9061, 7359, 
       9341, 8407, 7488, 7496, 9146, 7491, 9140, 7432, 9108, 9109, 7431, 8391,
        7444, 9161, 7529, 9158, 7528, 9242, 7634, 8439, 7631, 9235, 7632, 
       9245, 7596, 9206, 7595, 9212, 7601, 8431, 7600, 7638}], 
      Line3DBox[{7482, 8404, 7371, 7358, 9060, 7357, 9064, 7362, 9062, 7361, 
       9342, 8408, 7490, 7495, 9145, 7492, 9141, 7435, 9111, 9112, 7434, 8388,
        7441, 9160, 7531, 9159, 7530, 9241, 7636, 8440, 7635, 9240, 7637, 
       9246, 7599, 9208, 7598, 9211, 7603, 8432, 7602, 7645}], 
      Line3DBox[{7483, 8405, 7350, 7351, 9063, 7363, 9137, 7475, 9134, 7474, 
       9343, 8409, 7485, 7486, 9142, 7428, 9105, 7427, 9115, 9116, 7440, 8395,
        7450, 9238, 7630, 9234, 7622, 9226, 7621, 8438, 7620, 9225, 7592, 
       9204, 7591, 9210, 7578, 9200, 7577, 8429, 7579, 7646}], 
      Line3DBox[{7484, 8406, 7356, 7353, 9058, 7352, 9135, 7477, 9136, 7478, 
       9344, 8410, 7489, 7487, 9139, 7433, 9110, 7430, 9106, 9107, 7429, 8389,
        7442, 9236, 7633, 9237, 7623, 9227, 7619, 8437, 7618, 9239, 7597, 
       9207, 7594, 9205, 7593, 9209, 7581, 8430, 7580, 7647}], 
      Line3DBox[{7493, 8411, 7479, 7480, 9138, 7473, 9131, 7472, 9132, 7438, 
       9340, 8387, 7437, 7436, 9113, 7426, 9104, 7423, 9102, 9103, 7422, 8397,
        7453, 9231, 7628, 9232, 7629, 9253, 7651, 8444, 7648, 9247, 7590, 
       9203, 7585, 9202, 7584, 9223, 7617, 8436, 7573, 7574}], 
      Line3DBox[{7494, 8412, 7481, 7466, 9127, 7465, 9133, 7469, 9128, 7417, 
       9337, 8384, 7416, 7439, 9114, 7421, 9101, 7420, 9121, 9122, 7452, 8396,
        7451, 9233, 7625, 9228, 7624, 9254, 7650, 8443, 7649, 9248, 7583, 
       9201, 7582, 9218, 7613, 9224, 7616, 8435, 7575, 7576}], 
      Line3DBox[{7498, 8414, 7468, 7464, 9126, 7462, 9130, 7471, 9144, 7425, 
       9339, 8386, 7419, 7415, 9100, 7413, 9124, 7455, 9118, 9120, 7449, 8394,
        7447, 9230, 7627, 9250, 7642, 9244, 7640, 8442, 7644, 9252, 7615, 
       9220, 7612, 9217, 7610, 9222, 7606, 8434, 7587, 7589}], 
      Line3DBox[{7588, 7586, 8433, 7605, 9221, 7609, 9216, 7611, 9219, 7614, 
       9251, 7643, 8441, 7639, 9243, 7641, 9249, 7626, 9229, 7446, 8393, 7448,
        9119, 9117, 7454, 9123, 7412, 9099, 7414, 7418, 8385, 9338, 7424, 
       9143, 7470, 9129, 7461, 9125, 7463, 7467, 8413, 7497}]}}},
   VertexNormals->CompressedData["
1:eJzt3UFqwlAQANDQLj2Cbgq9RRfZuu4RCi3ueoT2JKU38Ai5gCJ4iG7tESpq
A/nNR6GGjPHNZvhv/j4wYebfPb0+Pt8URfF+XxS327x4eHv5+Pwqi0Ms9+eK
c84555xzzjnnnHPOOeecc84555xzzjnnnHPOOeec80D+p84555xzzjnnnHPO
Oeecc84555xzzjnnnHPOOeecc855BG+P74pzzjnnnHPOOeecc84555zzIXny
v6y+xznnnHPOOeecc84555xzzjnnnHPOOeecc84555xzznkEb0a8+RzOOeec
c84555xzzjnnnHPOz+GT+Xo6G23K8S6vSs4555xzzjnnnHPOOeecc84555xz
zi/ZD3Pj9XnZnCfnnHPOOeecc84555xzznlgT3KuzjnnnHPOOeecc84555zz
gN4e/e/d5JxzzjnnnHPOOeecc875cU/6//U9zjnnnHPOOeecc84555zH92bE
+w/BOeecc84555xzzjnnnPO8R3sXmHPOOefdebR3gjjnnHPOOeecc84555xz
zjnnnHPOOeecc8455zznSc7VOeecc84555xzzjnn/OK8PfrfR8U555xzzjnn
nHPOOeec8+Oe9P/re5xzzjnnnHPOOeecc873Ee39Ps4555xzzjnnnHPOOef8
FE/63pxfg1ecR/Jo34W+PNp7AZxzzjnnnHPOOeecc961F60Rb+8Q55xzzjnn
nHPOOeecn8uj9Wk555xzzjnnnHPOOeene5Jzdc4555xzzjnnnHPOOeecc845
55xzzjnnnHPOOY/mFeecc84555xzzjnnnHPOOeecc84555xzzjnnnEf1ZsR7
f45zzjnnnHPOOeecc84553mfzNfT2WhTjnd5VXLOOeecc84555xzzjnnnHPO
OeeX4Iv9nFt9/p1745xfjyc5V+ecc84555xzzjnnnPOhesU555xzzjnnnHPO
OedD92b0v7eNc84555xzzjnnnHPOu/Zo+z0455xze6U455xzzjnnnHPOOee8
O09yrs4555xzzjnnnPP/e8U555xzzjnnnHPOOe/Po80zcs4555xzzjnnnHN+
zZ708TjnnMf0infj0b7LQ/Uf5Q7TWg==
    "]],
  Axes->True,
  AxesLabel->{
    FormBox["x", TraditionalForm], 
    FormBox["y", TraditionalForm], 
    FormBox["z", TraditionalForm]},
  BoxRatios->{1, 1, 1},
  DisplayFunction->Identity,
  FaceGridsStyle->Automatic,
  ImageSize->{360., 388.82606482073544`},
  Method->{"DefaultBoundaryStyle" -> Directive[
      GrayLevel[0.3]]},
  PlotRange->{{-3, 3}, {-3, 3}, {-3, 3}},
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02], 
    Scaled[0.02]},
  Ticks->{Automatic, Automatic, Automatic},
  ViewPoint->{0.09005434082888664, 1.6540118573962654`, 2.9506160358966476`},
  ViewVertical->{-0.0274841513809295, 0.9920834117160925, 
   0.12253622166783332`}]], "Output",
 CellChangeTimes->{
  3.6353107711206417`*^9, {3.635310804936356*^9, 3.635310814873706*^9}, 
   3.635319795817243*^9, 3.635320309465983*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**",
     "**", "**", "**"}], "*", "Example", " ", 
   RowBox[{"7", "**", "**", "**"}], "*", 
   RowBox[{
   "**", "**", "**", "**", "**", "**", "**", "**", "**", "**", "**"}]}], 
  "*****)"}]], "Input",
 CellChangeTimes->{3.64275965813741*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContourPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"x1", "^", "2"}], "-", 
       RowBox[{"4", "x1"}], "+", "4"}], "\[Equal]", "x2"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x1"}], "+", "3"}], "\[Equal]", "x2"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"3", 
        SuperscriptBox["x1", "2"]}], "+", 
       SuperscriptBox["x2", "2"]}], "\[Equal]", "2"}], ",", 
     RowBox[{"x2", "==", "0"}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       RowBox[{"2", " ", "x1"}], "+", 
       SuperscriptBox["x1", "2"], "+", 
       FractionBox[
        SuperscriptBox["x2", "2"], "2"]}], "\[Equal]", "0"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x1", ",", 
     RowBox[{"-", "2"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x2", ",", 
     RowBox[{"-", "4"}], ",", "4"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.64275983563061*^9, 3.642759883124455*^9}, {
   3.642760087003202*^9, 3.642760095723734*^9}, {3.642760147812027*^9, 
   3.642760151444282*^9}, {3.642760207533539*^9, 3.6427602228211737`*^9}, 
   3.6427605184771214`*^9, {3.6427605633651333`*^9, 3.642760588954608*^9}, {
   3.642760861701675*^9, 3.642760888884233*^9}, {3.642761555012307*^9, 
   3.642761559612805*^9}, {3.6427616664850283`*^9, 3.642761717389049*^9}, {
   3.642761794722628*^9, 3.6427618020518436`*^9}, {3.6427619691745653`*^9, 
   3.6427619790764923`*^9}, {3.64280482261924*^9, 3.642804824195307*^9}, {
   3.64280486997272*^9, 3.642804909276389*^9}, {3.642805016316476*^9, 
   3.6428050178205*^9}, 3.6428072925475607`*^9, 3.642807341731995*^9, 
   3.64280785929517*^9, {3.642807981327491*^9, 3.642808005750065*^9}, 
   3.642808128438192*^9, {3.64280822558237*^9, 3.642808236396019*^9}, {
   3.642808281462538*^9, 3.6428083189165487`*^9}, {3.642808366565915*^9, 
   3.6428084064854527`*^9}, {3.6428126702629843`*^9, 3.642812693230624*^9}, 
   3.6428139348235073`*^9, {3.642814706975569*^9, 3.64281470878474*^9}, 
   3.65132376226928*^9}],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxdWQlYjNsfnqZm2hRl79qTbFcuQlx+R4Sksm8XyZJ9C+EKZb3WFElJhihZ
IilFnBEtKpW0aW/aU1pnpPXffOd883/65pmnevu2c37L+77nfEM37l2yhc/j
8Zw6fzC/XQyWfnEE4DGfHqj/8JyH2Rs9If2rzsoIk+5I87axa6X+Q0g2+aJk
FKyNekxYHJc/OBh2ZYfuzg7VQjMlu0/d4IWBWbpSQlNvLeQ93NxtuHkkFPeK
8D7loYkSdo62Gfo5Ej5qLF5x+l9NtFzDt+ddpY+QKb98tyaaGOyfaXv9I9x8
FPfmxUJNZLDI8Xpj7GdQPe7geKVYHeUcOdQ8Yf0XmOsmv7E6sj7qJ7KwT4ay
2yPdbRaroVsOrQa7J36DKe1uoZ5DVdGcXdYG3bO/wSv57bOFaHPgWZ0KnVQQ
W0Gp+IMQjZIPzy0VnD2W1tpfFKKmJHvjzMQMsPAw+KdjigDd/TigdPz57zCM
OU8FQabFH43e2RCbpTr6WZAy2rzt5pj+h/PgRfcx+uEefPTbd3Bb+bx8uMbM
m49qFs1ynXI6H/CkFc+NxvMRn4lrAbR3yD9K6PWzz8Gq0YVQ8GRRoHcID+FM
XcfbWAKtzPEOCGfGLQGJPH4ZHXBK+QEqSC+CjKrabGWndtjHxL0Ewjqju7S2
BSb2cgjA0hJAxSaaqqIWGPC29/GcIaWQwcS3Bfp0zypPiC2FqobXZi5uzdA0
O148a1Q5DLoaZnM5uQlW/ai69Ci9Al4yz5VBr5M/XNbur4TD/t8LLunIII+5
zw+YLDDyLyhphNNLjVP4iVVwZLp1XfPGBvAQ+GrZl1fDVWb+9VATEbIETGsg
72it5/yYWhjBxLEWyu011lt9qAbf0H8s88trwf2YgWvcqSqYkbk35K9JdfCN
PofEqx6a5NE4WQ7eT3LuHEf1wI9OdkwIKAPn5gr/uyfqIZAZbynkMtc1QBVz
/yLwdT/zKjegAZKXuklE6kXwydo6x7uqAS4y45NAGHNdIzjJ86+RDw6zii53
GyOFYcZCvvnOXEi+9dem6MtSiGfumw1Xj0+tQw1S+Ls2SVU4/zvcYO4jgwKm
vjMgqP3wvA8fZbDzlrZlzuo0Ov5fZPyQCke+mvVdd/AXnGKuS4GmUW5Ltb1/
wUln1zN37nyl+fwFvM7Rx4/6CkuCH61OHdsElS/+XTXjaSIkrd6X7Hy8CW50
HxWSMyUBLJg++A3JJfIBxMCZJccuLWz/Dfa077Q367+2sW2GnhuOeQ4PxDT+
zYDktz/yDtQ/l74vV22B6/0GDxiSFAaVvwTDz9u1gOPc9avsTELo+FspH7wA
xzufDl5xbIVnxWfX9K14BJubh/r97tsGdX0vH8owuEfrow2c5OVo7wVx3bbE
9vZrgzPXln9ef/kmjBv5dvz9hHZA2n9/UX96mNZ3O/BU5PV0EAbuu8OPKGsH
kfGOyUdfHICJBx8ajxrOQzzPKSalysawgJlvJ+bJz58EeiF8S55BJ54hE0bz
JsOtZ6LA4Yk8tMvD7pPfrLM0v53HS+XxOQ9a7/xE0ioeygy3MAvodhk2h85+
Gr5dCenq3VuyyURE46OEeAfk9eMLouPLRKbpSmjt+PllHuOfQMvduZ/+a1ZC
Xntve53d/xyu0z5HTD+8gjZ1/eXhznyUZbfZZvmscJiZs7ukqJmPeK5mA5dH
f6BxVEbkdySMMHoXUq6kjHxEv26Z9YuEyGKNjfYCZcTmbw9TD8qI1Fc8/Bng
1f7ipzK6ZO2RVd2aCDMf8Fz5c1QQW085TPxV0IsCeUF8A0Pde/m3Y1WQWsMh
+9mSdBiq6n/z7y8q6NqHEctTu2fQeAqQiMlXFkSeVD+zfroAsfUurUy+cclN
gEZmXZH66ObTeArQ+CMmAiPDQnCp1A3uoyFEbD8lbZm8asgiISo0ce91rbYI
DJh4ClE5M/4S4KVId6l38i7br8+0bAds5qsiLztThxmicmCGY66KmH68WAlH
/QNLCuxUEcsHJxz2JgQ8VUVHxRpY53Q1EJpURUx/ddTQ+KrR+NZyMI/XRs9n
gFPW37V1g2rqBqkiYeTQAZFDIxTjfcGMLxryi2bkFc0QIjXmeALtT4Ei3mz8
yPnp8D7mWETMMRXUkzk/BzQ+ju/2cXxnPsqO+pQdzVPkcz5zXSE8C/d6Eu6l
jKz6uy/u715I+0dZEU/vJ/IT+Mh1sfyEEkW9vaLxu3Qn88KdTCWUckH+Rznl
AyVFvP51+XXE5RcP9WHGU6XohyHMPKug3znbzi8P3WfG9xO2O/fZ5tyHh9Y0
P7RpflhD+5+niC/br/OY59RBUOmOwNId7WDNjL8O7Jn5tSn4/1rco8txj1ph
n/HKA8YrGxR8QvSvAfYEym/QDG7M/KRgRfmM1R+W30IonkvxG4rHOGw0dNj4
C9KY+TdBBP3/HHoey8/En/wGtTUiwRqRFJrk07NpVvA/yUcLED/QqNDLUnn6
8xpAj4lfq0Jf9JnzWiFK/u8B9TBdflpRG2xgAloHIiae7Qq9y2Ku6wBfgXwA
tbCOiW8HqNA6ZfWe/82oLcWoGkDzFdJ8xUOs3s6neX0vL5cnFbCIibcSEtM6
YP3GMXk4DEvBVv7LgY9Yf8AcduOjir+TGv5OKoJoeVl2U0ZTR/tOGO0rAXsm
P8oKf0LSroIqmPrPg9Ozp56ZPVUFNVBeYP3QxgPyCzPgBpM/gcJPMY/dLUCP
aZ/spH2Tw/8zufMLJPwCdJj5/xdgLhsuRBGU91i/9ojiEIpZPxlK8VaKwyk+
qF3YQ7tQBNHyNoxQRbuY4/cx4RU1JJkW1HN6UDDOYOpFDdmQ6zHrJ1OYG8dj
5nah6ihKno62FPybGbAGOrhc/knDgY/lHw1E6uw7JvnRRFby8hJkYXV5+pAm
+kgGill/u1Pt/D618wX4D6aeuiGSNwkm+emGnjOXFeOx8ijxtViexKy/bjgi
b+gyzGSlSAuRPirDJF/ayNFHXngV+C5Tf9rIRD7dnj+wVdWnzq82+k7qCZNh
aSNy32pM8tUdnajw6Pz+xEx6Hnan9VCL2fXAnsXuL9bxKrGv7pzU+T7h+GDO
zeWWSRV4WXQCz7AtFvNs3wvdDlfg+yTvWNLxqboJKrDjyst1WubpeEX/Ip9V
ueX4B40LO/72e0EzJ6UXYtXAbwkLqsrwoXvbkPcoCbaPE+3IKC7DXjROy7pH
LXJNLsOPH2blqrlL8NRRwUWmamX4jz7NNZrWJfhJzOQYa+dS/J7GTXr0VsRL
1VKcOrclLXVuOSa8VYJ99DKn+52rxMMnTn+9pqoYzwlbv+pTZ5y6eWXOXRlZ
jItonFKSmqURIUVYr/VCL52Qajx21F2rOP8iPNstIEWWWI3rn5Z0s3GQYNrH
eP7OFXMO2kpw3M6MRvuetZjNrz3fcB/fsBZr95tqnFpfgFucpgcumFKHSZ0X
4KT7douD59dhSebq0M8L8vHpaHMbzwH1mPBgHhZpWJ/1N63HDm+fDrBOycNB
s5XfnjCrx9t6HB7hGZ2HbxK+xS1MPLOxZXF7um7/BnwhA51wdcrGJd/fZL2b
1oCd2keH+eIsnE94DLP1O3tg6qyBqQ34jtH0LbKmDNz/v0Sj/XqN+KufwHlw
VjrW6v3vGItVjfgK85x0rK9c0Rbu0IhfZHfbOzEiDY8kvImrrs9th7GpeNMe
646TeY04nXnON6wzBDnxlKT4dtuIInOvFLyQea4Uuy63iUkem4Jr9IK2nJws
xXX4a8Eer694YL5yxARLKSY6lYzNKtZOnn1QikMnpWks7ZeMC3b53NQ9J8UF
RjGJUXO+4P1MAUvxTY8oE1lhPN6ittHyj0QpZvvZOjfVMjdVigNtIj863Y7D
R84BlBZIcZD/m5O/N8VgS5VBMwO7yfBm5j5RWO2Ik+qRITLsITqVdbjbRzyp
bM375SDDTSKIVHobiTU3XrvxyFSGq5l4Y/zoeJb/8TUyrNP6x6CJ19/iOuET
4YgdMqzLjP8VNvopGffzlAyn1qsZTv3ujxPVBRdMbsgwy093Pnt6f/aU4fJV
eVHDT3rh88uOT2rwkuGxjCE5BXXdO2q735Xh/66KWsqbH4Ke2+GpL9xlmP9a
Pr8nMPaD7tgPbjI8xO+NqC7mBeTB1RM/Lsuw5JH6kp+3QsD9gsGgx04yvJaJ
ezhYyeNxUIYzSkqPHot6By3tMe01m2XY/MC/Z9wfYtB/aC/+Z50Ms3y7YrNZ
51eGVUKVLD/d+QTnmrSvjxsnw5nCS5uWtURB76ytDeMHybAG0wexID97hYoM
G25JUYqd9BkORzxTvdMoxUSv4og+5ErxlzSNVWM2fAE2f4+XDrP0vP8Fel/p
mJj4UopZfQgq7mtxIkiKD6zsm3o+/ws8jEyvDwuU4gW6SdLhNcmdOr8mo8lO
ion/+AqO6Vp+sfOkuGfupx/mnt+gTevEHom0EbP6dC/iXL1eXCNGen6nfepT
Id6bF/Q1rBEvPPC0apJfGrD1vDQ3/8yiZ5mAopWqrlQ30D7LAsfKKMfKsw1Y
7H1zHBqbA1nnE5M3ajTgA/bPT9g/zwO2H9/X6aSd25cP886eLhN3r8esvuYy
nzp85s3bI7dnFMKuWKPm3u21ODFflB1iL2F9AVa5eHhMoJ8E9JrHLvN6UoPZ
/YAjcnmbV4P1NH5OaG8ogpcLVqn5jKvGaXY903IjioHlrwVP7w7SHFECWoLn
o5Q7+Y71A0dNvd3v9qjAUfHtWy+cLgWWL+MWmsUvmFYGkX7RjeohxTgtRKji
va4MzsyW2ginFOP9hYHvzfPKgOVjQyZO5WDFrCfzcIhdxuT45HJYKFng+M44
B7fNGbNziKQcWL4Pf7zQQYlfAQv7laYZq2XhTKegnyK7Cpg5o6DEtzYVf791
pfNbAax+bMk0CxrxuQJOvwo0wQkJeLnQ7Kh1RgX46X7oY7k9Dl/7a2PIv40V
8JLqeLeFYdP79KmEt5dKP2RtCsZrIGLxiH6VAH8elQh7BWH97gHtUZ3HiZ4l
R7DH34xljoMWvR6R68GV3p9dj62gz99Fng92dHzTyfggm46fXR98p/MbTuYH
EXT+g8n8gWdG4sOut8Jo/CaS+AEbXwsSXzhE48+uD3JofraR/MAXmr/XJH8Q
R/PLrrc4+QcrWh8qpD7A+LT23fVRxYr9F+Kfi2HU3ssb7p+sgkG03gJIvUGq
pGzay6AisCM+QrFfVVrse93FqgbUaf3qkvoF3w5N8zQHCbDrCeJvC2HTn72S
g77XwgXaD9tIPwDbLzmkXyCW9tNs0k9wmfYbu95IoP2YQfoROP0KG2g/zyD9
DAdovw+hvt+K8kEs4QPg8AXU5BA+UdFm+AQ4fAOrKR+5ET4CY8pXAYSvgOWz
Pr6fI3YGSUGm01hx9Z8vsJ3wH8ylfHmI8CVw+BRElG/7Eb4FQ8rHZwkfA8vX
A+00p86cJ4MT6/f6Qq9IGh8ZXKb8PpTwOzhS/m8l/A8cfYCRAUQ/bhD9gLiH
XfQFOPoDQ1y66BNw9AsGremib8DRPxhN9TGJ6CNw9BNWUn2tJfoKHP2F/veI
PmsQfYbNVL8nE/0Gjr7DV6r/C4n+w2HqD44RfwAc/wCvqL/YRPwFrB1P/Aeb
v2jqT/KIPwGOf4Fk6m+GEX8DIup/qoj/gS/UHxFfJgWOf4Jm6q9sib+i6+RU
XJ0ZtCnmfSO4Km8dmydOw2w9Syb4BCb9kY67nyozMnRqBNa/LT01ce3Aw43w
gPq7vsTfwWPq//oQ/wccfwgi6h8z6DpYZmC1W/N0Np7++/Lut9MbgOM/4RT1
p2x/OlP/Gkj8K3D8Layi/vcl8b/Qk/rlX8Qvg+lAF5V2zUJsRvcfWH8967FF
wpqRtbCQ+u9o4r+hgV+wTPeIBLN8s5X69zRXxr9DBvX3PYi/h17U/7P8x64X
7pH1Aoh4Q46v7CjB+xarajiYlIML1LsZxpfhvavctF7ekYADXa+w/KxB1zPb
yXoGOOsdWE3XQyz/F9P10iayXgI+XU+xenKIrrc0yHoL2PXYGLIeg2GvN8VW
96vErL5x12vc/TB2/4zFI+j+F4sNOHg4B1vQ/S8WL+Bgcw7eS/e/WLyHg3dz
8A26r8Hi6xzsxsHh7H4v/YRx8GsOfsvuP3e5/v/4NQcLmJ+tCsznYBLPFgW2
pPtQLLbgYHMO9qA83XX+/8euHEzXcQqcy8HZHDyK7kexeAQH63Mw9ZEKnMfB
3zn4EPUXLN7HwTs5WJX5WcCJ5/9xMxPPfAWeSPW463z+jwdz8Auqhyz25uD/
OHgA1SMW7+LgCA5+T/WBxSkcXMrB0yifsngOB1tx8CXKbyy+xsHuHPy7y34Q
j9fOwcrMz3IF3kr3fxTz5eD9HEzyV6fAuzl4LwcPpesoFg/nYEMOJvX0S4Gz
OTiXg12YGzYrsBsHu3Mw4fM2BTbnYAsOJu8LOhSYfsRcvGvYtZ3DrimLw29Z
v7tl3YZJX6mIz/sM7nj9Vxu+VGUY+sVbRcw+r9uEcbFhIhWx7aI+h+aqtuH8
4zuUwgNUxO7eP8+a9mnBkaYv9GwnC8TsfDbInL4r2wnEhZ76+h6SJjxmy7vR
NyME4qc10mL/pCbcQ0vNca5YIGbjFayaMGh8i0A8u1+ssPC8DD94q3/ARV8o
PtpXNnivqRTP2rjq/CkroZjNh4pd91szNgjFi46mapVoNOJHzQEPBu4Vip0L
6z49063HpklmD5pchWI230t0LMzGugvFCy6d9b+7qQ5vbw4+kXFLKHYouhC6
YdlPbDXljedOb6GYrac3Abc7v0Kxz870kc+1q7Gdv3PiyM7z7Q6GvrhaX47/
sXdL3/qvUMzW6w+rJ9Of7RGKlV4Xz3ubWIqrQpWnLbEVivMtDMbqVRThhNGL
jmoaC8VsPzCvMfoJxa/tl+bqR+TjGQG3HyUUCcShnr779Kzy8L2Uq/MHfxOI
2X47Jq5SCj7fGa9v5k8sbNNwqtr73NolAnHbim33k9oT8ejVT3beqlYRs/0s
P101QUWc4+uYWvLxM364+bFmXoSKeN/ltQNCU6MU+c6ckutX5RiM85CjSZ6W
ipjlDwv5J15ZnOLyq67/ZD/oPeqvmiULlcXOLo7vL1i+htzdbbXN9Xwxy09z
0YK3Otf44pT+4kWrWj+Ck+/P9wEH+eKCamkP0bloui7ji+cN+ctDMykZlEKN
A078pySeJt+mP/ONfQ8kZvkx7KKDX2MzT7xjuv7sXqYZYNo2QOhygSf2Obg5
CS3LYt/ziG3PN82sXpYL67ZvWhj1s12xX/Ef856pDY/s9zT4xqlC+CtunU/z
/VbssX1/qvE3CRAdasEnZ72erT+yGBanTRvyblyzYr/hgVB2NcC5CSc+MDBJ
9ywFgenWEcquv/DLsLU6f44rY9/nYOWJI9VWpJeD5lffrPDYRgyuX3vHOFZA
7wCb8UHpDXi0YEfbAudKxf7KQGG0s+HXSjDyWNu3JL4Os/pkIH8/6V+Ly1MD
HxldrII1ln9fzJtUjflJvbWm11Yp9keOPVDt7RVRDc6qOgstIsqwK9/mba+O
ahikcqupenMpJvzxE7LfBP54E1iMN4TknZrw9Kdi/2OjHt+ltXcNHPtcmzy5
LRfj+4M2rNlWAx4XIuc/SM/Ast/uDevv1ij2MzYMLpllGl0DMduNZPOT4/Ei
c3VXy4YaWBZcbZx/LhBb3V5u16OVfY+ZHMEet3rJHAdbev1lcj38ovdn/eEH
+vz95PmwmY5vAxkfbKLjZ/0pZ35wnc5fl8wfnGh8dpD4gKTbyhjL31WK/YEf
NL5WJL7AiT8MofkZRfID42j+2PWABc2vCskvqNL8C0n+IYzWB/s+MIXWD4/U
D3DqC87Q+rMk9QciWp/s+7w/af3+SeoXOPUNu2j9ryb1DyG0P9j3c4do/yDS
P4jTX2gp7T+iM0poCe3PjhCmPxXvu3qYqg09k6yEbNt2J+95Hq14f1dB+/0E
6XfF+66XLVc6v3z0/irhiyLCF2jmNcInvQifIA7foHuUj3IJH6FelK/Y93cc
fkMmKwn/jSX8h+K78iPi8Cfy68qvKJny70zCv4jDzyid8nc84W+kRfm9mvA7
4vA/WtdVH9DjrvqBOPqCdnbVH7Soqz4hjn6hY131DS3vqn+I1cfJdps6v0Jk
T/XTlOgnmtdVXxFHf5Ef1Wcdos+ohOr3aKLfKLjnriVmbU2YfT/K6n0Es0Ek
QJ7UD3wgfgCtoX6hkPgFxPoJTeIn0CXqNy4Sv4E+UT/C5tvheWvv3DEd2Oq+
i/f1csU6i/Uv6H8yWvrV
   "], {{}, {}, 
    TagBox[
     TooltipBox[
      {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 
        36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 
        53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 
        70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 
        87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 
        103, 104, 105, 106, 107, 108, 109}]},
      RowBox[{
        RowBox[{"4", "-", 
          RowBox[{"4", " ", "x1"}], "+", 
          SuperscriptBox["x1", "2"]}], "\[Equal]", "x2"}]],
     Annotation[#, 4 - 4 SubKernels`x1 + SubKernels`x1^2 == SubKernels`x2, 
      "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], 
       LineBox[{110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 
        122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 
        136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 
        150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 
        164, 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177, 
        178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190, 191, 
        192, 193, 194}]},
      RowBox[{
        RowBox[{"3", "-", "x1"}], "\[Equal]", "x2"}]],
     Annotation[#, 3 - SubKernels`x1 == SubKernels`x2, "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      {RGBColor[0.560181, 0.691569, 0.194885], AbsoluteThickness[1.6], 
       LineBox[CompressedData["
1:eJwt0tVSFQAARdGLnSjYhWKL2IEJdmGBgR3YiYqtmNiNYmD8jI3d3YGo2F24
mOFhPe85Myc8MSl+blAgELjPcU5wklOc5gxnyeQc57nARS5xmStc5RrXucFN
bnGbO9zlXn7nAQ95xGOe8JRnPOcFL8niFdm85g1vyeEd7/nARz7xmS985Rvf
+cFPfvGbP/zlH7kEjA+iAAUpRGGKUJRiFKcEJSlFaYIpQ1lCCKUc5alARSpR
mSpUpRrVqUEYNalFOLWpQ13qUZ8GNKQRETQmkiY0pRnNaUFLWtGaNrQlina0
pwMd6URnoomhC13pRnd60JNe9KYPfelHLP0ZwEAGMZg44hnCUIYxnARGMJJR
jGYMYxnHeCYwkUQmMZkpTGUa05nBTGYxmznknTaJecxnAcksZBGLWcJSlrGc
FawkhVWsZg1rWcd6UtnARjaxmS1sZRvb2cFOdrGbPaSxl32ks58DHOQQGRzm
CEc5xn+dEmnd
        "]]},
      RowBox[{
        RowBox[{
          RowBox[{"3", " ", 
            SuperscriptBox["x1", "2"]}], "+", 
          SuperscriptBox["x2", "2"]}], "\[Equal]", "2"}]],
     Annotation[#, 3 SubKernels`x1^2 + SubKernels`x2^2 == 2, "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      {RGBColor[0.922526, 0.385626, 0.209179], AbsoluteThickness[1.6], 
       LineBox[CompressedData["
1:eJwNxmkyggEAANDPUbqSGRdwgByJyJJESmkRsmTNlsgu2aJEXcD78WZeaHRs
ODwUBMEI4zJBhEmmiDLNDLPMEWOeOAskWGSJJMukSLNChiyr5MhToMgaJdbZ
YJMyW2yzwy4V9tjngEOOOKbKCaeccc4FNS6pc8U1DW645Y57HnjkiWeavNDi
lTfe+eCTNl9806HLDz1++aPPgH+6SEUb
        "]]},
      RowBox[{"x2", "\[Equal]", "0"}]],
     Annotation[#, SubKernels`x2 == 0, "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      {RGBColor[0.528488, 0.470624, 0.701351], AbsoluteThickness[1.6], 
       LineBox[CompressedData["
1:eJwVy2c7lQEAgOH3HCojJSShOIqMQsooZISyc8yWcRqytcjuD/i3ZGR09+G+
rufLE4ktRRdDQRDssif2+cMBhxxxzF9OOOWM8/9TOAhChIkjngtc5BIJJJJE
MpdJ4QpXSeUaaaSTwXUyuUEWN8kmh1xucZs88olQwB3uUkgR9yimhFLKuM8D
yqmgkodU8YjHVFNDLXU84Sn1NNDIM5popoVWntNGOx284CWddNFND7300c8r
BogyyBDDjDDKGK95w1ve8Z5xJphkihgf+MgnPjPNF2aYZY55FlhkiWW+8o3v
/OAnK6zyizXW2WCTLbbZ4Tf/AMOnL0E=
        "]]},
      RowBox[{
        RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"2", " ", "x1"}], "+", 
          SuperscriptBox["x1", "2"], "+", 
          FractionBox[
           SuperscriptBox["x2", "2"], "2"]}], "\[Equal]", "0"}]],
     Annotation[#, -3 + 2 SubKernels`x1 + SubKernels`x1^2 + 
       Rational[1, 2] SubKernels`x2^2 == 0, "Tooltip"]& ]}],
  AspectRatio->1,
  Axes->True,
  AxesLabel->{
    FormBox["x1", TraditionalForm], 
    FormBox["x2", TraditionalForm]},
  DisplayFunction->Identity,
  Frame->True,
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  Method->{"DefaultBoundaryStyle" -> Automatic},
  PlotRange->{{-2, 3}, {-4, 4}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}},
  Ticks->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.6427598436187563`*^9, 3.642759853853065*^9}, 
   3.642760096513413*^9, 3.6427601520454063`*^9, {3.64276020810548*^9, 
   3.6427602242473392`*^9}, 3.642760519365962*^9, 3.642760726318183*^9, {
   3.642760869500372*^9, 3.642760890405402*^9}, {3.642761698545575*^9, 
   3.64276171839085*^9}, 3.642761802726358*^9, 3.64276198105735*^9, 
   3.642804967354734*^9, 3.64280502870888*^9, 3.642807422586092*^9, 
   3.6428078606101294`*^9, {3.642807982208137*^9, 3.642808006884931*^9}, 
   3.6428081356439953`*^9, 3.642808240242008*^9, {3.642808282650325*^9, 
   3.6428083195928707`*^9}, {3.642808367322611*^9, 3.642808407184102*^9}, 
   3.64281269446487*^9, 3.642813936480731*^9, 3.64281470958508*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"IGFQC", "[", 
   RowBox[{"A7", ",", "B7", ",", "0", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "x1"}], "-", "1"}], ")"}], "^", "2"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"x2", "-", "1"}], ")"}], "^", "2"}], "+", 
     RowBox[{"z", "^", "2"}]}], ",", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"x1", "^", "2"}]}], "+", 
     RowBox[{"4", "x1"}], "+", "x2", "-", "4"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.6428116129240217`*^9, 3.64281161893917*^9}, 
   3.642812036499649*^9, {3.642812071515353*^9, 3.642812087947783*^9}, {
   3.642812715855118*^9, 3.642812724758552*^9}, {3.6428127587987337`*^9, 
   3.6428127724846497`*^9}, 3.6428144548304443`*^9, {3.651324346578685*^9, 
   3.65132434698831*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"NSOSC unsatisfied, procedure terminates with:\"\>"], "Print",
 CellChangeTimes->{
  3.642812121632078*^9, 3.6428122264575653`*^9, 3.642812783396121*^9, 
   3.642812848835093*^9, 3.642812887827156*^9, 3.642813056789041*^9, {
   3.642813130382945*^9, 3.642813140764348*^9}, 3.642813246878092*^9, 
   3.642813302649311*^9, 3.642813505819878*^9, {3.642813547299305*^9, 
   3.642813566372072*^9}, 3.642813651571701*^9, 3.642813738773582*^9, 
   3.6428144579834747`*^9, 3.6428145793504887`*^9, {3.66908158914856*^9, 
   3.669081592959692*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", "False", 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", "False"}],
  SequenceForm["A: ", False, "\nB: ", False],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.642812121632078*^9, 3.6428122264575653`*^9, 3.642812783396121*^9, 
   3.642812848835093*^9, 3.642812887827156*^9, 3.642813056789041*^9, {
   3.642813130382945*^9, 3.642813140764348*^9}, 3.642813246878092*^9, 
   3.642813302649311*^9, 3.642813505819878*^9, {3.642813547299305*^9, 
   3.642813566372072*^9}, 3.642813651571701*^9, 3.642813738773582*^9, 
   3.6428144579834747`*^9, 3.6428145793504887`*^9, {3.66908158914856*^9, 
   3.6690815929607964`*^9}}],

Cell[BoxData["\<\"Var(A) is a subset of Var(B), procedure terminates \
with:\"\>"], "Print",
 CellChangeTimes->{
  3.642812121632078*^9, 3.6428122264575653`*^9, 3.642812783396121*^9, 
   3.642812848835093*^9, 3.642812887827156*^9, 3.642813056789041*^9, {
   3.642813130382945*^9, 3.642813140764348*^9}, 3.642813246878092*^9, 
   3.642813302649311*^9, 3.642813505819878*^9, {3.642813547299305*^9, 
   3.642813566372072*^9}, 3.642813651571701*^9, 3.642813738773582*^9, 
   3.6428144579834747`*^9, 3.6428145793504887`*^9, {3.66908158914856*^9, 
   3.6690815929613*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A: \"\>", "\[InvisibleSpace]", "False", 
   "\[InvisibleSpace]", "\<\"\\nB: \"\>", "\[InvisibleSpace]", "False"}],
  SequenceForm["A: ", False, "\nB: ", False],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.642812121632078*^9, 3.6428122264575653`*^9, 3.642812783396121*^9, 
   3.642812848835093*^9, 3.642812887827156*^9, 3.642813056789041*^9, {
   3.642813130382945*^9, 3.642813140764348*^9}, 3.642813246878092*^9, 
   3.642813302649311*^9, 3.642813505819878*^9, {3.642813547299305*^9, 
   3.642813566372072*^9}, 3.642813651571701*^9, 3.642813738773582*^9, 
   3.6428144579834747`*^9, 3.6428145793504887`*^9, {3.66908158914856*^9, 
   3.669081592961926*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], "+", 
     RowBox[{"2", " ", "x1"}], "+", 
     SuperscriptBox["x1", "2"], "+", 
     FractionBox[
      SuperscriptBox["x2", "2"], "2"]}], ">", "0"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.642812121634922*^9, 3.642812226459976*^9, 3.642812783399432*^9, 
   3.642812848838368*^9, 3.642812887834255*^9, 3.642813056999835*^9, {
   3.642813130571458*^9, 3.6428131409554243`*^9}, 3.6428132468863897`*^9, 
   3.642813302656658*^9, 3.6428135060188007`*^9, {3.642813547505341*^9, 
   3.642813566544072*^9}, 3.642813651746581*^9, 3.6428137389443274`*^9, 
   3.642814457991693*^9, 3.642814579358556*^9, {3.6690815891557827`*^9, 
   3.669081592962538*^9}}]
}, Open  ]]
},
WindowSize->{960, 1148},
WindowMargins->{{-10, Automatic}, {Automatic, -10}},
FrontEndVersion->"10.0 for Linux x86 (64-bit) (December 4, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 434, 12, 32, "Input"],
Cell[995, 34, 11440, 330, 517, "Input"],
Cell[12438, 366, 444, 11, 32, "Input"],
Cell[CellGroupData[{
Cell[12907, 381, 576, 12, 32, "Input"],
Cell[CellGroupData[{
Cell[13508, 397, 2478, 34, 23, "Print"],
Cell[15989, 433, 2638, 39, 43, "Print"],
Cell[18630, 474, 2491, 35, 23, "Print"],
Cell[21124, 511, 2635, 39, 43, "Print"]
}, Open  ]],
Cell[23774, 553, 2431, 41, 49, "Output"]
}, Open  ]],
Cell[26220, 597, 425, 11, 32, "Input"],
Cell[CellGroupData[{
Cell[26670, 612, 518, 14, 37, "Input"],
Cell[CellGroupData[{
Cell[27213, 630, 631, 8, 23, "Print"],
Cell[27847, 640, 3449, 86, 86, "Print"]
}, Open  ]],
Cell[31311, 729, 538, 9, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[31886, 743, 2493, 74, 131, "Input"],
Cell[CellGroupData[{
Cell[34404, 821, 437, 6, 23, "Print"],
Cell[34844, 829, 3253, 88, 66, "Print"]
}, Open  ]],
Cell[38112, 920, 430, 8, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[38579, 933, 3410, 105, 153, "Input"],
Cell[CellGroupData[{
Cell[42014, 1042, 913, 12, 23, "Print"],
Cell[42930, 1056, 3733, 94, 66, "Print"]
}, Open  ]],
Cell[46678, 1153, 1045, 18, 32, "Output"]
}, Open  ]],
Cell[47738, 1174, 448, 11, 32, "Input"],
Cell[CellGroupData[{
Cell[48211, 1189, 1047, 24, 32, "Input"],
Cell[49261, 1215, 5879, 124, 183, "Print"],
Cell[55143, 1341, 2658, 38, 32, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57838, 1384, 1310, 34, 84, "Input"],
Cell[CellGroupData[{
Cell[59173, 1422, 269, 3, 23, "Print"],
Cell[59445, 1427, 2762, 68, 83, "Print"],
Cell[62210, 1497, 268, 3, 23, "Print"],
Cell[62481, 1502, 2876, 71, 83, "Print"]
}, Open  ]],
Cell[65372, 1576, 623, 19, 49, "Output"]
}, Open  ]],
Cell[66010, 1598, 470, 11, 32, "Input"],
Cell[CellGroupData[{
Cell[66505, 1613, 992, 18, 32, "Input"],
Cell[CellGroupData[{
Cell[67522, 1635, 537, 7, 23, "Print"],
Cell[68062, 1644, 695, 12, 43, "Print"]
}, Open  ]],
Cell[68772, 1659, 883, 27, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[69692, 1691, 223, 5, 32, "Input"],
Cell[CellGroupData[{
Cell[69940, 1700, 255, 4, 23, "Print"],
Cell[70198, 1706, 400, 8, 43, "Print"]
}, Open  ]],
Cell[70613, 1717, 241, 5, 32, "Output"]
}, Open  ]],
Cell[70869, 1725, 374, 10, 32, "Input"],
Cell[CellGroupData[{
Cell[71268, 1739, 1063, 30, 55, "Input"],
Cell[72334, 1771, 213412, 3356, 404, "Output"]
}, Open  ]],
Cell[285761, 5130, 373, 10, 32, "Input"],
Cell[CellGroupData[{
Cell[286159, 5144, 2117, 47, 92, "Input"],
Cell[288279, 5193, 13515, 249, 371, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[301831, 5447, 829, 21, 32, "Input"],
Cell[CellGroupData[{
Cell[302685, 5472, 555, 8, 23, "Print"],
Cell[303243, 5482, 717, 13, 43, "Print"],
Cell[303963, 5497, 566, 9, 23, "Print"],
Cell[304532, 5508, 715, 13, 43, "Print"]
}, Open  ]],
Cell[305262, 5524, 754, 17, 52, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
