(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     72868,       1591]
NotebookOptionsPosition[     72538,       1576]
NotebookOutlinePosition[     72877,       1591]
CellTagsIndexPosition[     72834,       1588]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "A", " ", "REDUCING", " ", "PROCEDURE", " ", "TO", " ", "ELIMINATE", " ", 
    "EUF", " ", "AND", " ", "DERIVE", " ", "GENERAL", " ", "NLA", " ", 
    "INTERPOLATION"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"reduce", "[", 
      RowBox[{"A0_", ",", "B0_", ",", "NSOSC_", ",", "h0_", ",", "hf1_"}], 
      "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "A", ",", "B", ",", "h", ",", "h1", ",", "h2", ",", "vlistA", ",", 
         "vlistB", ",", "x", ",", "y", ",", "z", ",", "d", ",", "u", ",", "v",
          ",", "a1", ",", "b1", ",", "c1", ",", "q1", ",", "f", ",", "fA", 
         ",", "fB", ",", "tA", ",", "tAlist", ",", "tAkey", ",", "tB", ",", 
         "tBlist", ",", "fresh", ",", "DA", ",", "DB", ",", "D", ",", "NA", 
         ",", "NB", ",", "Nmix", ",", "N", ",", "NsepA", ",", "NsepB", ",", 
         "cntA", ",", "cntB", ",", "i", ",", "j", ",", "k"}], "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", "initialization", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"A", "=", "A0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"B", "=", "B0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"h", "=", "h0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"h1", "=", 
         RowBox[{"h2", "=", "0"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"fA", "=", 
         RowBox[{"fB", "=", "True"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tA", "=", 
         RowBox[{"tB", "=", "True"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"N", "=", 
         RowBox[{"NA", "=", 
          RowBox[{"NB", "=", 
           RowBox[{"Nmix", "=", 
            RowBox[{"{", "}"}]}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"D", "=", 
         RowBox[{"DA", "=", 
          RowBox[{"DB", "=", 
           RowBox[{"{", "}"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"y", "=", 
          RowBox[{"z", "=", 
           RowBox[{"{", "}"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cntA", "=", 
         RowBox[{"cntB", "=", "0"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "get", " ", "variables", " ", "and", " ", "uninterpreted", " ", 
          "functions"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"vlistA", "=", 
         RowBox[{"Variables", "[", 
          RowBox[{"Level", "[", 
           RowBox[{"A", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vlistB", "=", 
         RowBox[{"Variables", "[", 
          RowBox[{"Level", "[", 
           RowBox[{"B", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"flattening", " ", "and", " ", "purification"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"introduce", " ", "fresh", " ", "variables"}], ",", " ", 
          RowBox[{"needs", " ", "to", " ", "be", " ", "done", " ", 
           RowBox[{
            RowBox[{"recursively", "!!"}], "!"}]}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "vlistA", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "   ", 
          RowBox[{"(*", 
           RowBox[{"for", " ", "A"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", 
              RowBox[{"vlistA", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], "=!=", "Symbol"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"cntA", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"While", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"vlistA", ",", 
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<a\>\"", "<>", 
                   RowBox[{"ToString", "[", "cntA", "]"}]}], "]"}]}], "]"}], 
               ",", 
               RowBox[{"cntA", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"fresh", "=", 
              RowBox[{"ToExpression", "[", 
               RowBox[{"\"\<a\>\"", "<>", 
                RowBox[{"ToString", "[", "cntA", "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"DA", ",", 
               RowBox[{"(", 
                RowBox[{"fresh", "\[Equal]", 
                 RowBox[{"vlistA", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], ")"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"A", "=", 
              RowBox[{"A", "/.", 
               RowBox[{
                RowBox[{"vlistA", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", "fresh"}]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"vlistA", "=", 
              RowBox[{"vlistA", "/.", 
               RowBox[{
                RowBox[{"vlistA", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", "fresh"}]}]}]}]}],
            "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", 
           RowBox[{"Length", "[", "vlistB", "]"}]}], ",", 
          RowBox[{"i", "++"}], ",", "   ", 
          RowBox[{"(*", 
           RowBox[{"for", " ", "B"}], "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", 
              RowBox[{"vlistB", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}], "=!=", "Symbol"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"cntB", "++"}], ";", "\[IndentingNewLine]", 
             RowBox[{"While", "[", 
              RowBox[{
               RowBox[{"MemberQ", "[", 
                RowBox[{"vlistB", ",", 
                 RowBox[{"ToExpression", "[", 
                  RowBox[{"\"\<b\>\"", "<>", 
                   RowBox[{"ToString", "[", "cntB", "]"}]}], "]"}]}], "]"}], 
               ",", 
               RowBox[{"cntB", "++"}]}], "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"fresh", "=", 
              RowBox[{"ToExpression", "[", 
               RowBox[{"\"\<b\>\"", "<>", 
                RowBox[{"ToString", "[", "cntB", "]"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"DB", ",", 
               RowBox[{"(", 
                RowBox[{"fresh", "\[Equal]", 
                 RowBox[{"vlistB", "[", 
                  RowBox[{"[", "i", "]"}], "]"}]}], ")"}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"B", "=", 
              RowBox[{"B", "/.", 
               RowBox[{
                RowBox[{"vlistB", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", "fresh"}]}]}], 
             ";", "\[IndentingNewLine]", 
             RowBox[{"vlistB", "=", 
              RowBox[{"vlistB", "/.", 
               RowBox[{
                RowBox[{"vlistB", "[", 
                 RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", "fresh"}]}]}]}]}],
            "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]",
         "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"calculate", " ", "NA"}], ",", " ", "NB", ",", " ", "Nmix", 
          ",", " ", 
          RowBox[{"D", " ", "and", " ", "N"}]}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", "DA", "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "   ", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"k", "=", 
             RowBox[{"j", "+", "1"}]}], ",", 
            RowBox[{"k", "\[LessEqual]", 
             RowBox[{"Length", "[", "DA", "]"}]}], ",", 
            RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Head", "[", 
                RowBox[{
                 RowBox[{"DA", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", 
               RowBox[{"Head", "[", 
                RowBox[{
                 RowBox[{"DA", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"NA", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"And", "@@", 
                   RowBox[{"(", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"List", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"DA", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}], "\[Equal]", 
                    RowBox[{"List", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"DA", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}]}], "]"}], ")"}]}],
                   ")"}], "\[Implies]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"DA", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "==", 
                  RowBox[{
                   RowBox[{"DA", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}]}]}], "]"}]}], "]"}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", "DB", "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "   ", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"k", "=", 
             RowBox[{"j", "+", "1"}]}], ",", 
            RowBox[{"k", "\[LessEqual]", 
             RowBox[{"Length", "[", "DB", "]"}]}], ",", 
            RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Head", "[", 
                RowBox[{
                 RowBox[{"DB", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", 
               RowBox[{"Head", "[", 
                RowBox[{
                 RowBox[{"DB", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"NB", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"And", "@@", 
                   RowBox[{"(", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"List", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"DB", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}], "\[Equal]", 
                    RowBox[{"List", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"DB", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}]}], "]"}], ")"}]}],
                   ")"}], "\[Implies]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"DB", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "==", 
                  RowBox[{
                   RowBox[{"DB", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}]}]}], "]"}]}], "]"}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", "DA", "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "   ", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"k", "=", "1"}], ",", 
            RowBox[{"k", "\[LessEqual]", 
             RowBox[{"Length", "[", "DB", "]"}]}], ",", 
            RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Head", "[", 
                RowBox[{
                 RowBox[{"DA", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}], "\[Equal]", 
               RowBox[{"Head", "[", 
                RowBox[{
                 RowBox[{"DB", "[", 
                  RowBox[{"[", "k", "]"}], "]"}], "[", 
                 RowBox[{"[", "2", "]"}], "]"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"Nmix", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"And", "@@", 
                   RowBox[{"(", 
                    RowBox[{"Thread", "[", 
                    RowBox[{
                    RowBox[{"List", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"DA", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}], "\[Equal]", 
                    RowBox[{"List", "@@", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"DB", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}]}], "]"}], ")"}]}],
                   ")"}], "\[Implies]", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"DA", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}], "==", 
                  RowBox[{
                   RowBox[{"DB", "[", 
                    RowBox[{"[", "k", "]"}], "]"}], "[", 
                   RowBox[{"[", "1", "]"}], "]"}]}]}]}], "]"}]}], "]"}]}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"D", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"DA", ",", "DB"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"N", "=", 
         RowBox[{"Join", "[", 
          RowBox[{"NA", ",", "NB", ",", "Nmix"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"Nmix", "\[Equal]", 
           RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", "\"\<Nmix\[Equal]{}, procedure terminates with:\>\"",
             "]"}], ";", 
           RowBox[{"Print", "[", 
            RowBox[{
             RowBox[{"\"\<A: \>\"", "A"}], ",", "\"\<\\nDA: \>\"", ",", "DA", 
             ",", "\"\<\\nNA: \>\"", ",", "NA", ",", "\"\<\\nB: \>\"", ",", 
             "B", ",", "\"\<\\nDB: \>\"", ",", "DB", ",", "\"\<\\nNB: \>\"", 
             ",", "NB", ",", "\"\<\\nD: \>\"", ",", "D", ",", 
             "\"\<\\nN: \>\"", ",", "N", ",", "\"\<\\nNmix: \>\"", ",", 
             "Nmix"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "NSOSC", " ", "needs", " ", "to", " ", "be", " ", "checked", " ", 
          RowBox[{"(", 
           RowBox[{"sos", "-", "solving"}], ")"}], " ", 
          RowBox[{
           RowBox[{"here", "!!"}], "!"}]}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"NSOSC", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<NSOSC satisfied, procedure terminates with:\>\"", "]"}], ";", 
           RowBox[{"Print", "[", 
            RowBox[{
             RowBox[{"\"\<A: \>\"", "A"}], ",", "\"\<\\nDA: \>\"", ",", "DA", 
             ",", "\"\<\\nNA: \>\"", ",", "NA", ",", "\"\<\\nB: \>\"", ",", 
             "B", ",", "\"\<\\nDB: \>\"", ",", "DB", ",", "\"\<\\nNB: \>\"", 
             ",", "NB", ",", "\"\<\\nD: \>\"", ",", "D", ",", 
             "\"\<\\nN: \>\"", ",", "N", ",", "\"\<\\nNmix: \>\"", ",", 
             "Nmix"}], "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Return", "[", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "separate", " ", "Nmix", " ", "when", " ", "NSOSC", " ", "is", " ", 
          "not", " ", "satisfied"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", "h", "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{"vlistA", ",", "vlistB", ",", 
           RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"Complement", "[", 
            RowBox[{"vlistA", ",", "x"}], "]"}], ",", 
           RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"z", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"Complement", "[", 
            RowBox[{"vlistB", ",", "x"}], "]"}], ",", 
           RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"d", "=", 
         RowBox[{"Length", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"u", "=", 
         RowBox[{"Length", "[", "y", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", "=", 
         RowBox[{"Length", "[", "z", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", "u"}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"htemp", "=", 
             RowBox[{"Collect", "[", 
              RowBox[{"h", ",", 
               RowBox[{"y", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"a1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"b1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"c1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"a1", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"h", "=", "c1"}], ";", "\[IndentingNewLine]", 
              RowBox[{"q1", "=", "0"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"h", "=", 
               RowBox[{"h", "/.", 
                RowBox[{
                 RowBox[{"y", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "b1"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"2", " ", "a1"}], ")"}]}], ")"}]}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"q1", "=", 
               RowBox[{"a1", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"y", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                   RowBox[{"b1", "/", 
                    RowBox[{"(", 
                    RowBox[{"2", " ", "a1"}], ")"}]}]}], ")"}], "^", 
                 "2"}]}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"h1", "=", 
            RowBox[{"h1", "+", "q1"}]}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"h2", "=", "h"}], ";", "\[IndentingNewLine]", 
        RowBox[{"f", "=", 
         RowBox[{"Simplify", "[", 
          RowBox[{"hf1", "+", "h1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", "A", "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", 
              RowBox[{"A", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", "GreaterEqual"}],
             ",", 
            RowBox[{
             RowBox[{"fA", "=", 
              RowBox[{"fA", "&&", 
               RowBox[{"A", "[", 
                RowBox[{"[", "j", "]"}], "]"}]}]}], ";", 
             RowBox[{"A", "=", 
              RowBox[{"Delete", "[", 
               RowBox[{"A", ",", "j"}], "]"}]}]}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"j", "=", "1"}], ",", 
          RowBox[{"j", "\[LessEqual]", 
           RowBox[{"Length", "[", "B", "]"}]}], ",", 
          RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", 
              RowBox[{"B", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", "GreaterEqual"}],
             ",", 
            RowBox[{
             RowBox[{"fB", "=", 
              RowBox[{"fB", "&&", 
               RowBox[{"B", "[", 
                RowBox[{"[", "j", "]"}], "]"}]}]}], ";", 
             RowBox[{"B", "=", 
              RowBox[{"Delete", "[", 
               RowBox[{"B", ",", "j"}], "]"}]}]}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"tAlist", "=", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{"fA", "&&", 
             RowBox[{"f", "\[Equal]", "0"}]}], ",", "Reals"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tAkey", "=", 
         RowBox[{
          RowBox[{"Select", "[", 
           RowBox[{"tAlist", ",", 
            RowBox[{
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"Variables", "[", "f", "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "&"}]}], "]"}], "[", 
          
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tAkey", "=", 
         RowBox[{
          RowBox[{"tAkey", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "\[Rule]", 
          RowBox[{"tAkey", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tAlist", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"tAlist", ",", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"Variables", "[", "f", "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "&"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", "tAlist", "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"tA", "=", 
           RowBox[{"tA", "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"tAlist", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
               RowBox[{
                RowBox[{"tAlist", "[", 
                 RowBox[{"[", "k", "]"}], "]"}], "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "/.", "tAkey"}], 
             ")"}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"tBlist", "=", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{"fB", "&&", 
             RowBox[{"f", "\[Equal]", "0"}]}], ",", "Reals"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tBlist", "=", 
         RowBox[{"Select", "[", 
          RowBox[{"tBlist", ",", 
           RowBox[{
            RowBox[{"!", 
             RowBox[{"MemberQ", "[", 
              RowBox[{
               RowBox[{"Variables", "[", "f", "]"}], ",", 
               RowBox[{"#", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "&"}]}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"k", "=", "1"}], ",", 
          RowBox[{"k", "\[LessEqual]", 
           RowBox[{"Length", "[", "tBlist", "]"}]}], ",", 
          RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"tB", "=", 
           RowBox[{"tB", "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"tBlist", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
              RowBox[{
               RowBox[{"tBlist", "[", 
                RowBox[{"[", "k", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"A", "=", 
         RowBox[{
          RowBox[{"f", "\[GreaterEqual]", "0"}], "&&", "A", "&&", "tA"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"B", "=", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "f"}], "\[GreaterEqual]", "0"}], "&&", "B", "&&", 
          "tB"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"A", "=", 
         RowBox[{"A", "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "f"}], "\[GreaterEqual]", "0"}], "\[Rule]", 
            RowBox[{
             RowBox[{
              RowBox[{"DA", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
             RowBox[{"ToExpression", "[", "\"\<tt\>\"", "]"}]}]}], ")"}]}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"B", "=", 
         RowBox[{"B", "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", "\[GreaterEqual]", "0"}], "\[Rule]", 
            RowBox[{
             RowBox[{
              RowBox[{"DB", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "[", 
              RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
             RowBox[{"ToExpression", "[", "\"\<tt\>\"", "]"}]}]}], ")"}]}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
          RowBox[{"\"\<A: \>\"", "A"}], ",", "\"\<\\nDA: \>\"", ",", "DA", 
          ",", "\"\<\\nNA: \>\"", ",", "NA", ",", "\"\<\\nB: \>\"", ",", "B", 
          ",", "\"\<\\nDB: \>\"", ",", "DB", ",", "\"\<\\nNB: \>\"", ",", 
          "NB", ",", "\"\<\\nD: \>\"", ",", "D", ",", "\"\<\\nN: \>\"", ",", 
          "N", ",", "\"\<\\nNmix: \>\"", ",", "Nmix"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.6329766133214293`*^9, 3.6329766481832733`*^9}, 
   3.633091643719595*^9, {3.633092106921231*^9, 3.633092110420955*^9}, {
   3.633092380291307*^9, 3.633092397003547*^9}, {3.633093352075411*^9, 
   3.633093366500522*^9}, {3.63309342050888*^9, 3.63309352679541*^9}, {
   3.633093813424188*^9, 3.633093951126082*^9}, {3.633094026340364*^9, 
   3.633094059367002*^9}, {3.633094114608612*^9, 3.633094223686812*^9}, {
   3.633094374511977*^9, 3.633094416892902*^9}, {3.633094452441504*^9, 
   3.633094518789204*^9}, {3.633094567255464*^9, 3.633094572103892*^9}, {
   3.633094607277117*^9, 3.633094630192697*^9}, {3.633094662330986*^9, 
   3.633094709874855*^9}, {3.633094794911121*^9, 3.633094795071145*^9}, {
   3.633094981796172*^9, 3.633094997177761*^9}, {3.633095040067258*^9, 
   3.633095071244335*^9}, {3.633095169096269*^9, 3.63309524080682*^9}, {
   3.633095272477355*^9, 3.633095299580431*^9}, {3.633095333708556*^9, 
   3.633095374122467*^9}, {3.633095454752696*^9, 3.63309545711636*^9}, {
   3.633095625958722*^9, 3.6330957716987*^9}, {3.633095805054966*^9, 
   3.633095842268152*^9}, {3.63309590133414*^9, 3.633095961493014*^9}, {
   3.633096033325218*^9, 3.633096057166382*^9}, {3.633096106944231*^9, 
   3.63309616683392*^9}, {3.633096289115126*^9, 3.633096292523485*^9}, {
   3.633096464371543*^9, 3.633096547503129*^9}, {3.633096618391088*^9, 
   3.633096652343243*^9}, 3.633096861346081*^9, {3.633096973224752*^9, 
   3.633097101202732*^9}, {3.633097272532887*^9, 3.633097431215254*^9}, {
   3.633097494887246*^9, 3.633097517706423*^9}, {3.633097555494295*^9, 
   3.633097589023188*^9}, {3.633097975486364*^9, 3.633098046607583*^9}, {
   3.633098080259363*^9, 3.633098247515687*^9}, {3.633098347191442*^9, 
   3.633098448573394*^9}, {3.633098481542953*^9, 3.633098513383636*^9}, {
   3.633169443861643*^9, 3.633169444075735*^9}, {3.633169559463292*^9, 
   3.633169618016236*^9}, {3.633169698966408*^9, 3.633169706910556*^9}, 
   3.63316974342639*^9, {3.633170420550598*^9, 3.633170516991656*^9}, {
   3.633170907069391*^9, 3.633171050735557*^9}, {3.633171085700086*^9, 
   3.633171121356386*^9}, {3.63317117468227*^9, 3.633171203950827*^9}, {
   3.63317126205851*^9, 3.633171360239971*^9}, 3.633306611603573*^9, {
   3.633306774049498*^9, 3.633306860594133*^9}, {3.633309264557283*^9, 
   3.633309304481461*^9}, {3.633319145883045*^9, 3.633319155626981*^9}, {
   3.633319230010984*^9, 3.633319253932325*^9}, {3.633319304158508*^9, 
   3.633319315039251*^9}, {3.633319416699431*^9, 3.63331941694785*^9}, {
   3.633322839556806*^9, 3.633322845503406*^9}, {3.633322908558373*^9, 
   3.63332293237736*^9}, {3.633322981063195*^9, 3.633322993939079*^9}, {
   3.633323034700274*^9, 3.633323041793314*^9}, {3.633494273801642*^9, 
   3.633494277490608*^9}, 3.633494336105918*^9, {3.633494448895893*^9, 
   3.633494460420782*^9}, {3.633494503514524*^9, 3.63349452729535*^9}, {
   3.633494620405626*^9, 3.633494622983071*^9}, {3.633494672057682*^9, 
   3.633494687592048*^9}, {3.633494758116678*^9, 3.633494824533193*^9}, {
   3.633494861304165*^9, 3.633494886096363*^9}, {3.633494947462755*^9, 
   3.633494948022929*^9}, {3.633495132301361*^9, 3.63349520576777*^9}, {
   3.633495285419686*^9, 3.633495290447892*^9}, {3.633495346706068*^9, 
   3.633495422483415*^9}, {3.633495457899737*^9, 3.633495569016953*^9}, {
   3.633495606794881*^9, 3.633495608580397*^9}, {3.63349571573038*^9, 
   3.63349572580724*^9}, {3.633495939758972*^9, 3.633495987667419*^9}, {
   3.633497550781538*^9, 3.633497561354334*^9}, {3.63349833515675*^9, 
   3.633498344232156*^9}, {3.633498452528524*^9, 3.633498458054624*^9}, {
   3.63349849059988*^9, 3.633498510634764*^9}, {3.633498595936067*^9, 
   3.633498625870858*^9}, {3.633498697217405*^9, 3.633498737083634*^9}, {
   3.633498771131654*^9, 3.633498849921885*^9}, 3.633498906708475*^9, {
   3.633499007426476*^9, 3.633499009844694*^9}, {3.63349915438001*^9, 
   3.633499158516792*^9}, {3.633499195259551*^9, 3.633499210083954*^9}, {
   3.633499368476153*^9, 3.633499457793435*^9}, {3.633499517060672*^9, 
   3.633499687954808*^9}, {3.633499774879088*^9, 3.633499817924942*^9}, {
   3.633499909626921*^9, 3.63349992577439*^9}, {3.633500078031986*^9, 
   3.633500080285595*^9}, {3.633500291763015*^9, 3.63350030073873*^9}, {
   3.633500813618822*^9, 3.633500822481264*^9}, {3.633501151997494*^9, 
   3.633501189185469*^9}, {3.633501274456921*^9, 3.633501277048312*^9}, {
   3.633501345869628*^9, 3.633501352993383*^9}, {3.633501425079098*^9, 
   3.633501458481765*^9}, {3.633501519555957*^9, 3.633501546512778*^9}, {
   3.633501663991287*^9, 3.633501694502735*^9}, {3.633512212540653*^9, 
   3.633512219182239*^9}, {3.633512749581335*^9, 3.633512787605053*^9}, {
   3.633512838217866*^9, 3.633512904003164*^9}, 3.633517075948758*^9, {
   3.633517917178967*^9, 3.633517922554447*^9}, {3.633517997673075*^9, 
   3.6335180584933*^9}, {3.633518090424118*^9, 3.633518217845714*^9}, {
   3.633518625696506*^9, 3.63351872368767*^9}, {3.633518802184646*^9, 
   3.633518849139882*^9}, {3.633519095836299*^9, 3.633519155278772*^9}, {
   3.633519249037248*^9, 3.633519469868322*^9}, 3.633519553005123*^9, 
   3.633519707462843*^9, {3.633519828813095*^9, 3.633519853641155*^9}, {
   3.633519895907784*^9, 3.633519922803129*^9}, {3.633519974315159*^9, 
   3.633520136208863*^9}, {3.633520211291462*^9, 3.633520348566364*^9}, {
   3.633520380547134*^9, 3.633520387642816*^9}, {3.633520695745952*^9, 
   3.633520859669331*^9}, {3.633520909350927*^9, 3.633520925104103*^9}, {
   3.633521458566893*^9, 3.633521586570597*^9}, {3.63352169611913*^9, 
   3.63352175849349*^9}, {3.633521814807221*^9, 3.633521837164935*^9}, {
   3.633521931499571*^9, 3.633521944734433*^9}, 3.633738583215453*^9, 
   3.633755116073443*^9, {3.633756477534178*^9, 3.633756526915601*^9}, {
   3.633758136744783*^9, 3.633758141408465*^9}, {3.6337816229739933`*^9, 
   3.6337816257582827`*^9}, 3.633781673038315*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
   "A", " ", "PROCEDURE", " ", "TO", " ", "SYNTHESIZE", " ", "GENERAL", " ", 
    "NLA", " ", "INTERPOLATION"}], "*)"}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"IGFQC", "[", 
      RowBox[{"A0_", ",", "B0_", ",", "NSOSC_", ",", "h0_", ",", "hf1_"}], 
      "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "A", ",", "B", ",", "h", ",", "h1", ",", "h2", ",", "vlistA", ",", 
         "vlistB", ",", "x", ",", "y", ",", "z", ",", "d", ",", "u", ",", "v",
          ",", "a1", ",", "b1", ",", "c1", ",", "q1", ",", "f", ",", "fA", 
         ",", "fB", ",", "tA", ",", "tAlist", ",", "tAkey", ",", "tB", ",", 
         "tBlist", ",", "booltemp", ",", "fresh", ",", "DA", ",", "DB", ",", 
         "D", ",", "NA", ",", "NB", ",", "Nmix", ",", "N", ",", "NsepA", ",", 
         "NsepB", ",", "cntA", ",", "cntB", ",", "i", ",", "j", ",", "k"}], 
        "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", "initialization", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"A", "=", "A0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"B", "=", "B0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"h", "=", "h0"}], ";", "\[IndentingNewLine]", 
        RowBox[{"h1", "=", 
         RowBox[{"h2", "=", "0"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"fA", "=", 
         RowBox[{"fB", "=", "True"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tA", "=", 
         RowBox[{"tB", "=", "True"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"N", "=", 
         RowBox[{"NA", "=", 
          RowBox[{"NB", "=", 
           RowBox[{"Nmix", "=", 
            RowBox[{"{", "}"}]}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"D", "=", 
         RowBox[{"DA", "=", 
          RowBox[{"DB", "=", 
           RowBox[{"{", "}"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"y", "=", 
          RowBox[{"z", "=", 
           RowBox[{"{", "}"}]}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"cntA", "=", 
         RowBox[{"cntB", "=", "0"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "get", " ", "variables", " ", "and", " ", "uninterpreted", " ", 
          "functions"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"vlistA", "=", 
         RowBox[{"Variables", "[", 
          RowBox[{"Level", "[", 
           RowBox[{"A", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"vlistB", "=", 
         RowBox[{"Variables", "[", 
          RowBox[{"Level", "[", 
           RowBox[{"B", ",", "2"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"SubsetQ", "[", 
           RowBox[{"vlistB", ",", "vlistA"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<Var(A) is a subset of Var(B), procedure terminates \
with:\>\"", "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<A: \>\"", ",", "A", ",", "\"\<\\nB: \>\"", ",", "B"}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Return", "[", "A", "]"}]}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"NSOSC", "==", "h", "\[Equal]", "hf1", "\[Equal]", "0"}], 
          ",", 
          RowBox[{"Return", "[", "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"check", " ", "the", " ", "condition", " ", "NSOSC"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"NSOSC", "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
           "Print", "[", 
            "\"\<NSOSC satisfied, procedure terminates with:\>\"", "]"}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"Print", "[", 
            RowBox[{
            "\"\<A: \>\"", ",", "A", ",", "\"\<\\nB: \>\"", ",", "B"}], "]"}],
            ";", "\[IndentingNewLine]", 
           RowBox[{"Return", "[", 
            RowBox[{"IGFCH", "[", 
             RowBox[{"A", ",", "B", ",", "h", ",", "hf1", ",", 
              RowBox[{"1", "/", "2"}]}], "]"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
         "construct", " ", "h1", " ", "and", " ", "h2", " ", "when", " ", 
          "NSOSC", " ", "is", " ", "not", " ", "satisfied"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{"vlistA", ",", "vlistB", ",", 
           RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"y", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"Complement", "[", 
            RowBox[{"vlistA", ",", "x"}], "]"}], ",", 
           RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"z", "=", 
         RowBox[{"Intersection", "[", 
          RowBox[{
           RowBox[{"Complement", "[", 
            RowBox[{"vlistB", ",", "x"}], "]"}], ",", 
           RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"d", "=", 
         RowBox[{"Length", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"u", "=", 
         RowBox[{"Length", "[", "y", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"v", "=", 
         RowBox[{"Length", "[", "z", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", "u"}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"htemp", "=", 
             RowBox[{"Collect", "[", 
              RowBox[{"h", ",", 
               RowBox[{"y", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"a1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"b1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"c1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"y", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"a1", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"h", "=", "c1"}], ";", "\[IndentingNewLine]", 
              RowBox[{"q1", "=", "0"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"h", "=", 
               RowBox[{"h", "/.", 
                RowBox[{
                 RowBox[{"y", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "b1"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"2", " ", "a1"}], ")"}]}], ")"}]}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"q1", "=", 
               RowBox[{"a1", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"y", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                   RowBox[{"b1", "/", 
                    RowBox[{"(", 
                    RowBox[{"2", " ", "a1"}], ")"}]}]}], ")"}], "^", 
                 "2"}]}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"h1", "=", 
            RowBox[{"h1", "+", "q1"}]}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"For", "[", 
         RowBox[{
          RowBox[{"i", "=", "1"}], ",", 
          RowBox[{"i", "\[LessEqual]", "v"}], ",", 
          RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
          RowBox[{"(*", 
           RowBox[{
            RowBox[{"htemp", "=", 
             RowBox[{"Collect", "[", 
              RowBox[{"h", ",", 
               RowBox[{"y", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";"}], "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"a1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"z", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"b1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"z", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"c1", "=", 
            RowBox[{"Coefficient", "[", 
             RowBox[{"h", ",", 
              RowBox[{"z", "[", 
               RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"a1", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"h", "=", "c1"}], ";", "\[IndentingNewLine]", 
              RowBox[{"q1", "=", "0"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"h", "=", 
               RowBox[{"h", "/.", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "b1"}], "/", 
                   RowBox[{"(", 
                    RowBox[{"2", " ", "a1"}], ")"}]}], ")"}]}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"q1", "=", 
               RowBox[{"a1", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"z", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "+", 
                   RowBox[{"b1", "/", 
                    RowBox[{"(", 
                    RowBox[{"2", " ", "a1"}], ")"}]}]}], ")"}], "^", 
                 "2"}]}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"h2", "=", 
            RowBox[{"h2", "+", "q1"}]}], ";"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"h1", "=", 
         RowBox[{"Simplify", "[", 
          RowBox[{
           RowBox[{"h", "/", "2"}], "+", "h1"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"h2", "=", 
         RowBox[{"Simplify", "[", 
          RowBox[{
           RowBox[{"h", "/", "2"}], "+", "h2"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"f", "=", 
         RowBox[{"Simplify", "[", 
          RowBox[{"hf1", "+", "h1"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"h1", ",", "h2", ",", "f"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "A", "]"}], "===", "GreaterEqual"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"fA", "=", 
              RowBox[{"fA", "&&", "A"}]}], ";", 
             RowBox[{"A", "=", "True"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"j", "=", "1"}], ",", 
              RowBox[{"j", "\[LessEqual]", 
               RowBox[{"Length", "[", "A", "]"}]}], ",", 
              RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Head", "[", 
                  RowBox[{"A", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", 
                 "GreaterEqual"}], ",", 
                RowBox[{"fA", "=", 
                 RowBox[{"fA", "&&", 
                  RowBox[{"A", "[", 
                   RowBox[{"[", "j", "]"}], "]"}]}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "B", "]"}], "===", "GreaterEqual"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"fB", "=", 
              RowBox[{"fB", "&&", "B"}]}], ";", 
             RowBox[{"B", "=", "True"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"For", "[", 
             RowBox[{
              RowBox[{"j", "=", "1"}], ",", 
              RowBox[{"j", "\[LessEqual]", 
               RowBox[{"Length", "[", "B", "]"}]}], ",", 
              RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Head", "[", 
                  RowBox[{"B", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], "]"}], "===", 
                 "GreaterEqual"}], ",", 
                RowBox[{"fB", "=", 
                 RowBox[{"fB", "&&", 
                  RowBox[{"B", "[", 
                   RowBox[{"[", "j", "]"}], "]"}]}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
          ";"}], "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"tAlist", "=", 
           RowBox[{
            RowBox[{"Solve", "[", 
             RowBox[{
              RowBox[{"fA", "&&", 
               RowBox[{"f", "\[Equal]", "0"}]}], ",", "Reals"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"tBlist", "=", 
           RowBox[{
            RowBox[{"Solve", "[", 
             RowBox[{
              RowBox[{"fB", "&&", 
               RowBox[{"f", "\[Equal]", "0"}]}], ",", "Reals"}], "]"}], "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"tAlist", "=", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{"h1", "\[Equal]", "0"}], ",", "Reals"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"tBlist", "=", 
         RowBox[{
          RowBox[{"Solve", "[", 
           RowBox[{
            RowBox[{"h2", "\[Equal]", "0"}], ",", "Reals"}], "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"tAlist", ",", "\"\<\\n\>\"", ",", "tBlist"}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"booltemp", "=", 
         RowBox[{"Reduce", "[", 
          RowBox[{"A", "/.", "tAlist"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"booltemp", "\[Equal]", "True"}], "||", 
           RowBox[{"booltemp", "\[Equal]", "False"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"A", "=", "booltemp"}], ",", "\[IndentingNewLine]", 
          RowBox[{"A", "=", 
           RowBox[{"A", "/.", "tAlist"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"A", "=", 
           RowBox[{"A", "/.", "tAlist"}]}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"booltemp", "=", 
         RowBox[{"Reduce", "[", 
          RowBox[{"B", "/.", "tBlist"}], "]"}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"booltemp", "\[Equal]", "True"}], "||", 
           RowBox[{"booltemp", "\[Equal]", "False"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"B", "=", "booltemp"}], ",", "\[IndentingNewLine]", 
          RowBox[{"B", "=", 
           RowBox[{"B", "/.", "tBlist"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"B", "=", 
           RowBox[{"B", "/.", "tBlist"}]}]}], "\[IndentingNewLine]", "]"}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
        "Print", "[", "\"\<NSOSC unsatisfied, procedure terminates with:\>\"",
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<A: \>\"", ",", "A", ",", "\"\<\\nB: \>\"", ",", "B"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"f", ">", "0"}], ")"}], "||", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"f", "\[Equal]", "0"}], "&&", 
            RowBox[{"IGFQC", "[", 
             RowBox[{"A", ",", "B", ",", "0", ",", "0", ",", "0"}], "]"}]}], 
           ")"}]}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.6329766133214293`*^9, 3.6329766481832733`*^9}, 
   3.633091643719595*^9, {3.633092106921231*^9, 3.633092110420955*^9}, {
   3.633092380291307*^9, 3.633092397003547*^9}, {3.633093352075411*^9, 
   3.633093366500522*^9}, {3.63309342050888*^9, 3.63309352679541*^9}, {
   3.633093813424188*^9, 3.633093951126082*^9}, {3.633094026340364*^9, 
   3.633094059367002*^9}, {3.633094114608612*^9, 3.633094223686812*^9}, {
   3.633094374511977*^9, 3.633094416892902*^9}, {3.633094452441504*^9, 
   3.633094518789204*^9}, {3.633094567255464*^9, 3.633094572103892*^9}, {
   3.633094607277117*^9, 3.633094630192697*^9}, {3.633094662330986*^9, 
   3.633094709874855*^9}, {3.633094794911121*^9, 3.633094795071145*^9}, {
   3.633094981796172*^9, 3.633094997177761*^9}, {3.633095040067258*^9, 
   3.633095071244335*^9}, {3.633095169096269*^9, 3.63309524080682*^9}, {
   3.633095272477355*^9, 3.633095299580431*^9}, {3.633095333708556*^9, 
   3.633095374122467*^9}, {3.633095454752696*^9, 3.63309545711636*^9}, {
   3.633095625958722*^9, 3.6330957716987*^9}, {3.633095805054966*^9, 
   3.633095842268152*^9}, {3.63309590133414*^9, 3.633095961493014*^9}, {
   3.633096033325218*^9, 3.633096057166382*^9}, {3.633096106944231*^9, 
   3.63309616683392*^9}, {3.633096289115126*^9, 3.633096292523485*^9}, {
   3.633096464371543*^9, 3.633096547503129*^9}, {3.633096618391088*^9, 
   3.633096652343243*^9}, 3.633096861346081*^9, {3.633096973224752*^9, 
   3.633097101202732*^9}, {3.633097272532887*^9, 3.633097431215254*^9}, {
   3.633097494887246*^9, 3.633097517706423*^9}, {3.633097555494295*^9, 
   3.633097589023188*^9}, {3.633097975486364*^9, 3.633098046607583*^9}, {
   3.633098080259363*^9, 3.633098247515687*^9}, {3.633098347191442*^9, 
   3.633098448573394*^9}, {3.633098481542953*^9, 3.633098513383636*^9}, {
   3.633169443861643*^9, 3.633169444075735*^9}, {3.633169559463292*^9, 
   3.633169618016236*^9}, {3.633169698966408*^9, 3.633169706910556*^9}, 
   3.63316974342639*^9, {3.633170420550598*^9, 3.633170516991656*^9}, {
   3.633170907069391*^9, 3.633171050735557*^9}, {3.633171085700086*^9, 
   3.633171121356386*^9}, {3.63317117468227*^9, 3.633171203950827*^9}, {
   3.63317126205851*^9, 3.633171360239971*^9}, 3.633306611603573*^9, {
   3.633306774049498*^9, 3.633306860594133*^9}, {3.633309264557283*^9, 
   3.633309304481461*^9}, {3.633319145883045*^9, 3.633319155626981*^9}, {
   3.633319230010984*^9, 3.633319253932325*^9}, {3.633319304158508*^9, 
   3.633319315039251*^9}, {3.633319416699431*^9, 3.63331941694785*^9}, {
   3.633322839556806*^9, 3.633322845503406*^9}, {3.633322908558373*^9, 
   3.63332293237736*^9}, {3.633322981063195*^9, 3.633322993939079*^9}, {
   3.633323034700274*^9, 3.633323041793314*^9}, {3.633494273801642*^9, 
   3.633494277490608*^9}, 3.633494336105918*^9, {3.633494448895893*^9, 
   3.633494460420782*^9}, {3.633494503514524*^9, 3.63349452729535*^9}, {
   3.633494620405626*^9, 3.633494622983071*^9}, {3.633494672057682*^9, 
   3.633494687592048*^9}, {3.633494758116678*^9, 3.633494824533193*^9}, {
   3.633494861304165*^9, 3.633494886096363*^9}, {3.633494947462755*^9, 
   3.633494948022929*^9}, {3.633495132301361*^9, 3.63349520576777*^9}, {
   3.633495285419686*^9, 3.633495290447892*^9}, {3.633495346706068*^9, 
   3.633495422483415*^9}, {3.633495457899737*^9, 3.633495569016953*^9}, {
   3.633495606794881*^9, 3.633495608580397*^9}, {3.63349571573038*^9, 
   3.63349572580724*^9}, {3.633495939758972*^9, 3.633495987667419*^9}, {
   3.633497550781538*^9, 3.633497561354334*^9}, {3.63349833515675*^9, 
   3.633498344232156*^9}, {3.633498452528524*^9, 3.633498458054624*^9}, {
   3.63349849059988*^9, 3.633498510634764*^9}, {3.633498595936067*^9, 
   3.633498625870858*^9}, {3.633498697217405*^9, 3.633498737083634*^9}, {
   3.633498771131654*^9, 3.633498849921885*^9}, 3.633498906708475*^9, {
   3.633499007426476*^9, 3.633499009844694*^9}, {3.63349915438001*^9, 
   3.633499158516792*^9}, {3.633499195259551*^9, 3.633499210083954*^9}, {
   3.633499368476153*^9, 3.633499457793435*^9}, {3.633499517060672*^9, 
   3.633499687954808*^9}, {3.633499774879088*^9, 3.633499817924942*^9}, {
   3.633499909626921*^9, 3.63349992577439*^9}, {3.633500078031986*^9, 
   3.633500080285595*^9}, {3.633500291763015*^9, 3.63350030073873*^9}, {
   3.633500813618822*^9, 3.633500822481264*^9}, {3.633501151997494*^9, 
   3.633501189185469*^9}, {3.633501274456921*^9, 3.633501277048312*^9}, {
   3.633501345869628*^9, 3.633501352993383*^9}, {3.633501425079098*^9, 
   3.633501458481765*^9}, {3.633501519555957*^9, 3.633501546512778*^9}, {
   3.633501663991287*^9, 3.633501694502735*^9}, {3.633512212540653*^9, 
   3.633512219182239*^9}, {3.633512749581335*^9, 3.633512787605053*^9}, {
   3.633512838217866*^9, 3.633512904003164*^9}, 3.633517075948758*^9, {
   3.633517917178967*^9, 3.633517922554447*^9}, {3.633517997673075*^9, 
   3.6335180584933*^9}, {3.633518090424118*^9, 3.633518217845714*^9}, {
   3.633518625696506*^9, 3.63351872368767*^9}, {3.633518802184646*^9, 
   3.633518849139882*^9}, {3.633519095836299*^9, 3.633519155278772*^9}, {
   3.633519249037248*^9, 3.633519469868322*^9}, 3.633519553005123*^9, 
   3.633519707462843*^9, {3.633519828813095*^9, 3.633519853641155*^9}, {
   3.633519895907784*^9, 3.633519922803129*^9}, {3.633519974315159*^9, 
   3.633520136208863*^9}, {3.633520211291462*^9, 3.633520348566364*^9}, {
   3.633520380547134*^9, 3.633520387642816*^9}, {3.633520695745952*^9, 
   3.633520859669331*^9}, {3.633520909350927*^9, 3.633520925104103*^9}, {
   3.633521458566893*^9, 3.633521586570597*^9}, {3.63352169611913*^9, 
   3.63352175849349*^9}, {3.633521814807221*^9, 3.633521837164935*^9}, {
   3.633521931499571*^9, 3.633521944734433*^9}, {3.633738603166296*^9, 
   3.633738622500939*^9}, {3.633738688801117*^9, 3.633738720538039*^9}, {
   3.633751926089308*^9, 3.633751927765917*^9}, {3.633752057879938*^9, 
   3.633752092130599*^9}, {3.633752521562066*^9, 3.633752524035334*^9}, {
   3.633752745467867*^9, 3.6337528295718*^9}, {3.633752948157661*^9, 
   3.63375296067605*^9}, 3.6337529915395107`*^9, {3.633753451096513*^9, 
   3.6337534563157177`*^9}, {3.6337535359333687`*^9, 
   3.6337535618596992`*^9}, {3.633753609375392*^9, 3.633753698786316*^9}, {
   3.6337537665888157`*^9, 3.6337538044841137`*^9}, {3.633754066092279*^9, 
   3.633754066907695*^9}, 3.6337551243256903`*^9, {3.633755219284705*^9, 
   3.633755277693182*^9}, {3.633755346260907*^9, 3.6337553548074083`*^9}, {
   3.633755394084511*^9, 3.633755399426935*^9}, {3.633755444114105*^9, 
   3.6337555644032383`*^9}, {3.633756024861958*^9, 3.633756040012816*^9}, 
   3.633756203520698*^9, 3.633756253654192*^9, {3.6337563059582767`*^9, 
   3.633756412946804*^9}, {3.633756603891255*^9, 3.6337566310370407`*^9}, {
   3.633756669427178*^9, 3.633756715586802*^9}, {3.633756800909977*^9, 
   3.633756825751087*^9}, {3.633756890205247*^9, 3.6337569043649187`*^9}, {
   3.633757026294832*^9, 3.6337570335920897`*^9}, {3.6337571688545322`*^9, 
   3.633757191958455*^9}, {3.633757224440248*^9, 3.633757229925515*^9}, {
   3.633757304039596*^9, 3.633757462364888*^9}, {3.6337575449856033`*^9, 
   3.633757568949377*^9}, {3.6337576216209307`*^9, 3.633757630163806*^9}, {
   3.633757669688046*^9, 3.633757713535165*^9}, {3.633757831084578*^9, 
   3.633757837636813*^9}, {3.633757888147839*^9, 3.633757944280793*^9}, {
   3.633757975400291*^9, 3.6337580134529123`*^9}, {3.633758069864695*^9, 
   3.6337581251590023`*^9}, {3.633758174852641*^9, 3.633758207067481*^9}, {
   3.633758239156005*^9, 3.633758241224429*^9}, {3.63375832763999*^9, 
   3.633758335013895*^9}, {3.63375837633202*^9, 3.633758384276709*^9}, 
   3.6337584925276546`*^9, {3.6337585633347197`*^9, 3.633758587380761*^9}, {
   3.633758815193536*^9, 3.6337588637289248`*^9}, {3.633759073051297*^9, 
   3.6337590740334053`*^9}, {3.633759247857176*^9, 3.63375926928055*^9}, {
   3.633759415927197*^9, 3.6337595313859386`*^9}, {3.633778579324304*^9, 
   3.633778626121628*^9}, {3.633779201456151*^9, 3.6337792122087717`*^9}, {
   3.633779261920759*^9, 3.633779313338711*^9}, {3.6337794326363173`*^9, 
   3.633779447613193*^9}, {3.633779512462789*^9, 3.633779541511629*^9}, {
   3.633779707375239*^9, 3.633779713021058*^9}, {3.633780493028488*^9, 
   3.6337805585298033`*^9}, {3.633780638363468*^9, 3.6337806568026867`*^9}, {
   3.6337807497404346`*^9, 3.633780778400713*^9}, {3.6337808378488817`*^9, 
   3.633780888506505*^9}, {3.633781091141259*^9, 3.633781108352844*^9}, {
   3.6337812539489613`*^9, 3.633781336894281*^9}, {3.633781449728088*^9, 
   3.6337816030649776`*^9}, {3.633781651329495*^9, 3.6337817937716427`*^9}, {
   3.633781928295528*^9, 3.6337819365983353`*^9}, {3.633782061704879*^9, 
   3.63378209182139*^9}, {3.633782132933639*^9, 3.633782136772156*^9}, {
   3.6337821944186287`*^9, 3.633782202166065*^9}, {3.6337822658469152`*^9, 
   3.633782308912816*^9}, {3.633782399609415*^9, 3.633782447518359*^9}, 
   3.633782519727449*^9, {3.633782563113782*^9, 3.633782569418947*^9}, 
   3.633782820330654*^9, {3.63378305627789*^9, 3.6337830632580442`*^9}, {
   3.633783183290002*^9, 3.633783211879141*^9}, 3.633784616140374*^9, 
   3.6337846538166637`*^9, {3.633784706634891*^9, 3.633784732013357*^9}, {
   3.633784765218688*^9, 3.6337847676707087`*^9}, {3.6338366832068033`*^9, 
   3.633836693277281*^9}, {3.633836852286318*^9, 3.633836861862545*^9}, {
   3.633846221250217*^9, 3.633846231688325*^9}, {3.633846262419174*^9, 
   3.633846263473774*^9}, {3.633846584542158*^9, 3.6338465875246353`*^9}, {
   3.6338473754304256`*^9, 3.63384738532638*^9}, 3.635139827008567*^9, 
   3.6351398691073227`*^9, 3.635148719900258*^9, 3.635148758667948*^9, 
   3.63514939082609*^9, 3.635149451298345*^9, {3.63515012579484*^9, 
   3.635150166162796*^9}, {3.635150327513665*^9, 3.635150383542025*^9}, {
   3.635151060607082*^9, 3.63515107352978*^9}, 3.6352480482174883`*^9, 
   3.635248138693315*^9, 3.63524817991343*^9, 3.642812220937866*^9, {
   3.6428130289594088`*^9, 3.642813053394549*^9}, {3.64281311686906*^9, 
   3.64281313720021*^9}, {3.642813209377153*^9, 3.642813214287262*^9}, 
   3.642813298425033*^9, {3.64281349733294*^9, 3.64281356344496*^9}, {
   3.642813627231831*^9, 3.642813649305121*^9}, 3.642813734456299*^9, {
   3.64281456658574*^9, 3.642814576594022*^9}, {3.642814729527932*^9, 
   3.64281473247073*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"IGFCH", "[", 
    RowBox[{"A0_", ",", "B0_", ",", "h0_", ",", "hf1_", ",", "etasA_"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "A", ",", "B", ",", "h", ",", "vlistA", ",", "vlistB", ",", "h1", ",", 
       "h2", ",", "f", ",", "a1", ",", "b1", ",", "c1", ",", "q1", ",", "x", 
       ",", "y", ",", "z", ",", "d", ",", "u", ",", "v", ",", "i"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"(*", "initialization", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"A", "=", "A0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"B", "=", "B0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"h", "=", "h0"}], ";", "\[IndentingNewLine]", 
      RowBox[{"h1", "=", 
       RowBox[{"h2", "=", "0"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"x", "=", 
       RowBox[{"y", "=", 
        RowBox[{"z", "=", 
         RowBox[{"{", "}"}]}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
       "get", " ", "variables", " ", "and", " ", "uninterpreted", " ", 
        "functions"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"vlistA", "=", 
       RowBox[{"Variables", "[", 
        RowBox[{"Level", "[", 
         RowBox[{"A", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"vlistB", "=", 
       RowBox[{"Variables", "[", 
        RowBox[{"Level", "[", 
         RowBox[{"B", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"construct", " ", "h1"}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"x", "=", 
       RowBox[{"Intersection", "[", 
        RowBox[{"vlistA", ",", "vlistB", ",", 
         RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"y", "=", 
       RowBox[{"Intersection", "[", 
        RowBox[{
         RowBox[{"Complement", "[", 
          RowBox[{"vlistA", ",", "x"}], "]"}], ",", 
         RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"z", "=", 
       RowBox[{"Intersection", "[", 
        RowBox[{
         RowBox[{"Complement", "[", 
          RowBox[{"vlistB", ",", "x"}], "]"}], ",", 
         RowBox[{"Variables", "[", "h", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"d", "=", 
       RowBox[{"Length", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"u", "=", 
       RowBox[{"Length", "[", "y", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"v", "=", 
       RowBox[{"Length", "[", "z", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", "u"}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"a1", "=", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"h", ",", 
            RowBox[{"y", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"b1", "=", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"h", ",", 
            RowBox[{"y", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"c1", "=", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"h", ",", 
            RowBox[{"y", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"a1", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"h", "=", "c1"}], ";", "\[IndentingNewLine]", 
            RowBox[{"q1", "=", "0"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"h", "=", 
             RowBox[{"h", "/.", 
              RowBox[{
               RowBox[{"y", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "b1"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"2", " ", "a1"}], ")"}]}], ")"}]}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"q1", "=", 
             RowBox[{"a1", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"y", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "+", 
                 RowBox[{"b1", "/", 
                  RowBox[{"(", 
                   RowBox[{"2", " ", "a1"}], ")"}]}]}], ")"}], "^", 
               "2"}]}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"h1", "=", 
          RowBox[{"h1", "+", "q1"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", "=", "1"}], ",", 
        RowBox[{"i", "\[LessEqual]", "v"}], ",", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"a1", "=", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"h", ",", 
            RowBox[{"z", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "2"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"b1", "=", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"h", ",", 
            RowBox[{"z", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "1"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"c1", "=", 
          RowBox[{"Coefficient", "[", 
           RowBox[{"h", ",", 
            RowBox[{"z", "[", 
             RowBox[{"[", "i", "]"}], "]"}], ",", "0"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"a1", "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"h", "=", "c1"}], ";", "\[IndentingNewLine]", 
            RowBox[{"q1", "=", "0"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"h", "=", 
             RowBox[{"h", "/.", 
              RowBox[{
               RowBox[{"z", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "\[Rule]", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "b1"}], "/", 
                 RowBox[{"(", 
                  RowBox[{"2", " ", "a1"}], ")"}]}], ")"}]}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"q1", "=", 
             RowBox[{"a1", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"z", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "+", 
                 RowBox[{"b1", "/", 
                  RowBox[{"(", 
                   RowBox[{"2", " ", "a1"}], ")"}]}]}], ")"}], "^", 
               "2"}]}]}]}]}], "\[IndentingNewLine]", "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"h2", "=", 
          RowBox[{"h2", "+", "q1"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"h1", "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{
         RowBox[{"h", "/", "2"}], "+", "h1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"f", "=", 
       RowBox[{"Simplify", "[", 
        RowBox[{"hf1", "+", "h1"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"etasA", ">", "0"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"f", ">", "0"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Return", "[", 
         RowBox[{"f", "\[GreaterEqual]", "0"}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.633753949857703*^9, 3.633754051993734*^9}, 
   3.633755265098662*^9, {3.633781687478902*^9, 3.633781688725752*^9}, {
   3.633782469055586*^9, 3.633782477773994*^9}, 3.633784393215763*^9, {
   3.633846283872588*^9, 3.633846331288024*^9}, {3.633846376293976*^9, 
   3.633846468798489*^9}, 3.633846553336656*^9, {3.633846711486006*^9, 
   3.6338467625427723`*^9}, {3.633846796474978*^9, 3.63384687680809*^9}, {
   3.63384699535561*^9, 3.633847041183406*^9}, {3.633847111514222*^9, 
   3.633847127434434*^9}, 3.633847262263878*^9, {3.633847297592914*^9, 
   3.633847309898843*^9}, {3.633847424636879*^9, 3.63384748820604*^9}, {
   3.6338665151919394`*^9, 3.633866644932857*^9}}]
},
WindowSize->{840, 998},
WindowMargins->{{Automatic, 830}, {Automatic, -10}},
FrontEndVersion->"10.0 for Linux x86 (32-bit) (December 4, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 35196, 775, 3069, "Input"],
Cell[35757, 797, 28148, 566, 2541, "Input"],
Cell[63908, 1365, 8626, 209, 1199, "Input"]
}
]
*)

(* End of internal cache information *)
